<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfChangedOrder ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfChangedOrder
 * @subpackage Arrays
 */
class ArrayOfChangedOrder extends AbstractStructArrayBase
{
    /**
     * The ChangedOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChangedOrder[]
     */
    public $ChangedOrder;
    /**
     * Constructor method for ArrayOfChangedOrder
     * @uses ArrayOfChangedOrder::setChangedOrder()
     * @param \StructType\ChangedOrder[] $changedOrder
     */
    public function __construct(array $changedOrder = array())
    {
        $this
            ->setChangedOrder($changedOrder);
    }
    /**
     * Get ChangedOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChangedOrder[]|null
     */
    public function getChangedOrder()
    {
        return isset($this->ChangedOrder) ? $this->ChangedOrder : null;
    }
    /**
     * This method is responsible for validating the values passed to the setChangedOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChangedOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChangedOrderForArrayConstraintsFromSetChangedOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfChangedOrderChangedOrderItem) {
            // validation for constraint: itemType
            if (!$arrayOfChangedOrderChangedOrderItem instanceof \StructType\ChangedOrder) {
                $invalidValues[] = is_object($arrayOfChangedOrderChangedOrderItem) ? get_class($arrayOfChangedOrderChangedOrderItem) : sprintf('%s(%s)', gettype($arrayOfChangedOrderChangedOrderItem), var_export($arrayOfChangedOrderChangedOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChangedOrder property can only contain items of type \StructType\ChangedOrder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChangedOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ChangedOrder[] $changedOrder
     * @return \ArrayType\ArrayOfChangedOrder
     */
    public function setChangedOrder(array $changedOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($changedOrderArrayErrorMessage = self::validateChangedOrderForArrayConstraintsFromSetChangedOrder($changedOrder))) {
            throw new \InvalidArgumentException($changedOrderArrayErrorMessage, __LINE__);
        }
        if (is_null($changedOrder) || (is_array($changedOrder) && empty($changedOrder))) {
            unset($this->ChangedOrder);
        } else {
            $this->ChangedOrder = $changedOrder;
        }
        return $this;
    }
    /**
     * Add item to ChangedOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\ChangedOrder $item
     * @return \ArrayType\ArrayOfChangedOrder
     */
    public function addToChangedOrder(\StructType\ChangedOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChangedOrder) {
            throw new \InvalidArgumentException(sprintf('The ChangedOrder property can only contain items of type \StructType\ChangedOrder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChangedOrder[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ChangedOrder|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ChangedOrder|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ChangedOrder|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ChangedOrder|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ChangedOrder|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChangedOrder
     */
    public function getAttributeName()
    {
        return 'ChangedOrder';
    }
}
