<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConsigneeInfoContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConsigneeInfoContainer
 * @subpackage Arrays
 */
class ArrayOfConsigneeInfoContainer extends AbstractStructArrayBase
{
    /**
     * The ConsigneeInfoContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConsigneeInfoContainer[]
     */
    public $ConsigneeInfoContainer;
    /**
     * Constructor method for ArrayOfConsigneeInfoContainer
     * @uses ArrayOfConsigneeInfoContainer::setConsigneeInfoContainer()
     * @param \StructType\ConsigneeInfoContainer[] $consigneeInfoContainer
     */
    public function __construct(array $consigneeInfoContainer = array())
    {
        $this
            ->setConsigneeInfoContainer($consigneeInfoContainer);
    }
    /**
     * Get ConsigneeInfoContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConsigneeInfoContainer[]|null
     */
    public function getConsigneeInfoContainer()
    {
        return isset($this->ConsigneeInfoContainer) ? $this->ConsigneeInfoContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConsigneeInfoContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConsigneeInfoContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConsigneeInfoContainerForArrayConstraintsFromSetConsigneeInfoContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConsigneeInfoContainerConsigneeInfoContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfConsigneeInfoContainerConsigneeInfoContainerItem instanceof \StructType\ConsigneeInfoContainer) {
                $invalidValues[] = is_object($arrayOfConsigneeInfoContainerConsigneeInfoContainerItem) ? get_class($arrayOfConsigneeInfoContainerConsigneeInfoContainerItem) : sprintf('%s(%s)', gettype($arrayOfConsigneeInfoContainerConsigneeInfoContainerItem), var_export($arrayOfConsigneeInfoContainerConsigneeInfoContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ConsigneeInfoContainer property can only contain items of type \StructType\ConsigneeInfoContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConsigneeInfoContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConsigneeInfoContainer[] $consigneeInfoContainer
     * @return \ArrayType\ArrayOfConsigneeInfoContainer
     */
    public function setConsigneeInfoContainer(array $consigneeInfoContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($consigneeInfoContainerArrayErrorMessage = self::validateConsigneeInfoContainerForArrayConstraintsFromSetConsigneeInfoContainer($consigneeInfoContainer))) {
            throw new \InvalidArgumentException($consigneeInfoContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($consigneeInfoContainer) || (is_array($consigneeInfoContainer) && empty($consigneeInfoContainer))) {
            unset($this->ConsigneeInfoContainer);
        } else {
            $this->ConsigneeInfoContainer = $consigneeInfoContainer;
        }
        return $this;
    }
    /**
     * Add item to ConsigneeInfoContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\ConsigneeInfoContainer $item
     * @return \ArrayType\ArrayOfConsigneeInfoContainer
     */
    public function addToConsigneeInfoContainer(\StructType\ConsigneeInfoContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConsigneeInfoContainer) {
            throw new \InvalidArgumentException(sprintf('The ConsigneeInfoContainer property can only contain items of type \StructType\ConsigneeInfoContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ConsigneeInfoContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConsigneeInfoContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConsigneeInfoContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConsigneeInfoContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConsigneeInfoContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConsigneeInfoContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConsigneeInfoContainer
     */
    public function getAttributeName()
    {
        return 'ConsigneeInfoContainer';
    }
}
