<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDiskPriceRest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDiskPriceRest
 * @subpackage Arrays
 */
class ArrayOfDiskPriceRest extends AbstractStructArrayBase
{
    /**
     * The DiskPriceRest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DiskPriceRest[]
     */
    public $DiskPriceRest;
    /**
     * Constructor method for ArrayOfDiskPriceRest
     * @uses ArrayOfDiskPriceRest::setDiskPriceRest()
     * @param \StructType\DiskPriceRest[] $diskPriceRest
     */
    public function __construct(array $diskPriceRest = array())
    {
        $this
            ->setDiskPriceRest($diskPriceRest);
    }
    /**
     * Get DiskPriceRest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DiskPriceRest[]|null
     */
    public function getDiskPriceRest()
    {
        return isset($this->DiskPriceRest) ? $this->DiskPriceRest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDiskPriceRest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDiskPriceRest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDiskPriceRestForArrayConstraintsFromSetDiskPriceRest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDiskPriceRestDiskPriceRestItem) {
            // validation for constraint: itemType
            if (!$arrayOfDiskPriceRestDiskPriceRestItem instanceof \StructType\DiskPriceRest) {
                $invalidValues[] = is_object($arrayOfDiskPriceRestDiskPriceRestItem) ? get_class($arrayOfDiskPriceRestDiskPriceRestItem) : sprintf('%s(%s)', gettype($arrayOfDiskPriceRestDiskPriceRestItem), var_export($arrayOfDiskPriceRestDiskPriceRestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DiskPriceRest property can only contain items of type \StructType\DiskPriceRest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DiskPriceRest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DiskPriceRest[] $diskPriceRest
     * @return \ArrayType\ArrayOfDiskPriceRest
     */
    public function setDiskPriceRest(array $diskPriceRest = array())
    {
        // validation for constraint: array
        if ('' !== ($diskPriceRestArrayErrorMessage = self::validateDiskPriceRestForArrayConstraintsFromSetDiskPriceRest($diskPriceRest))) {
            throw new \InvalidArgumentException($diskPriceRestArrayErrorMessage, __LINE__);
        }
        if (is_null($diskPriceRest) || (is_array($diskPriceRest) && empty($diskPriceRest))) {
            unset($this->DiskPriceRest);
        } else {
            $this->DiskPriceRest = $diskPriceRest;
        }
        return $this;
    }
    /**
     * Add item to DiskPriceRest value
     * @throws \InvalidArgumentException
     * @param \StructType\DiskPriceRest $item
     * @return \ArrayType\ArrayOfDiskPriceRest
     */
    public function addToDiskPriceRest(\StructType\DiskPriceRest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DiskPriceRest) {
            throw new \InvalidArgumentException(sprintf('The DiskPriceRest property can only contain items of type \StructType\DiskPriceRest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DiskPriceRest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DiskPriceRest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DiskPriceRest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DiskPriceRest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DiskPriceRest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DiskPriceRest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DiskPriceRest
     */
    public function getAttributeName()
    {
        return 'DiskPriceRest';
    }
}
