<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFastenerContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFastenerContainer
 * @subpackage Arrays
 */
class ArrayOfFastenerContainer extends AbstractStructArrayBase
{
    /**
     * The FastenerContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FastenerContainer[]
     */
    public $FastenerContainer;
    /**
     * Constructor method for ArrayOfFastenerContainer
     * @uses ArrayOfFastenerContainer::setFastenerContainer()
     * @param \StructType\FastenerContainer[] $fastenerContainer
     */
    public function __construct(array $fastenerContainer = array())
    {
        $this
            ->setFastenerContainer($fastenerContainer);
    }
    /**
     * Get FastenerContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FastenerContainer[]|null
     */
    public function getFastenerContainer()
    {
        return isset($this->FastenerContainer) ? $this->FastenerContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFastenerContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFastenerContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFastenerContainerForArrayConstraintsFromSetFastenerContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFastenerContainerFastenerContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfFastenerContainerFastenerContainerItem instanceof \StructType\FastenerContainer) {
                $invalidValues[] = is_object($arrayOfFastenerContainerFastenerContainerItem) ? get_class($arrayOfFastenerContainerFastenerContainerItem) : sprintf('%s(%s)', gettype($arrayOfFastenerContainerFastenerContainerItem), var_export($arrayOfFastenerContainerFastenerContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FastenerContainer property can only contain items of type \StructType\FastenerContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FastenerContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FastenerContainer[] $fastenerContainer
     * @return \ArrayType\ArrayOfFastenerContainer
     */
    public function setFastenerContainer(array $fastenerContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($fastenerContainerArrayErrorMessage = self::validateFastenerContainerForArrayConstraintsFromSetFastenerContainer($fastenerContainer))) {
            throw new \InvalidArgumentException($fastenerContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($fastenerContainer) || (is_array($fastenerContainer) && empty($fastenerContainer))) {
            unset($this->FastenerContainer);
        } else {
            $this->FastenerContainer = $fastenerContainer;
        }
        return $this;
    }
    /**
     * Add item to FastenerContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\FastenerContainer $item
     * @return \ArrayType\ArrayOfFastenerContainer
     */
    public function addToFastenerContainer(\StructType\FastenerContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FastenerContainer) {
            throw new \InvalidArgumentException(sprintf('The FastenerContainer property can only contain items of type \StructType\FastenerContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FastenerContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FastenerContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FastenerContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FastenerContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FastenerContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FastenerContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FastenerContainer
     */
    public function getAttributeName()
    {
        return 'FastenerContainer';
    }
}
