<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetConsumableResultItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGetConsumableResultItem
 * @subpackage Arrays
 */
class ArrayOfGetConsumableResultItem extends AbstractStructArrayBase
{
    /**
     * The GetConsumableResultItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetConsumableResultItem[]
     */
    public $GetConsumableResultItem;
    /**
     * Constructor method for ArrayOfGetConsumableResultItem
     * @uses ArrayOfGetConsumableResultItem::setGetConsumableResultItem()
     * @param \StructType\GetConsumableResultItem[] $getConsumableResultItem
     */
    public function __construct(array $getConsumableResultItem = array())
    {
        $this
            ->setGetConsumableResultItem($getConsumableResultItem);
    }
    /**
     * Get GetConsumableResultItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetConsumableResultItem[]|null
     */
    public function getGetConsumableResultItem()
    {
        return isset($this->GetConsumableResultItem) ? $this->GetConsumableResultItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetConsumableResultItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetConsumableResultItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetConsumableResultItemForArrayConstraintsFromSetGetConsumableResultItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetConsumableResultItemGetConsumableResultItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetConsumableResultItemGetConsumableResultItemItem instanceof \StructType\GetConsumableResultItem) {
                $invalidValues[] = is_object($arrayOfGetConsumableResultItemGetConsumableResultItemItem) ? get_class($arrayOfGetConsumableResultItemGetConsumableResultItemItem) : sprintf('%s(%s)', gettype($arrayOfGetConsumableResultItemGetConsumableResultItemItem), var_export($arrayOfGetConsumableResultItemGetConsumableResultItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetConsumableResultItem property can only contain items of type \StructType\GetConsumableResultItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetConsumableResultItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetConsumableResultItem[] $getConsumableResultItem
     * @return \ArrayType\ArrayOfGetConsumableResultItem
     */
    public function setGetConsumableResultItem(array $getConsumableResultItem = array())
    {
        // validation for constraint: array
        if ('' !== ($getConsumableResultItemArrayErrorMessage = self::validateGetConsumableResultItemForArrayConstraintsFromSetGetConsumableResultItem($getConsumableResultItem))) {
            throw new \InvalidArgumentException($getConsumableResultItemArrayErrorMessage, __LINE__);
        }
        if (is_null($getConsumableResultItem) || (is_array($getConsumableResultItem) && empty($getConsumableResultItem))) {
            unset($this->GetConsumableResultItem);
        } else {
            $this->GetConsumableResultItem = $getConsumableResultItem;
        }
        return $this;
    }
    /**
     * Add item to GetConsumableResultItem value
     * @throws \InvalidArgumentException
     * @param \StructType\GetConsumableResultItem $item
     * @return \ArrayType\ArrayOfGetConsumableResultItem
     */
    public function addToGetConsumableResultItem(\StructType\GetConsumableResultItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetConsumableResultItem) {
            throw new \InvalidArgumentException(sprintf('The GetConsumableResultItem property can only contain items of type \StructType\GetConsumableResultItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetConsumableResultItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetConsumableResultItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetConsumableResultItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetConsumableResultItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetConsumableResultItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetConsumableResultItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetConsumableResultItem
     */
    public function getAttributeName()
    {
        return 'GetConsumableResultItem';
    }
}
