<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetOrderStatusResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGetOrderStatusResult
 * @subpackage Arrays
 */
class ArrayOfGetOrderStatusResult extends AbstractStructArrayBase
{
    /**
     * The GetOrderStatusResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetOrderStatusResult[]
     */
    public $GetOrderStatusResult;
    /**
     * Constructor method for ArrayOfGetOrderStatusResult
     * @uses ArrayOfGetOrderStatusResult::setGetOrderStatusResult()
     * @param \StructType\GetOrderStatusResult[] $getOrderStatusResult
     */
    public function __construct(array $getOrderStatusResult = array())
    {
        $this
            ->setGetOrderStatusResult($getOrderStatusResult);
    }
    /**
     * Get GetOrderStatusResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetOrderStatusResult[]|null
     */
    public function getGetOrderStatusResult()
    {
        return isset($this->GetOrderStatusResult) ? $this->GetOrderStatusResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetOrderStatusResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetOrderStatusResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetOrderStatusResultForArrayConstraintsFromSetGetOrderStatusResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetOrderStatusResultGetOrderStatusResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetOrderStatusResultGetOrderStatusResultItem instanceof \StructType\GetOrderStatusResult) {
                $invalidValues[] = is_object($arrayOfGetOrderStatusResultGetOrderStatusResultItem) ? get_class($arrayOfGetOrderStatusResultGetOrderStatusResultItem) : sprintf('%s(%s)', gettype($arrayOfGetOrderStatusResultGetOrderStatusResultItem), var_export($arrayOfGetOrderStatusResultGetOrderStatusResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetOrderStatusResult property can only contain items of type \StructType\GetOrderStatusResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetOrderStatusResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetOrderStatusResult[] $getOrderStatusResult
     * @return \ArrayType\ArrayOfGetOrderStatusResult
     */
    public function setGetOrderStatusResult(array $getOrderStatusResult = array())
    {
        // validation for constraint: array
        if ('' !== ($getOrderStatusResultArrayErrorMessage = self::validateGetOrderStatusResultForArrayConstraintsFromSetGetOrderStatusResult($getOrderStatusResult))) {
            throw new \InvalidArgumentException($getOrderStatusResultArrayErrorMessage, __LINE__);
        }
        if (is_null($getOrderStatusResult) || (is_array($getOrderStatusResult) && empty($getOrderStatusResult))) {
            unset($this->GetOrderStatusResult);
        } else {
            $this->GetOrderStatusResult = $getOrderStatusResult;
        }
        return $this;
    }
    /**
     * Add item to GetOrderStatusResult value
     * @throws \InvalidArgumentException
     * @param \StructType\GetOrderStatusResult $item
     * @return \ArrayType\ArrayOfGetOrderStatusResult
     */
    public function addToGetOrderStatusResult(\StructType\GetOrderStatusResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetOrderStatusResult) {
            throw new \InvalidArgumentException(sprintf('The GetOrderStatusResult property can only contain items of type \StructType\GetOrderStatusResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetOrderStatusResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetOrderStatusResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetOrderStatusResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetOrderStatusResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetOrderStatusResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetOrderStatusResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetOrderStatusResult
     */
    public function getAttributeName()
    {
        return 'GetOrderStatusResult';
    }
}
