<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetStatusListResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGetStatusListResult
 * @subpackage Arrays
 */
class ArrayOfGetStatusListResult extends AbstractStructArrayBase
{
    /**
     * The GetStatusListResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetStatusListResult[]
     */
    public $GetStatusListResult;
    /**
     * Constructor method for ArrayOfGetStatusListResult
     * @uses ArrayOfGetStatusListResult::setGetStatusListResult()
     * @param \StructType\GetStatusListResult[] $getStatusListResult
     */
    public function __construct(array $getStatusListResult = array())
    {
        $this
            ->setGetStatusListResult($getStatusListResult);
    }
    /**
     * Get GetStatusListResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetStatusListResult[]|null
     */
    public function getGetStatusListResult()
    {
        return isset($this->GetStatusListResult) ? $this->GetStatusListResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetStatusListResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetStatusListResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetStatusListResultForArrayConstraintsFromSetGetStatusListResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetStatusListResultGetStatusListResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetStatusListResultGetStatusListResultItem instanceof \StructType\GetStatusListResult) {
                $invalidValues[] = is_object($arrayOfGetStatusListResultGetStatusListResultItem) ? get_class($arrayOfGetStatusListResultGetStatusListResultItem) : sprintf('%s(%s)', gettype($arrayOfGetStatusListResultGetStatusListResultItem), var_export($arrayOfGetStatusListResultGetStatusListResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetStatusListResult property can only contain items of type \StructType\GetStatusListResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetStatusListResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetStatusListResult[] $getStatusListResult
     * @return \ArrayType\ArrayOfGetStatusListResult
     */
    public function setGetStatusListResult(array $getStatusListResult = array())
    {
        // validation for constraint: array
        if ('' !== ($getStatusListResultArrayErrorMessage = self::validateGetStatusListResultForArrayConstraintsFromSetGetStatusListResult($getStatusListResult))) {
            throw new \InvalidArgumentException($getStatusListResultArrayErrorMessage, __LINE__);
        }
        if (is_null($getStatusListResult) || (is_array($getStatusListResult) && empty($getStatusListResult))) {
            unset($this->GetStatusListResult);
        } else {
            $this->GetStatusListResult = $getStatusListResult;
        }
        return $this;
    }
    /**
     * Add item to GetStatusListResult value
     * @throws \InvalidArgumentException
     * @param \StructType\GetStatusListResult $item
     * @return \ArrayType\ArrayOfGetStatusListResult
     */
    public function addToGetStatusListResult(\StructType\GetStatusListResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetStatusListResult) {
            throw new \InvalidArgumentException(sprintf('The GetStatusListResult property can only contain items of type \StructType\GetStatusListResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetStatusListResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetStatusListResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetStatusListResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetStatusListResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetStatusListResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetStatusListResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetStatusListResult
     */
    public function getAttributeName()
    {
        return 'GetStatusListResult';
    }
}
