<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMarkCodeContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMarkCodeContainer
 * @subpackage Arrays
 */
class ArrayOfMarkCodeContainer extends AbstractStructArrayBase
{
    /**
     * The MarkCodeContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MarkCodeContainer[]
     */
    public $MarkCodeContainer;
    /**
     * Constructor method for ArrayOfMarkCodeContainer
     * @uses ArrayOfMarkCodeContainer::setMarkCodeContainer()
     * @param \StructType\MarkCodeContainer[] $markCodeContainer
     */
    public function __construct(array $markCodeContainer = array())
    {
        $this
            ->setMarkCodeContainer($markCodeContainer);
    }
    /**
     * Get MarkCodeContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MarkCodeContainer[]|null
     */
    public function getMarkCodeContainer()
    {
        return isset($this->MarkCodeContainer) ? $this->MarkCodeContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMarkCodeContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMarkCodeContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMarkCodeContainerForArrayConstraintsFromSetMarkCodeContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMarkCodeContainerMarkCodeContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfMarkCodeContainerMarkCodeContainerItem instanceof \StructType\MarkCodeContainer) {
                $invalidValues[] = is_object($arrayOfMarkCodeContainerMarkCodeContainerItem) ? get_class($arrayOfMarkCodeContainerMarkCodeContainerItem) : sprintf('%s(%s)', gettype($arrayOfMarkCodeContainerMarkCodeContainerItem), var_export($arrayOfMarkCodeContainerMarkCodeContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MarkCodeContainer property can only contain items of type \StructType\MarkCodeContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MarkCodeContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MarkCodeContainer[] $markCodeContainer
     * @return \ArrayType\ArrayOfMarkCodeContainer
     */
    public function setMarkCodeContainer(array $markCodeContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($markCodeContainerArrayErrorMessage = self::validateMarkCodeContainerForArrayConstraintsFromSetMarkCodeContainer($markCodeContainer))) {
            throw new \InvalidArgumentException($markCodeContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($markCodeContainer) || (is_array($markCodeContainer) && empty($markCodeContainer))) {
            unset($this->MarkCodeContainer);
        } else {
            $this->MarkCodeContainer = $markCodeContainer;
        }
        return $this;
    }
    /**
     * Add item to MarkCodeContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\MarkCodeContainer $item
     * @return \ArrayType\ArrayOfMarkCodeContainer
     */
    public function addToMarkCodeContainer(\StructType\MarkCodeContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MarkCodeContainer) {
            throw new \InvalidArgumentException(sprintf('The MarkCodeContainer property can only contain items of type \StructType\MarkCodeContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MarkCodeContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MarkCodeContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MarkCodeContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MarkCodeContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MarkCodeContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MarkCodeContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MarkCodeContainer
     */
    public function getAttributeName()
    {
        return 'MarkCodeContainer';
    }
}
