<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderProductError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderProductError
 * @subpackage Arrays
 */
class ArrayOfOrderProductError extends AbstractStructArrayBase
{
    /**
     * The OrderProductError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderProductError[]
     */
    public $OrderProductError;
    /**
     * Constructor method for ArrayOfOrderProductError
     * @uses ArrayOfOrderProductError::setOrderProductError()
     * @param \StructType\OrderProductError[] $orderProductError
     */
    public function __construct(array $orderProductError = array())
    {
        $this
            ->setOrderProductError($orderProductError);
    }
    /**
     * Get OrderProductError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderProductError[]|null
     */
    public function getOrderProductError()
    {
        return isset($this->OrderProductError) ? $this->OrderProductError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderProductError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderProductError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderProductErrorForArrayConstraintsFromSetOrderProductError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderProductErrorOrderProductErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderProductErrorOrderProductErrorItem instanceof \StructType\OrderProductError) {
                $invalidValues[] = is_object($arrayOfOrderProductErrorOrderProductErrorItem) ? get_class($arrayOfOrderProductErrorOrderProductErrorItem) : sprintf('%s(%s)', gettype($arrayOfOrderProductErrorOrderProductErrorItem), var_export($arrayOfOrderProductErrorOrderProductErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderProductError property can only contain items of type \StructType\OrderProductError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderProductError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderProductError[] $orderProductError
     * @return \ArrayType\ArrayOfOrderProductError
     */
    public function setOrderProductError(array $orderProductError = array())
    {
        // validation for constraint: array
        if ('' !== ($orderProductErrorArrayErrorMessage = self::validateOrderProductErrorForArrayConstraintsFromSetOrderProductError($orderProductError))) {
            throw new \InvalidArgumentException($orderProductErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($orderProductError) || (is_array($orderProductError) && empty($orderProductError))) {
            unset($this->OrderProductError);
        } else {
            $this->OrderProductError = $orderProductError;
        }
        return $this;
    }
    /**
     * Add item to OrderProductError value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderProductError $item
     * @return \ArrayType\ArrayOfOrderProductError
     */
    public function addToOrderProductError(\StructType\OrderProductError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderProductError) {
            throw new \InvalidArgumentException(sprintf('The OrderProductError property can only contain items of type \StructType\OrderProductError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderProductError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderProductError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderProductError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderProductError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderProductError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderProductError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderProductError
     */
    public function getAttributeName()
    {
        return 'OrderProductError';
    }
}
