<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPressureSensorContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPressureSensorContainer
 * @subpackage Arrays
 */
class ArrayOfPressureSensorContainer extends AbstractStructArrayBase
{
    /**
     * The PressureSensorContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PressureSensorContainer[]
     */
    public $PressureSensorContainer;
    /**
     * Constructor method for ArrayOfPressureSensorContainer
     * @uses ArrayOfPressureSensorContainer::setPressureSensorContainer()
     * @param \StructType\PressureSensorContainer[] $pressureSensorContainer
     */
    public function __construct(array $pressureSensorContainer = array())
    {
        $this
            ->setPressureSensorContainer($pressureSensorContainer);
    }
    /**
     * Get PressureSensorContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PressureSensorContainer[]|null
     */
    public function getPressureSensorContainer()
    {
        return isset($this->PressureSensorContainer) ? $this->PressureSensorContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPressureSensorContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPressureSensorContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePressureSensorContainerForArrayConstraintsFromSetPressureSensorContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPressureSensorContainerPressureSensorContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfPressureSensorContainerPressureSensorContainerItem instanceof \StructType\PressureSensorContainer) {
                $invalidValues[] = is_object($arrayOfPressureSensorContainerPressureSensorContainerItem) ? get_class($arrayOfPressureSensorContainerPressureSensorContainerItem) : sprintf('%s(%s)', gettype($arrayOfPressureSensorContainerPressureSensorContainerItem), var_export($arrayOfPressureSensorContainerPressureSensorContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PressureSensorContainer property can only contain items of type \StructType\PressureSensorContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PressureSensorContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PressureSensorContainer[] $pressureSensorContainer
     * @return \ArrayType\ArrayOfPressureSensorContainer
     */
    public function setPressureSensorContainer(array $pressureSensorContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($pressureSensorContainerArrayErrorMessage = self::validatePressureSensorContainerForArrayConstraintsFromSetPressureSensorContainer($pressureSensorContainer))) {
            throw new \InvalidArgumentException($pressureSensorContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($pressureSensorContainer) || (is_array($pressureSensorContainer) && empty($pressureSensorContainer))) {
            unset($this->PressureSensorContainer);
        } else {
            $this->PressureSensorContainer = $pressureSensorContainer;
        }
        return $this;
    }
    /**
     * Add item to PressureSensorContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\PressureSensorContainer $item
     * @return \ArrayType\ArrayOfPressureSensorContainer
     */
    public function addToPressureSensorContainer(\StructType\PressureSensorContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PressureSensorContainer) {
            throw new \InvalidArgumentException(sprintf('The PressureSensorContainer property can only contain items of type \StructType\PressureSensorContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PressureSensorContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PressureSensorContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PressureSensorContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PressureSensorContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PressureSensorContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PressureSensorContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PressureSensorContainer
     */
    public function getAttributeName()
    {
        return 'PressureSensorContainer';
    }
}
