<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPriceListError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPriceListError
 * @subpackage Arrays
 */
class ArrayOfPriceListError extends AbstractStructArrayBase
{
    /**
     * The PriceListError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PriceListError[]
     */
    public $PriceListError;
    /**
     * Constructor method for ArrayOfPriceListError
     * @uses ArrayOfPriceListError::setPriceListError()
     * @param \StructType\PriceListError[] $priceListError
     */
    public function __construct(array $priceListError = array())
    {
        $this
            ->setPriceListError($priceListError);
    }
    /**
     * Get PriceListError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PriceListError[]|null
     */
    public function getPriceListError()
    {
        return isset($this->PriceListError) ? $this->PriceListError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPriceListError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPriceListError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePriceListErrorForArrayConstraintsFromSetPriceListError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPriceListErrorPriceListErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfPriceListErrorPriceListErrorItem instanceof \StructType\PriceListError) {
                $invalidValues[] = is_object($arrayOfPriceListErrorPriceListErrorItem) ? get_class($arrayOfPriceListErrorPriceListErrorItem) : sprintf('%s(%s)', gettype($arrayOfPriceListErrorPriceListErrorItem), var_export($arrayOfPriceListErrorPriceListErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PriceListError property can only contain items of type \StructType\PriceListError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PriceListError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PriceListError[] $priceListError
     * @return \ArrayType\ArrayOfPriceListError
     */
    public function setPriceListError(array $priceListError = array())
    {
        // validation for constraint: array
        if ('' !== ($priceListErrorArrayErrorMessage = self::validatePriceListErrorForArrayConstraintsFromSetPriceListError($priceListError))) {
            throw new \InvalidArgumentException($priceListErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($priceListError) || (is_array($priceListError) && empty($priceListError))) {
            unset($this->PriceListError);
        } else {
            $this->PriceListError = $priceListError;
        }
        return $this;
    }
    /**
     * Add item to PriceListError value
     * @throws \InvalidArgumentException
     * @param \StructType\PriceListError $item
     * @return \ArrayType\ArrayOfPriceListError
     */
    public function addToPriceListError(\StructType\PriceListError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PriceListError) {
            throw new \InvalidArgumentException(sprintf('The PriceListError property can only contain items of type \StructType\PriceListError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PriceListError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PriceListError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PriceListError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PriceListError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PriceListError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PriceListError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PriceListError
     */
    public function getAttributeName()
    {
        return 'PriceListError';
    }
}
