<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRestListError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRestListError
 * @subpackage Arrays
 */
class ArrayOfRestListError extends AbstractStructArrayBase
{
    /**
     * The RestListError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RestListError[]
     */
    public $RestListError;
    /**
     * Constructor method for ArrayOfRestListError
     * @uses ArrayOfRestListError::setRestListError()
     * @param \StructType\RestListError[] $restListError
     */
    public function __construct(array $restListError = array())
    {
        $this
            ->setRestListError($restListError);
    }
    /**
     * Get RestListError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RestListError[]|null
     */
    public function getRestListError()
    {
        return isset($this->RestListError) ? $this->RestListError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRestListError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRestListError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRestListErrorForArrayConstraintsFromSetRestListError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRestListErrorRestListErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfRestListErrorRestListErrorItem instanceof \StructType\RestListError) {
                $invalidValues[] = is_object($arrayOfRestListErrorRestListErrorItem) ? get_class($arrayOfRestListErrorRestListErrorItem) : sprintf('%s(%s)', gettype($arrayOfRestListErrorRestListErrorItem), var_export($arrayOfRestListErrorRestListErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RestListError property can only contain items of type \StructType\RestListError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RestListError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RestListError[] $restListError
     * @return \ArrayType\ArrayOfRestListError
     */
    public function setRestListError(array $restListError = array())
    {
        // validation for constraint: array
        if ('' !== ($restListErrorArrayErrorMessage = self::validateRestListErrorForArrayConstraintsFromSetRestListError($restListError))) {
            throw new \InvalidArgumentException($restListErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($restListError) || (is_array($restListError) && empty($restListError))) {
            unset($this->RestListError);
        } else {
            $this->RestListError = $restListError;
        }
        return $this;
    }
    /**
     * Add item to RestListError value
     * @throws \InvalidArgumentException
     * @param \StructType\RestListError $item
     * @return \ArrayType\ArrayOfRestListError
     */
    public function addToRestListError(\StructType\RestListError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RestListError) {
            throw new \InvalidArgumentException(sprintf('The RestListError property can only contain items of type \StructType\RestListError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RestListError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RestListError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RestListError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RestListError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RestListError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RestListError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RestListError
     */
    public function getAttributeName()
    {
        return 'RestListError';
    }
}
