<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResult.PeriodContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResult.PeriodContainer
 * @subpackage Arrays
 */
class ArrayOfResult_PeriodContainer extends AbstractStructArrayBase
{
    /**
     * The Result_PeriodContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Result_PeriodContainer[]
     */
    public $Result_PeriodContainer;
    /**
     * Constructor method for ArrayOfResult.PeriodContainer
     * @uses ArrayOfResult_PeriodContainer::setResult_PeriodContainer()
     * @param \StructType\Result_PeriodContainer[] $result_PeriodContainer
     */
    public function __construct(array $result_PeriodContainer = array())
    {
        $this
            ->setResult_PeriodContainer($result_PeriodContainer);
    }
    /**
     * Get Result_PeriodContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Result_PeriodContainer[]|null
     */
    public function getResult_PeriodContainer()
    {
        return isset($this->{'Result.PeriodContainer'}) ? $this->{'Result.PeriodContainer'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setResult_PeriodContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResult_PeriodContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResult_PeriodContainerForArrayConstraintsFromSetResult_PeriodContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResult_PeriodContainerResult_PeriodContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfResult_PeriodContainerResult_PeriodContainerItem instanceof \StructType\Result_PeriodContainer) {
                $invalidValues[] = is_object($arrayOfResult_PeriodContainerResult_PeriodContainerItem) ? get_class($arrayOfResult_PeriodContainerResult_PeriodContainerItem) : sprintf('%s(%s)', gettype($arrayOfResult_PeriodContainerResult_PeriodContainerItem), var_export($arrayOfResult_PeriodContainerResult_PeriodContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Result_PeriodContainer property can only contain items of type \StructType\Result_PeriodContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Result_PeriodContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Result_PeriodContainer[] $result_PeriodContainer
     * @return \ArrayType\ArrayOfResult_PeriodContainer
     */
    public function setResult_PeriodContainer(array $result_PeriodContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($result_PeriodContainerArrayErrorMessage = self::validateResult_PeriodContainerForArrayConstraintsFromSetResult_PeriodContainer($result_PeriodContainer))) {
            throw new \InvalidArgumentException($result_PeriodContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($result_PeriodContainer) || (is_array($result_PeriodContainer) && empty($result_PeriodContainer))) {
            unset($this->Result_PeriodContainer, $this->{'Result.PeriodContainer'});
        } else {
            $this->Result_PeriodContainer = $this->{'Result.PeriodContainer'} = $result_PeriodContainer;
        }
        return $this;
    }
    /**
     * Add item to Result_PeriodContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\Result_PeriodContainer $item
     * @return \ArrayType\ArrayOfResult_PeriodContainer
     */
    public function addToResult_PeriodContainer(\StructType\Result_PeriodContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Result_PeriodContainer) {
            throw new \InvalidArgumentException(sprintf('The Result_PeriodContainer property can only contain items of type \StructType\Result_PeriodContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Result_PeriodContainer[] = $this->{'Result.PeriodContainer'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Result_PeriodContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Result_PeriodContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Result_PeriodContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Result_PeriodContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Result_PeriodContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Result.PeriodContainer
     */
    public function getAttributeName()
    {
        return 'Result.PeriodContainer';
    }
}
