<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRimContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRimContainer
 * @subpackage Arrays
 */
class ArrayOfRimContainer extends AbstractStructArrayBase
{
    /**
     * The RimContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RimContainer[]
     */
    public $RimContainer;
    /**
     * Constructor method for ArrayOfRimContainer
     * @uses ArrayOfRimContainer::setRimContainer()
     * @param \StructType\RimContainer[] $rimContainer
     */
    public function __construct(array $rimContainer = array())
    {
        $this
            ->setRimContainer($rimContainer);
    }
    /**
     * Get RimContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RimContainer[]|null
     */
    public function getRimContainer()
    {
        return isset($this->RimContainer) ? $this->RimContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRimContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRimContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRimContainerForArrayConstraintsFromSetRimContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRimContainerRimContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfRimContainerRimContainerItem instanceof \StructType\RimContainer) {
                $invalidValues[] = is_object($arrayOfRimContainerRimContainerItem) ? get_class($arrayOfRimContainerRimContainerItem) : sprintf('%s(%s)', gettype($arrayOfRimContainerRimContainerItem), var_export($arrayOfRimContainerRimContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RimContainer property can only contain items of type \StructType\RimContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RimContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RimContainer[] $rimContainer
     * @return \ArrayType\ArrayOfRimContainer
     */
    public function setRimContainer(array $rimContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($rimContainerArrayErrorMessage = self::validateRimContainerForArrayConstraintsFromSetRimContainer($rimContainer))) {
            throw new \InvalidArgumentException($rimContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($rimContainer) || (is_array($rimContainer) && empty($rimContainer))) {
            unset($this->RimContainer);
        } else {
            $this->RimContainer = $rimContainer;
        }
        return $this;
    }
    /**
     * Add item to RimContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\RimContainer $item
     * @return \ArrayType\ArrayOfRimContainer
     */
    public function addToRimContainer(\StructType\RimContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RimContainer) {
            throw new \InvalidArgumentException(sprintf('The RimContainer property can only contain items of type \StructType\RimContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RimContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RimContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RimContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RimContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RimContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RimContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RimContainer
     */
    public function getAttributeName()
    {
        return 'RimContainer';
    }
}
