<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSaleContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSaleContainer
 * @subpackage Arrays
 */
class ArrayOfSaleContainer extends AbstractStructArrayBase
{
    /**
     * The SaleContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaleContainer[]
     */
    public $SaleContainer;
    /**
     * Constructor method for ArrayOfSaleContainer
     * @uses ArrayOfSaleContainer::setSaleContainer()
     * @param \StructType\SaleContainer[] $saleContainer
     */
    public function __construct(array $saleContainer = array())
    {
        $this
            ->setSaleContainer($saleContainer);
    }
    /**
     * Get SaleContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaleContainer[]|null
     */
    public function getSaleContainer()
    {
        return isset($this->SaleContainer) ? $this->SaleContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleContainerForArrayConstraintsFromSetSaleContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSaleContainerSaleContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfSaleContainerSaleContainerItem instanceof \StructType\SaleContainer) {
                $invalidValues[] = is_object($arrayOfSaleContainerSaleContainerItem) ? get_class($arrayOfSaleContainerSaleContainerItem) : sprintf('%s(%s)', gettype($arrayOfSaleContainerSaleContainerItem), var_export($arrayOfSaleContainerSaleContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaleContainer property can only contain items of type \StructType\SaleContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaleContainer[] $saleContainer
     * @return \ArrayType\ArrayOfSaleContainer
     */
    public function setSaleContainer(array $saleContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($saleContainerArrayErrorMessage = self::validateSaleContainerForArrayConstraintsFromSetSaleContainer($saleContainer))) {
            throw new \InvalidArgumentException($saleContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($saleContainer) || (is_array($saleContainer) && empty($saleContainer))) {
            unset($this->SaleContainer);
        } else {
            $this->SaleContainer = $saleContainer;
        }
        return $this;
    }
    /**
     * Add item to SaleContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleContainer $item
     * @return \ArrayType\ArrayOfSaleContainer
     */
    public function addToSaleContainer(\StructType\SaleContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleContainer) {
            throw new \InvalidArgumentException(sprintf('The SaleContainer property can only contain items of type \StructType\SaleContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaleContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SaleContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SaleContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SaleContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SaleContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SaleContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SaleContainer
     */
    public function getAttributeName()
    {
        return 'SaleContainer';
    }
}
