<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSaleGoodContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSaleGoodContainer
 * @subpackage Arrays
 */
class ArrayOfSaleGoodContainer extends AbstractStructArrayBase
{
    /**
     * The SaleGoodContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaleGoodContainer[]
     */
    public $SaleGoodContainer;
    /**
     * Constructor method for ArrayOfSaleGoodContainer
     * @uses ArrayOfSaleGoodContainer::setSaleGoodContainer()
     * @param \StructType\SaleGoodContainer[] $saleGoodContainer
     */
    public function __construct(array $saleGoodContainer = array())
    {
        $this
            ->setSaleGoodContainer($saleGoodContainer);
    }
    /**
     * Get SaleGoodContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaleGoodContainer[]|null
     */
    public function getSaleGoodContainer()
    {
        return isset($this->SaleGoodContainer) ? $this->SaleGoodContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleGoodContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleGoodContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleGoodContainerForArrayConstraintsFromSetSaleGoodContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSaleGoodContainerSaleGoodContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfSaleGoodContainerSaleGoodContainerItem instanceof \StructType\SaleGoodContainer) {
                $invalidValues[] = is_object($arrayOfSaleGoodContainerSaleGoodContainerItem) ? get_class($arrayOfSaleGoodContainerSaleGoodContainerItem) : sprintf('%s(%s)', gettype($arrayOfSaleGoodContainerSaleGoodContainerItem), var_export($arrayOfSaleGoodContainerSaleGoodContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaleGoodContainer property can only contain items of type \StructType\SaleGoodContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaleGoodContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaleGoodContainer[] $saleGoodContainer
     * @return \ArrayType\ArrayOfSaleGoodContainer
     */
    public function setSaleGoodContainer(array $saleGoodContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($saleGoodContainerArrayErrorMessage = self::validateSaleGoodContainerForArrayConstraintsFromSetSaleGoodContainer($saleGoodContainer))) {
            throw new \InvalidArgumentException($saleGoodContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($saleGoodContainer) || (is_array($saleGoodContainer) && empty($saleGoodContainer))) {
            unset($this->SaleGoodContainer);
        } else {
            $this->SaleGoodContainer = $saleGoodContainer;
        }
        return $this;
    }
    /**
     * Add item to SaleGoodContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleGoodContainer $item
     * @return \ArrayType\ArrayOfSaleGoodContainer
     */
    public function addToSaleGoodContainer(\StructType\SaleGoodContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleGoodContainer) {
            throw new \InvalidArgumentException(sprintf('The SaleGoodContainer property can only contain items of type \StructType\SaleGoodContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaleGoodContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SaleGoodContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SaleGoodContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SaleGoodContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SaleGoodContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SaleGoodContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SaleGoodContainer
     */
    public function getAttributeName()
    {
        return 'SaleGoodContainer';
    }
}
