<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetDeliveryAddresResultItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSetDeliveryAddresResultItem
 * @subpackage Arrays
 */
class ArrayOfSetDeliveryAddresResultItem extends AbstractStructArrayBase
{
    /**
     * The SetDeliveryAddresResultItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetDeliveryAddresResultItem[]
     */
    public $SetDeliveryAddresResultItem;
    /**
     * Constructor method for ArrayOfSetDeliveryAddresResultItem
     * @uses ArrayOfSetDeliveryAddresResultItem::setSetDeliveryAddresResultItem()
     * @param \StructType\SetDeliveryAddresResultItem[] $setDeliveryAddresResultItem
     */
    public function __construct(array $setDeliveryAddresResultItem = array())
    {
        $this
            ->setSetDeliveryAddresResultItem($setDeliveryAddresResultItem);
    }
    /**
     * Get SetDeliveryAddresResultItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetDeliveryAddresResultItem[]|null
     */
    public function getSetDeliveryAddresResultItem()
    {
        return isset($this->SetDeliveryAddresResultItem) ? $this->SetDeliveryAddresResultItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetDeliveryAddresResultItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetDeliveryAddresResultItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetDeliveryAddresResultItemForArrayConstraintsFromSetSetDeliveryAddresResultItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem instanceof \StructType\SetDeliveryAddresResultItem) {
                $invalidValues[] = is_object($arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem) ? get_class($arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem) : sprintf('%s(%s)', gettype($arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem), var_export($arrayOfSetDeliveryAddresResultItemSetDeliveryAddresResultItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetDeliveryAddresResultItem property can only contain items of type \StructType\SetDeliveryAddresResultItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetDeliveryAddresResultItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetDeliveryAddresResultItem[] $setDeliveryAddresResultItem
     * @return \ArrayType\ArrayOfSetDeliveryAddresResultItem
     */
    public function setSetDeliveryAddresResultItem(array $setDeliveryAddresResultItem = array())
    {
        // validation for constraint: array
        if ('' !== ($setDeliveryAddresResultItemArrayErrorMessage = self::validateSetDeliveryAddresResultItemForArrayConstraintsFromSetSetDeliveryAddresResultItem($setDeliveryAddresResultItem))) {
            throw new \InvalidArgumentException($setDeliveryAddresResultItemArrayErrorMessage, __LINE__);
        }
        if (is_null($setDeliveryAddresResultItem) || (is_array($setDeliveryAddresResultItem) && empty($setDeliveryAddresResultItem))) {
            unset($this->SetDeliveryAddresResultItem);
        } else {
            $this->SetDeliveryAddresResultItem = $setDeliveryAddresResultItem;
        }
        return $this;
    }
    /**
     * Add item to SetDeliveryAddresResultItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SetDeliveryAddresResultItem $item
     * @return \ArrayType\ArrayOfSetDeliveryAddresResultItem
     */
    public function addToSetDeliveryAddresResultItem(\StructType\SetDeliveryAddresResultItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetDeliveryAddresResultItem) {
            throw new \InvalidArgumentException(sprintf('The SetDeliveryAddresResultItem property can only contain items of type \StructType\SetDeliveryAddresResultItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetDeliveryAddresResultItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetDeliveryAddresResultItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetDeliveryAddresResultItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetDeliveryAddresResultItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetDeliveryAddresResultItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetDeliveryAddresResultItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetDeliveryAddresResultItem
     */
    public function getAttributeName()
    {
        return 'SetDeliveryAddresResultItem';
    }
}
