<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetOrderDeliveryPeriodContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSetOrderDeliveryPeriodContainer
 * @subpackage Arrays
 */
class ArrayOfSetOrderDeliveryPeriodContainer extends AbstractStructArrayBase
{
    /**
     * The SetOrderDeliveryPeriodContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetOrderDeliveryPeriodContainer[]
     */
    public $SetOrderDeliveryPeriodContainer;
    /**
     * Constructor method for ArrayOfSetOrderDeliveryPeriodContainer
     * @uses ArrayOfSetOrderDeliveryPeriodContainer::setSetOrderDeliveryPeriodContainer()
     * @param \StructType\SetOrderDeliveryPeriodContainer[] $setOrderDeliveryPeriodContainer
     */
    public function __construct(array $setOrderDeliveryPeriodContainer = array())
    {
        $this
            ->setSetOrderDeliveryPeriodContainer($setOrderDeliveryPeriodContainer);
    }
    /**
     * Get SetOrderDeliveryPeriodContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetOrderDeliveryPeriodContainer[]|null
     */
    public function getSetOrderDeliveryPeriodContainer()
    {
        return isset($this->SetOrderDeliveryPeriodContainer) ? $this->SetOrderDeliveryPeriodContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetOrderDeliveryPeriodContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetOrderDeliveryPeriodContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetOrderDeliveryPeriodContainerForArrayConstraintsFromSetSetOrderDeliveryPeriodContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem instanceof \StructType\SetOrderDeliveryPeriodContainer) {
                $invalidValues[] = is_object($arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem) ? get_class($arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem) : sprintf('%s(%s)', gettype($arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem), var_export($arrayOfSetOrderDeliveryPeriodContainerSetOrderDeliveryPeriodContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetOrderDeliveryPeriodContainer property can only contain items of type \StructType\SetOrderDeliveryPeriodContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetOrderDeliveryPeriodContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetOrderDeliveryPeriodContainer[] $setOrderDeliveryPeriodContainer
     * @return \ArrayType\ArrayOfSetOrderDeliveryPeriodContainer
     */
    public function setSetOrderDeliveryPeriodContainer(array $setOrderDeliveryPeriodContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($setOrderDeliveryPeriodContainerArrayErrorMessage = self::validateSetOrderDeliveryPeriodContainerForArrayConstraintsFromSetSetOrderDeliveryPeriodContainer($setOrderDeliveryPeriodContainer))) {
            throw new \InvalidArgumentException($setOrderDeliveryPeriodContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($setOrderDeliveryPeriodContainer) || (is_array($setOrderDeliveryPeriodContainer) && empty($setOrderDeliveryPeriodContainer))) {
            unset($this->SetOrderDeliveryPeriodContainer);
        } else {
            $this->SetOrderDeliveryPeriodContainer = $setOrderDeliveryPeriodContainer;
        }
        return $this;
    }
    /**
     * Add item to SetOrderDeliveryPeriodContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\SetOrderDeliveryPeriodContainer $item
     * @return \ArrayType\ArrayOfSetOrderDeliveryPeriodContainer
     */
    public function addToSetOrderDeliveryPeriodContainer(\StructType\SetOrderDeliveryPeriodContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetOrderDeliveryPeriodContainer) {
            throw new \InvalidArgumentException(sprintf('The SetOrderDeliveryPeriodContainer property can only contain items of type \StructType\SetOrderDeliveryPeriodContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetOrderDeliveryPeriodContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetOrderDeliveryPeriodContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetOrderDeliveryPeriodContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetOrderDeliveryPeriodContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetOrderDeliveryPeriodContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetOrderDeliveryPeriodContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetOrderDeliveryPeriodContainer
     */
    public function getAttributeName()
    {
        return 'SetOrderDeliveryPeriodContainer';
    }
}
