<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetOrderDeliveryResultItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSetOrderDeliveryResultItem
 * @subpackage Arrays
 */
class ArrayOfSetOrderDeliveryResultItem extends AbstractStructArrayBase
{
    /**
     * The SetOrderDeliveryResultItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetOrderDeliveryResultItem[]
     */
    public $SetOrderDeliveryResultItem;
    /**
     * Constructor method for ArrayOfSetOrderDeliveryResultItem
     * @uses ArrayOfSetOrderDeliveryResultItem::setSetOrderDeliveryResultItem()
     * @param \StructType\SetOrderDeliveryResultItem[] $setOrderDeliveryResultItem
     */
    public function __construct(array $setOrderDeliveryResultItem = array())
    {
        $this
            ->setSetOrderDeliveryResultItem($setOrderDeliveryResultItem);
    }
    /**
     * Get SetOrderDeliveryResultItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetOrderDeliveryResultItem[]|null
     */
    public function getSetOrderDeliveryResultItem()
    {
        return isset($this->SetOrderDeliveryResultItem) ? $this->SetOrderDeliveryResultItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetOrderDeliveryResultItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetOrderDeliveryResultItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetOrderDeliveryResultItemForArrayConstraintsFromSetSetOrderDeliveryResultItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem instanceof \StructType\SetOrderDeliveryResultItem) {
                $invalidValues[] = is_object($arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem) ? get_class($arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem) : sprintf('%s(%s)', gettype($arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem), var_export($arrayOfSetOrderDeliveryResultItemSetOrderDeliveryResultItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetOrderDeliveryResultItem property can only contain items of type \StructType\SetOrderDeliveryResultItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetOrderDeliveryResultItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetOrderDeliveryResultItem[] $setOrderDeliveryResultItem
     * @return \ArrayType\ArrayOfSetOrderDeliveryResultItem
     */
    public function setSetOrderDeliveryResultItem(array $setOrderDeliveryResultItem = array())
    {
        // validation for constraint: array
        if ('' !== ($setOrderDeliveryResultItemArrayErrorMessage = self::validateSetOrderDeliveryResultItemForArrayConstraintsFromSetSetOrderDeliveryResultItem($setOrderDeliveryResultItem))) {
            throw new \InvalidArgumentException($setOrderDeliveryResultItemArrayErrorMessage, __LINE__);
        }
        if (is_null($setOrderDeliveryResultItem) || (is_array($setOrderDeliveryResultItem) && empty($setOrderDeliveryResultItem))) {
            unset($this->SetOrderDeliveryResultItem);
        } else {
            $this->SetOrderDeliveryResultItem = $setOrderDeliveryResultItem;
        }
        return $this;
    }
    /**
     * Add item to SetOrderDeliveryResultItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SetOrderDeliveryResultItem $item
     * @return \ArrayType\ArrayOfSetOrderDeliveryResultItem
     */
    public function addToSetOrderDeliveryResultItem(\StructType\SetOrderDeliveryResultItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetOrderDeliveryResultItem) {
            throw new \InvalidArgumentException(sprintf('The SetOrderDeliveryResultItem property can only contain items of type \StructType\SetOrderDeliveryResultItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetOrderDeliveryResultItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetOrderDeliveryResultItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetOrderDeliveryResultItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetOrderDeliveryResultItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetOrderDeliveryResultItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetOrderDeliveryResultItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetOrderDeliveryResultItem
     */
    public function getAttributeName()
    {
        return 'SetOrderDeliveryResultItem';
    }
}
