<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSparePartContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSparePartContainer
 * @subpackage Arrays
 */
class ArrayOfSparePartContainer extends AbstractStructArrayBase
{
    /**
     * The SparePartContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SparePartContainer[]
     */
    public $SparePartContainer;
    /**
     * Constructor method for ArrayOfSparePartContainer
     * @uses ArrayOfSparePartContainer::setSparePartContainer()
     * @param \StructType\SparePartContainer[] $sparePartContainer
     */
    public function __construct(array $sparePartContainer = array())
    {
        $this
            ->setSparePartContainer($sparePartContainer);
    }
    /**
     * Get SparePartContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SparePartContainer[]|null
     */
    public function getSparePartContainer()
    {
        return isset($this->SparePartContainer) ? $this->SparePartContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSparePartContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSparePartContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSparePartContainerForArrayConstraintsFromSetSparePartContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSparePartContainerSparePartContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfSparePartContainerSparePartContainerItem instanceof \StructType\SparePartContainer) {
                $invalidValues[] = is_object($arrayOfSparePartContainerSparePartContainerItem) ? get_class($arrayOfSparePartContainerSparePartContainerItem) : sprintf('%s(%s)', gettype($arrayOfSparePartContainerSparePartContainerItem), var_export($arrayOfSparePartContainerSparePartContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SparePartContainer property can only contain items of type \StructType\SparePartContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SparePartContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SparePartContainer[] $sparePartContainer
     * @return \ArrayType\ArrayOfSparePartContainer
     */
    public function setSparePartContainer(array $sparePartContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($sparePartContainerArrayErrorMessage = self::validateSparePartContainerForArrayConstraintsFromSetSparePartContainer($sparePartContainer))) {
            throw new \InvalidArgumentException($sparePartContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($sparePartContainer) || (is_array($sparePartContainer) && empty($sparePartContainer))) {
            unset($this->SparePartContainer);
        } else {
            $this->SparePartContainer = $sparePartContainer;
        }
        return $this;
    }
    /**
     * Add item to SparePartContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\SparePartContainer $item
     * @return \ArrayType\ArrayOfSparePartContainer
     */
    public function addToSparePartContainer(\StructType\SparePartContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SparePartContainer) {
            throw new \InvalidArgumentException(sprintf('The SparePartContainer property can only contain items of type \StructType\SparePartContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SparePartContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SparePartContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SparePartContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SparePartContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SparePartContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SparePartContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SparePartContainer
     */
    public function getAttributeName()
    {
        return 'SparePartContainer';
    }
}
