<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTyrePriceRest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTyrePriceRest
 * @subpackage Arrays
 */
class ArrayOfTyrePriceRest extends AbstractStructArrayBase
{
    /**
     * The TyrePriceRest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TyrePriceRest[]
     */
    public $TyrePriceRest;
    /**
     * Constructor method for ArrayOfTyrePriceRest
     * @uses ArrayOfTyrePriceRest::setTyrePriceRest()
     * @param \StructType\TyrePriceRest[] $tyrePriceRest
     */
    public function __construct(array $tyrePriceRest = array())
    {
        $this
            ->setTyrePriceRest($tyrePriceRest);
    }
    /**
     * Get TyrePriceRest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TyrePriceRest[]|null
     */
    public function getTyrePriceRest()
    {
        return isset($this->TyrePriceRest) ? $this->TyrePriceRest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTyrePriceRest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTyrePriceRest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTyrePriceRestForArrayConstraintsFromSetTyrePriceRest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTyrePriceRestTyrePriceRestItem) {
            // validation for constraint: itemType
            if (!$arrayOfTyrePriceRestTyrePriceRestItem instanceof \StructType\TyrePriceRest) {
                $invalidValues[] = is_object($arrayOfTyrePriceRestTyrePriceRestItem) ? get_class($arrayOfTyrePriceRestTyrePriceRestItem) : sprintf('%s(%s)', gettype($arrayOfTyrePriceRestTyrePriceRestItem), var_export($arrayOfTyrePriceRestTyrePriceRestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TyrePriceRest property can only contain items of type \StructType\TyrePriceRest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TyrePriceRest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TyrePriceRest[] $tyrePriceRest
     * @return \ArrayType\ArrayOfTyrePriceRest
     */
    public function setTyrePriceRest(array $tyrePriceRest = array())
    {
        // validation for constraint: array
        if ('' !== ($tyrePriceRestArrayErrorMessage = self::validateTyrePriceRestForArrayConstraintsFromSetTyrePriceRest($tyrePriceRest))) {
            throw new \InvalidArgumentException($tyrePriceRestArrayErrorMessage, __LINE__);
        }
        if (is_null($tyrePriceRest) || (is_array($tyrePriceRest) && empty($tyrePriceRest))) {
            unset($this->TyrePriceRest);
        } else {
            $this->TyrePriceRest = $tyrePriceRest;
        }
        return $this;
    }
    /**
     * Add item to TyrePriceRest value
     * @throws \InvalidArgumentException
     * @param \StructType\TyrePriceRest $item
     * @return \ArrayType\ArrayOfTyrePriceRest
     */
    public function addToTyrePriceRest(\StructType\TyrePriceRest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TyrePriceRest) {
            throw new \InvalidArgumentException(sprintf('The TyrePriceRest property can only contain items of type \StructType\TyrePriceRest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TyrePriceRest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TyrePriceRest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TyrePriceRest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TyrePriceRest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TyrePriceRest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TyrePriceRest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TyrePriceRest
     */
    public function getAttributeName()
    {
        return 'TyrePriceRest';
    }
}
