<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWarehouseLogistic ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWarehouseLogistic
 * @subpackage Arrays
 */
class ArrayOfWarehouseLogistic extends AbstractStructArrayBase
{
    /**
     * The WarehouseLogistic
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WarehouseLogistic[]
     */
    public $WarehouseLogistic;
    /**
     * Constructor method for ArrayOfWarehouseLogistic
     * @uses ArrayOfWarehouseLogistic::setWarehouseLogistic()
     * @param \StructType\WarehouseLogistic[] $warehouseLogistic
     */
    public function __construct(array $warehouseLogistic = array())
    {
        $this
            ->setWarehouseLogistic($warehouseLogistic);
    }
    /**
     * Get WarehouseLogistic value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WarehouseLogistic[]|null
     */
    public function getWarehouseLogistic()
    {
        return isset($this->WarehouseLogistic) ? $this->WarehouseLogistic : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWarehouseLogistic method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWarehouseLogistic method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWarehouseLogisticForArrayConstraintsFromSetWarehouseLogistic(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWarehouseLogisticWarehouseLogisticItem) {
            // validation for constraint: itemType
            if (!$arrayOfWarehouseLogisticWarehouseLogisticItem instanceof \StructType\WarehouseLogistic) {
                $invalidValues[] = is_object($arrayOfWarehouseLogisticWarehouseLogisticItem) ? get_class($arrayOfWarehouseLogisticWarehouseLogisticItem) : sprintf('%s(%s)', gettype($arrayOfWarehouseLogisticWarehouseLogisticItem), var_export($arrayOfWarehouseLogisticWarehouseLogisticItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WarehouseLogistic property can only contain items of type \StructType\WarehouseLogistic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WarehouseLogistic value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WarehouseLogistic[] $warehouseLogistic
     * @return \ArrayType\ArrayOfWarehouseLogistic
     */
    public function setWarehouseLogistic(array $warehouseLogistic = array())
    {
        // validation for constraint: array
        if ('' !== ($warehouseLogisticArrayErrorMessage = self::validateWarehouseLogisticForArrayConstraintsFromSetWarehouseLogistic($warehouseLogistic))) {
            throw new \InvalidArgumentException($warehouseLogisticArrayErrorMessage, __LINE__);
        }
        if (is_null($warehouseLogistic) || (is_array($warehouseLogistic) && empty($warehouseLogistic))) {
            unset($this->WarehouseLogistic);
        } else {
            $this->WarehouseLogistic = $warehouseLogistic;
        }
        return $this;
    }
    /**
     * Add item to WarehouseLogistic value
     * @throws \InvalidArgumentException
     * @param \StructType\WarehouseLogistic $item
     * @return \ArrayType\ArrayOfWarehouseLogistic
     */
    public function addToWarehouseLogistic(\StructType\WarehouseLogistic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WarehouseLogistic) {
            throw new \InvalidArgumentException(sprintf('The WarehouseLogistic property can only contain items of type \StructType\WarehouseLogistic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WarehouseLogistic[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WarehouseLogistic|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WarehouseLogistic|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WarehouseLogistic|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WarehouseLogistic|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WarehouseLogistic|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WarehouseLogistic
     */
    public function getAttributeName()
    {
        return 'WarehouseLogistic';
    }
}
