<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfgetAddressListItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfgetAddressListItem
 * @subpackage Arrays
 */
class ArrayOfgetAddressListItem extends AbstractStructArrayBase
{
    /**
     * The getAddressListItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetAddressListItem[]
     */
    public $getAddressListItem;
    /**
     * Constructor method for ArrayOfgetAddressListItem
     * @uses ArrayOfgetAddressListItem::setGetAddressListItem()
     * @param \StructType\GetAddressListItem[] $getAddressListItem
     */
    public function __construct(array $getAddressListItem = array())
    {
        $this
            ->setGetAddressListItem($getAddressListItem);
    }
    /**
     * Get getAddressListItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetAddressListItem[]|null
     */
    public function getGetAddressListItem()
    {
        return isset($this->getAddressListItem) ? $this->getAddressListItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetAddressListItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetAddressListItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetAddressListItemForArrayConstraintsFromSetGetAddressListItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfgetAddressListItemGetAddressListItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfgetAddressListItemGetAddressListItemItem instanceof \StructType\GetAddressListItem) {
                $invalidValues[] = is_object($arrayOfgetAddressListItemGetAddressListItemItem) ? get_class($arrayOfgetAddressListItemGetAddressListItemItem) : sprintf('%s(%s)', gettype($arrayOfgetAddressListItemGetAddressListItemItem), var_export($arrayOfgetAddressListItemGetAddressListItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The getAddressListItem property can only contain items of type \StructType\GetAddressListItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set getAddressListItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetAddressListItem[] $getAddressListItem
     * @return \ArrayType\ArrayOfgetAddressListItem
     */
    public function setGetAddressListItem(array $getAddressListItem = array())
    {
        // validation for constraint: array
        if ('' !== ($getAddressListItemArrayErrorMessage = self::validateGetAddressListItemForArrayConstraintsFromSetGetAddressListItem($getAddressListItem))) {
            throw new \InvalidArgumentException($getAddressListItemArrayErrorMessage, __LINE__);
        }
        if (is_null($getAddressListItem) || (is_array($getAddressListItem) && empty($getAddressListItem))) {
            unset($this->getAddressListItem);
        } else {
            $this->getAddressListItem = $getAddressListItem;
        }
        return $this;
    }
    /**
     * Add item to getAddressListItem value
     * @throws \InvalidArgumentException
     * @param \StructType\GetAddressListItem $item
     * @return \ArrayType\ArrayOfgetAddressListItem
     */
    public function addToGetAddressListItem(\StructType\GetAddressListItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetAddressListItem) {
            throw new \InvalidArgumentException(sprintf('The getAddressListItem property can only contain items of type \StructType\GetAddressListItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->getAddressListItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetAddressListItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetAddressListItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetAddressListItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetAddressListItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetAddressListItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string getAddressListItem
     */
    public function getAttributeName()
    {
        return 'getAddressListItem';
    }
}
