<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfgtdContainer ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfgtdContainer
 * @subpackage Arrays
 */
class ArrayOfgtdContainer extends AbstractStructArrayBase
{
    /**
     * The gtdContainer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GtdContainer[]
     */
    public $gtdContainer;
    /**
     * Constructor method for ArrayOfgtdContainer
     * @uses ArrayOfgtdContainer::setGtdContainer()
     * @param \StructType\GtdContainer[] $gtdContainer
     */
    public function __construct(array $gtdContainer = array())
    {
        $this
            ->setGtdContainer($gtdContainer);
    }
    /**
     * Get gtdContainer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GtdContainer[]|null
     */
    public function getGtdContainer()
    {
        return isset($this->gtdContainer) ? $this->gtdContainer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGtdContainer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGtdContainer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGtdContainerForArrayConstraintsFromSetGtdContainer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfgtdContainerGtdContainerItem) {
            // validation for constraint: itemType
            if (!$arrayOfgtdContainerGtdContainerItem instanceof \StructType\GtdContainer) {
                $invalidValues[] = is_object($arrayOfgtdContainerGtdContainerItem) ? get_class($arrayOfgtdContainerGtdContainerItem) : sprintf('%s(%s)', gettype($arrayOfgtdContainerGtdContainerItem), var_export($arrayOfgtdContainerGtdContainerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The gtdContainer property can only contain items of type \StructType\GtdContainer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set gtdContainer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GtdContainer[] $gtdContainer
     * @return \ArrayType\ArrayOfgtdContainer
     */
    public function setGtdContainer(array $gtdContainer = array())
    {
        // validation for constraint: array
        if ('' !== ($gtdContainerArrayErrorMessage = self::validateGtdContainerForArrayConstraintsFromSetGtdContainer($gtdContainer))) {
            throw new \InvalidArgumentException($gtdContainerArrayErrorMessage, __LINE__);
        }
        if (is_null($gtdContainer) || (is_array($gtdContainer) && empty($gtdContainer))) {
            unset($this->gtdContainer);
        } else {
            $this->gtdContainer = $gtdContainer;
        }
        return $this;
    }
    /**
     * Add item to gtdContainer value
     * @throws \InvalidArgumentException
     * @param \StructType\GtdContainer $item
     * @return \ArrayType\ArrayOfgtdContainer
     */
    public function addToGtdContainer(\StructType\GtdContainer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GtdContainer) {
            throw new \InvalidArgumentException(sprintf('The gtdContainer property can only contain items of type \StructType\GtdContainer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->gtdContainer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GtdContainer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GtdContainer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GtdContainer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GtdContainer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GtdContainer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string gtdContainer
     */
    public function getAttributeName()
    {
        return 'gtdContainer';
    }
}
