<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfprice_rest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfprice_rest
 * @subpackage Arrays
 */
class ArrayOfprice_rest extends AbstractStructArrayBase
{
    /**
     * The price_rest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Price_rest[]
     */
    public $price_rest;
    /**
     * Constructor method for ArrayOfprice_rest
     * @uses ArrayOfprice_rest::setPrice_rest()
     * @param \StructType\Price_rest[] $price_rest
     */
    public function __construct(array $price_rest = array())
    {
        $this
            ->setPrice_rest($price_rest);
    }
    /**
     * Get price_rest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Price_rest[]|null
     */
    public function getPrice_rest()
    {
        return isset($this->price_rest) ? $this->price_rest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrice_rest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrice_rest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrice_restForArrayConstraintsFromSetPrice_rest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfprice_restPrice_restItem) {
            // validation for constraint: itemType
            if (!$arrayOfprice_restPrice_restItem instanceof \StructType\Price_rest) {
                $invalidValues[] = is_object($arrayOfprice_restPrice_restItem) ? get_class($arrayOfprice_restPrice_restItem) : sprintf('%s(%s)', gettype($arrayOfprice_restPrice_restItem), var_export($arrayOfprice_restPrice_restItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The price_rest property can only contain items of type \StructType\Price_rest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set price_rest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Price_rest[] $price_rest
     * @return \ArrayType\ArrayOfprice_rest
     */
    public function setPrice_rest(array $price_rest = array())
    {
        // validation for constraint: array
        if ('' !== ($price_restArrayErrorMessage = self::validatePrice_restForArrayConstraintsFromSetPrice_rest($price_rest))) {
            throw new \InvalidArgumentException($price_restArrayErrorMessage, __LINE__);
        }
        if (is_null($price_rest) || (is_array($price_rest) && empty($price_rest))) {
            unset($this->price_rest);
        } else {
            $this->price_rest = $price_rest;
        }
        return $this;
    }
    /**
     * Add item to price_rest value
     * @throws \InvalidArgumentException
     * @param \StructType\Price_rest $item
     * @return \ArrayType\ArrayOfprice_rest
     */
    public function addToPrice_rest(\StructType\Price_rest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Price_rest) {
            throw new \InvalidArgumentException(sprintf('The price_rest property can only contain items of type \StructType\Price_rest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->price_rest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Price_rest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Price_rest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Price_rest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Price_rest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Price_rest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string price_rest
     */
    public function getAttributeName()
    {
        return 'price_rest';
    }
}
