<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfproposeConsumableItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfproposeConsumableItem
 * @subpackage Arrays
 */
class ArrayOfproposeConsumableItem extends AbstractStructArrayBase
{
    /**
     * The proposeConsumableItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProposeConsumableItem[]
     */
    public $proposeConsumableItem;
    /**
     * Constructor method for ArrayOfproposeConsumableItem
     * @uses ArrayOfproposeConsumableItem::setProposeConsumableItem()
     * @param \StructType\ProposeConsumableItem[] $proposeConsumableItem
     */
    public function __construct(array $proposeConsumableItem = array())
    {
        $this
            ->setProposeConsumableItem($proposeConsumableItem);
    }
    /**
     * Get proposeConsumableItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProposeConsumableItem[]|null
     */
    public function getProposeConsumableItem()
    {
        return isset($this->proposeConsumableItem) ? $this->proposeConsumableItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProposeConsumableItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProposeConsumableItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProposeConsumableItemForArrayConstraintsFromSetProposeConsumableItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfproposeConsumableItemProposeConsumableItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfproposeConsumableItemProposeConsumableItemItem instanceof \StructType\ProposeConsumableItem) {
                $invalidValues[] = is_object($arrayOfproposeConsumableItemProposeConsumableItemItem) ? get_class($arrayOfproposeConsumableItemProposeConsumableItemItem) : sprintf('%s(%s)', gettype($arrayOfproposeConsumableItemProposeConsumableItemItem), var_export($arrayOfproposeConsumableItemProposeConsumableItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The proposeConsumableItem property can only contain items of type \StructType\ProposeConsumableItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set proposeConsumableItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProposeConsumableItem[] $proposeConsumableItem
     * @return \ArrayType\ArrayOfproposeConsumableItem
     */
    public function setProposeConsumableItem(array $proposeConsumableItem = array())
    {
        // validation for constraint: array
        if ('' !== ($proposeConsumableItemArrayErrorMessage = self::validateProposeConsumableItemForArrayConstraintsFromSetProposeConsumableItem($proposeConsumableItem))) {
            throw new \InvalidArgumentException($proposeConsumableItemArrayErrorMessage, __LINE__);
        }
        if (is_null($proposeConsumableItem) || (is_array($proposeConsumableItem) && empty($proposeConsumableItem))) {
            unset($this->proposeConsumableItem);
        } else {
            $this->proposeConsumableItem = $proposeConsumableItem;
        }
        return $this;
    }
    /**
     * Add item to proposeConsumableItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ProposeConsumableItem $item
     * @return \ArrayType\ArrayOfproposeConsumableItem
     */
    public function addToProposeConsumableItem(\StructType\ProposeConsumableItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProposeConsumableItem) {
            throw new \InvalidArgumentException(sprintf('The proposeConsumableItem property can only contain items of type \StructType\ProposeConsumableItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->proposeConsumableItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProposeConsumableItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProposeConsumableItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProposeConsumableItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProposeConsumableItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProposeConsumableItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string proposeConsumableItem
     */
    public function getAttributeName()
    {
        return 'proposeConsumableItem';
    }
}
