<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsaleInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsaleInfo
 * @subpackage Arrays
 */
class ArrayOfsaleInfo extends AbstractStructArrayBase
{
    /**
     * The saleInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaleInfo[]
     */
    public $saleInfo;
    /**
     * Constructor method for ArrayOfsaleInfo
     * @uses ArrayOfsaleInfo::setSaleInfo()
     * @param \StructType\SaleInfo[] $saleInfo
     */
    public function __construct(array $saleInfo = array())
    {
        $this
            ->setSaleInfo($saleInfo);
    }
    /**
     * Get saleInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaleInfo[]|null
     */
    public function getSaleInfo()
    {
        return isset($this->saleInfo) ? $this->saleInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSaleInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaleInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaleInfoForArrayConstraintsFromSetSaleInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfsaleInfoSaleInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfsaleInfoSaleInfoItem instanceof \StructType\SaleInfo) {
                $invalidValues[] = is_object($arrayOfsaleInfoSaleInfoItem) ? get_class($arrayOfsaleInfoSaleInfoItem) : sprintf('%s(%s)', gettype($arrayOfsaleInfoSaleInfoItem), var_export($arrayOfsaleInfoSaleInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The saleInfo property can only contain items of type \StructType\SaleInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set saleInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaleInfo[] $saleInfo
     * @return \ArrayType\ArrayOfsaleInfo
     */
    public function setSaleInfo(array $saleInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($saleInfoArrayErrorMessage = self::validateSaleInfoForArrayConstraintsFromSetSaleInfo($saleInfo))) {
            throw new \InvalidArgumentException($saleInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($saleInfo) || (is_array($saleInfo) && empty($saleInfo))) {
            unset($this->saleInfo);
        } else {
            $this->saleInfo = $saleInfo;
        }
        return $this;
    }
    /**
     * Add item to saleInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleInfo $item
     * @return \ArrayType\ArrayOfsaleInfo
     */
    public function addToSaleInfo(\StructType\SaleInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleInfo) {
            throw new \InvalidArgumentException(sprintf('The saleInfo property can only contain items of type \StructType\SaleInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->saleInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SaleInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SaleInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SaleInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SaleInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SaleInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string saleInfo
     */
    public function getAttributeName()
    {
        return 'saleInfo';
    }
}
