<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfyearAvto ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfyearAvto
 * @subpackage Arrays
 */
class ArrayOfyearAvto extends AbstractStructArrayBase
{
    /**
     * The yearAvto
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\YearAvto[]
     */
    public $yearAvto;
    /**
     * Constructor method for ArrayOfyearAvto
     * @uses ArrayOfyearAvto::setYearAvto()
     * @param \StructType\YearAvto[] $yearAvto
     */
    public function __construct(array $yearAvto = array())
    {
        $this
            ->setYearAvto($yearAvto);
    }
    /**
     * Get yearAvto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\YearAvto[]|null
     */
    public function getYearAvto()
    {
        return isset($this->yearAvto) ? $this->yearAvto : null;
    }
    /**
     * This method is responsible for validating the values passed to the setYearAvto method
     * This method is willingly generated in order to preserve the one-line inline validation within the setYearAvto method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateYearAvtoForArrayConstraintsFromSetYearAvto(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfyearAvtoYearAvtoItem) {
            // validation for constraint: itemType
            if (!$arrayOfyearAvtoYearAvtoItem instanceof \StructType\YearAvto) {
                $invalidValues[] = is_object($arrayOfyearAvtoYearAvtoItem) ? get_class($arrayOfyearAvtoYearAvtoItem) : sprintf('%s(%s)', gettype($arrayOfyearAvtoYearAvtoItem), var_export($arrayOfyearAvtoYearAvtoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The yearAvto property can only contain items of type \StructType\YearAvto, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set yearAvto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\YearAvto[] $yearAvto
     * @return \ArrayType\ArrayOfyearAvto
     */
    public function setYearAvto(array $yearAvto = array())
    {
        // validation for constraint: array
        if ('' !== ($yearAvtoArrayErrorMessage = self::validateYearAvtoForArrayConstraintsFromSetYearAvto($yearAvto))) {
            throw new \InvalidArgumentException($yearAvtoArrayErrorMessage, __LINE__);
        }
        if (is_null($yearAvto) || (is_array($yearAvto) && empty($yearAvto))) {
            unset($this->yearAvto);
        } else {
            $this->yearAvto = $yearAvto;
        }
        return $this;
    }
    /**
     * Add item to yearAvto value
     * @throws \InvalidArgumentException
     * @param \StructType\YearAvto $item
     * @return \ArrayType\ArrayOfyearAvto
     */
    public function addToYearAvto(\StructType\YearAvto $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\YearAvto) {
            throw new \InvalidArgumentException(sprintf('The yearAvto property can only contain items of type \StructType\YearAvto, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->yearAvto[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\YearAvto|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\YearAvto|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\YearAvto|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\YearAvto|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\YearAvto|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string yearAvto
     */
    public function getAttributeName()
    {
        return 'yearAvto';
    }
}
