<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetFindTyre' => '\\StructType\\GetFindTyre',
            'GetFindTyreResponse' => '\\StructType\\GetFindTyreResponse',
            'GetFindDisk' => '\\StructType\\GetFindDisk',
            'GetFindDiskResponse' => '\\StructType\\GetFindDiskResponse',
            'GetGoodsPriceRestByCode' => '\\StructType\\GetGoodsPriceRestByCode',
            'GetGoodsPriceRestByCodeResponse' => '\\StructType\\GetGoodsPriceRestByCodeResponse',
            'GetGoodsInfo' => '\\StructType\\GetGoodsInfo',
            'GetGoodsInfoResponse' => '\\StructType\\GetGoodsInfoResponse',
            'GetGoodsByCar' => '\\StructType\\GetGoodsByCar',
            'GetGoodsByCarResponse' => '\\StructType\\GetGoodsByCarResponse',
            'GetMarkaAvto' => '\\StructType\\GetMarkaAvto',
            'GetMarkaAvtoResponse' => '\\StructType\\GetMarkaAvtoResponse',
            'GetModelAvto' => '\\StructType\\GetModelAvto',
            'GetModelAvtoResponse' => '\\StructType\\GetModelAvtoResponse',
            'GetYearAvto' => '\\StructType\\GetYearAvto',
            'GetYearAvtoResponse' => '\\StructType\\GetYearAvtoResponse',
            'GetModificationAvto' => '\\StructType\\GetModificationAvto',
            'GetModificationAvtoResponse' => '\\StructType\\GetModificationAvtoResponse',
            'SetRest' => '\\StructType\\SetRest',
            'SetRestResponse' => '\\StructType\\SetRestResponse',
            'SetPrice' => '\\StructType\\SetPrice',
            'SetPriceResponse' => '\\StructType\\SetPriceResponse',
            'CreateOrder' => '\\StructType\\CreateOrder',
            'CreateOrderResponse' => '\\StructType\\CreateOrderResponse',
            'GetChangeOrder' => '\\StructType\\GetChangeOrder',
            'GetChangeOrderResponse' => '\\StructType\\GetChangeOrderResponse',
            'SetOrderStatus' => '\\StructType\\SetOrderStatus',
            'SetOrderStatusResponse' => '\\StructType\\SetOrderStatusResponse',
            'SetOrderStatusSatellite' => '\\StructType\\SetOrderStatusSatellite',
            'SetOrderStatusSatelliteResponse' => '\\StructType\\SetOrderStatusSatelliteResponse',
            'GetOrderStatus' => '\\StructType\\GetOrderStatus',
            'GetOrderStatusResponse' => '\\StructType\\GetOrderStatusResponse',
            'SetMergeOrders' => '\\StructType\\SetMergeOrders',
            'SetMergeOrdersResponse' => '\\StructType\\SetMergeOrdersResponse',
            'GetOrderInfo' => '\\StructType\\GetOrderInfo',
            'GetOrderInfoResponse' => '\\StructType\\GetOrderInfoResponse',
            'GetStatusList' => '\\StructType\\GetStatusList',
            'GetStatusListResponse' => '\\StructType\\GetStatusListResponse',
            'GetOrderComment' => '\\StructType\\GetOrderComment',
            'GetOrderCommentResponse' => '\\StructType\\GetOrderCommentResponse',
            'GetUserList' => '\\StructType\\GetUserList',
            'GetUserListResponse' => '\\StructType\\GetUserListResponse',
            'SetOrderComment' => '\\StructType\\SetOrderComment',
            'SetOrderCommentResponse' => '\\StructType\\SetOrderCommentResponse',
            'SetCancelDelivery' => '\\StructType\\SetCancelDelivery',
            'SetCancelDeliveryResponse' => '\\StructType\\SetCancelDeliveryResponse',
            'SetDeliveryInfo' => '\\StructType\\SetDeliveryInfo',
            'SetDeliveryInfoResponse' => '\\StructType\\SetDeliveryInfoResponse',
            'GetWarehouses' => '\\StructType\\GetWarehouses',
            'GetWarehousesResponse' => '\\StructType\\GetWarehousesResponse',
            'Ping' => '\\StructType\\Ping',
            'PingResponse' => '\\StructType\\PingResponse',
            'SetToMove' => '\\StructType\\SetToMove',
            'SetToMoveResponse' => '\\StructType\\SetToMoveResponse',
            'TireCalc' => '\\StructType\\TireCalc',
            'TireCalcResponse' => '\\StructType\\TireCalcResponse',
            'GetPressureSensor' => '\\StructType\\GetPressureSensor',
            'GetPressureSensorResponse' => '\\StructType\\GetPressureSensorResponse',
            'OrderReadyToWait' => '\\StructType\\OrderReadyToWait',
            'OrderReadyToWaitResponse' => '\\StructType\\OrderReadyToWaitResponse',
            'ProposeGoods' => '\\StructType\\ProposeGoods',
            'ProposeGoodsResponse' => '\\StructType\\ProposeGoodsResponse',
            'CreateMovement' => '\\StructType\\CreateMovement',
            'CreateMovementResponse' => '\\StructType\\CreateMovementResponse',
            'SetMovementStatus' => '\\StructType\\SetMovementStatus',
            'SetMovementStatusResponse' => '\\StructType\\SetMovementStatusResponse',
            'GetMovementList' => '\\StructType\\GetMovementList',
            'GetMovementListResponse' => '\\StructType\\GetMovementListResponse',
            'GetMovementInfo' => '\\StructType\\GetMovementInfo',
            'GetMovementInfoResponse' => '\\StructType\\GetMovementInfoResponse',
            'GetFastener' => '\\StructType\\GetFastener',
            'GetFastenerResponse' => '\\StructType\\GetFastenerResponse',
            'GetAddressList' => '\\StructType\\GetAddressList',
            'GetAddressListResponse' => '\\StructType\\GetAddressListResponse',
            'GetDeliveryPeriod' => '\\StructType\\GetDeliveryPeriod',
            'GetDeliveryPeriodResponse' => '\\StructType\\GetDeliveryPeriodResponse',
            'SetDeliveryAddress' => '\\StructType\\SetDeliveryAddress',
            'SetDeliveryAddressResponse' => '\\StructType\\SetDeliveryAddressResponse',
            'SetOrderDelivery' => '\\StructType\\SetOrderDelivery',
            'SetOrderDeliveryResponse' => '\\StructType\\SetOrderDeliveryResponse',
            'SetRemoveFromOH' => '\\StructType\\SetRemoveFromOH',
            'SetRemoveFromOHResponse' => '\\StructType\\SetRemoveFromOHResponse',
            'SetMarkCodeList' => '\\StructType\\SetMarkCodeList',
            'SetMarkCodeListResponse' => '\\StructType\\SetMarkCodeListResponse',
            'GetSaleInfo' => '\\StructType\\GetSaleInfo',
            'GetSaleInfoResponse' => '\\StructType\\GetSaleInfoResponse',
            'GetSaleList' => '\\StructType\\GetSaleList',
            'GetSaleListResponse' => '\\StructType\\GetSaleListResponse',
            'GetConsumable' => '\\StructType\\GetConsumable',
            'GetConsumableResponse' => '\\StructType\\GetConsumableResponse',
            'CreateConsignee' => '\\StructType\\CreateConsignee',
            'CreateConsigneeResponse' => '\\StructType\\CreateConsigneeResponse',
            'DeleteConsignee' => '\\StructType\\DeleteConsignee',
            'DeleteConsigneeResponse' => '\\StructType\\DeleteConsigneeResponse',
            'GetConsigneeList' => '\\StructType\\GetConsigneeList',
            'GetConsigneeListResponse' => '\\StructType\\GetConsigneeListResponse',
            'FindTyreFilter' => '\\StructType\\FindTyreFilter',
            'ResultFindTyre' => '\\StructType\\ResultFindTyre',
            'ArrayOfTyrePriceRest' => '\\ArrayType\\ArrayOfTyrePriceRest',
            'TyrePriceRest' => '\\StructType\\TyrePriceRest',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'CurrencyRate' => '\\StructType\\CurrencyRate',
            'Error' => '\\StructType\\Error',
            'ArrayOfwh_price_rest' => '\\ArrayType\\ArrayOfwh_price_rest',
            'wh_price_rest' => '\\StructType\\Wh_price_rest',
            'ArrayOfsaleInfo' => '\\ArrayType\\ArrayOfsaleInfo',
            'saleInfo' => '\\StructType\\SaleInfo',
            'ArrayOfWarehouseLogistic' => '\\ArrayType\\ArrayOfWarehouseLogistic',
            'WarehouseLogistic' => '\\StructType\\WarehouseLogistic',
            'CoordinatesAsDouble' => '\\StructType\\CoordinatesAsDouble',
            'ClientServiceResult' => '\\StructType\\ClientServiceResult',
            'Coordinates' => '\\StructType\\Coordinates',
            'FindDiskFilter' => '\\StructType\\FindDiskFilter',
            'ResultFindDisk' => '\\StructType\\ResultFindDisk',
            'ArrayOfDiskPriceRest' => '\\ArrayType\\ArrayOfDiskPriceRest',
            'DiskPriceRest' => '\\StructType\\DiskPriceRest',
            'GoodsPriceRestFilter' => '\\StructType\\GoodsPriceRestFilter',
            'GetGoodsPriceRestByCodeResult' => '\\StructType\\GetGoodsPriceRestByCodeResult',
            'ArrayOfprice_rest' => '\\ArrayType\\ArrayOfprice_rest',
            'price_rest' => '\\StructType\\Price_rest',
            'ResultGetGoodsInfo' => '\\StructType\\ResultGetGoodsInfo',
            'ArrayOfFastenerContainer' => '\\ArrayType\\ArrayOfFastenerContainer',
            'FastenerContainer' => '\\StructType\\FastenerContainer',
            'ArrayOfPressureSensorContainer' => '\\ArrayType\\ArrayOfPressureSensorContainer',
            'PressureSensorContainer' => '\\StructType\\PressureSensorContainer',
            'ArrayOfRimContainer' => '\\ArrayType\\ArrayOfRimContainer',
            'RimContainer' => '\\StructType\\RimContainer',
            'ArrayOfSparePartContainer' => '\\ArrayType\\ArrayOfSparePartContainer',
            'SparePartContainer' => '\\StructType\\SparePartContainer',
            'ArrayOfTyreContainer' => '\\ArrayType\\ArrayOfTyreContainer',
            'TyreContainer' => '\\StructType\\TyreContainer',
            'ArrayOfGtinItem' => '\\ArrayType\\ArrayOfGtinItem',
            'GtinItem' => '\\StructType\\GtinItem',
            'GetGoodsByCarFilter' => '\\StructType\\GetGoodsByCarFilter',
            'GetGoodsByCarResult' => '\\StructType\\GetGoodsByCarResult',
            'ArrayOfgoods_price_rest' => '\\ArrayType\\ArrayOfgoods_price_rest',
            'goods_price_rest' => '\\StructType\\Goods_price_rest',
            'GetMarkaAvtoResult' => '\\StructType\\GetMarkaAvtoResult',
            'ArrayOfyearAvto' => '\\ArrayType\\ArrayOfyearAvto',
            'yearAvto' => '\\StructType\\YearAvto',
            'ArrayOfRestList' => '\\ArrayType\\ArrayOfRestList',
            'RestList' => '\\StructType\\RestList',
            'setRestResult' => '\\StructType\\SetRestResult',
            'ArrayOfRestListError' => '\\ArrayType\\ArrayOfRestListError',
            'RestListError' => '\\StructType\\RestListError',
            'ArrayOfPriceList' => '\\ArrayType\\ArrayOfPriceList',
            'PriceList' => '\\StructType\\PriceList',
            'setPriceResult' => '\\StructType\\SetPriceResult',
            'ArrayOfPriceListError' => '\\ArrayType\\ArrayOfPriceListError',
            'PriceListError' => '\\StructType\\PriceListError',
            'Order' => '\\StructType\\Order',
            'BaseOrder' => '\\StructType\\BaseOrder',
            'DeliveryInfoContainer' => '\\StructType\\DeliveryInfoContainer',
            'deliveryDatePeriod' => '\\StructType\\DeliveryDatePeriod',
            'ArrayOfOrderProduct' => '\\ArrayType\\ArrayOfOrderProduct',
            'OrderProduct' => '\\StructType\\OrderProduct',
            'CreateOrderResult' => '\\StructType\\CreateOrderResult',
            'ArrayOfOrderProductError' => '\\ArrayType\\ArrayOfOrderProductError',
            'OrderProductError' => '\\StructType\\OrderProductError',
            'ArrayOfGoods' => '\\ArrayType\\ArrayOfGoods',
            'Goods' => '\\StructType\\Goods',
            'FindChangeOrderFilter' => '\\StructType\\FindChangeOrderFilter',
            'GetChangeOrderResult' => '\\StructType\\GetChangeOrderResult',
            'ArrayOfChangedOrder' => '\\ArrayType\\ArrayOfChangedOrder',
            'ChangedOrder' => '\\StructType\\ChangedOrder',
            'ClientSoapResultDM' => '\\StructType\\ClientSoapResultDM',
            'FindOrderFilter' => '\\StructType\\FindOrderFilter',
            'ArrayOfGetOrderStatusResult' => '\\ArrayType\\ArrayOfGetOrderStatusResult',
            'GetOrderStatusResult' => '\\StructType\\GetOrderStatusResult',
            'SetMergeOrdersResult' => '\\StructType\\SetMergeOrdersResult',
            'GetOrderInfoResult' => '\\StructType\\GetOrderInfoResult',
            'ArrayOfnote' => '\\ArrayType\\ArrayOfnote',
            'note' => '\\StructType\\Note',
            'ArrayOfGetStatusListResult' => '\\ArrayType\\ArrayOfGetStatusListResult',
            'GetStatusListResult' => '\\StructType\\GetStatusListResult',
            'FindOrderCommentFilter' => '\\StructType\\FindOrderCommentFilter',
            'GetOrderCommentResult' => '\\StructType\\GetOrderCommentResult',
            'ArrayOfOrderComment' => '\\ArrayType\\ArrayOfOrderComment',
            'OrderComment' => '\\StructType\\OrderComment',
            'GetUserListResult' => '\\StructType\\GetUserListResult',
            'ArrayOfuserInfo' => '\\ArrayType\\ArrayOfuserInfo',
            'userInfo' => '\\StructType\\UserInfo',
            'SetOrderCommentResult' => '\\StructType\\SetOrderCommentResult',
            'ResultSetCancelDelivery' => '\\StructType\\ResultSetCancelDelivery',
            'SetDeliveryInfoResult' => '\\StructType\\SetDeliveryInfoResult',
            'GetWarehousesResult' => '\\StructType\\GetWarehousesResult',
            'ArrayOfWarehouseInfo' => '\\ArrayType\\ArrayOfWarehouseInfo',
            'WarehouseInfo' => '\\StructType\\WarehouseInfo',
            'params' => '\\StructType\\Params',
            'TireCalcParameters' => '\\StructType\\TireCalcParameters',
            'TireCalcSize' => '\\StructType\\TireCalcSize',
            'TireCalcResult' => '\\StructType\\TireCalcResult',
            'TireCalcSpeedometerInfo' => '\\StructType\\TireCalcSpeedometerInfo',
            'getPressureSensorFilter' => '\\StructType\\GetPressureSensorFilter',
            'GetPressureSensorResult' => '\\StructType\\GetPressureSensorResult',
            'OrderReadyToWaitResult' => '\\StructType\\OrderReadyToWaitResult',
            'proposeGoodsContainer' => '\\StructType\\ProposeGoodsContainer',
            'ArrayOfproposeConsumableItem' => '\\ArrayType\\ArrayOfproposeConsumableItem',
            'proposeConsumableItem' => '\\StructType\\ProposeConsumableItem',
            'ArrayOfproposeDiskItem' => '\\ArrayType\\ArrayOfproposeDiskItem',
            'proposeDiskItem' => '\\StructType\\ProposeDiskItem',
            'ArrayOfproposeFastenerItem' => '\\ArrayType\\ArrayOfproposeFastenerItem',
            'proposeFastenerItem' => '\\StructType\\ProposeFastenerItem',
            'Result' => '\\StructType\\Result',
            'ArrayOfgood' => '\\ArrayType\\ArrayOfgood',
            'good' => '\\StructType\\Good',
            'ArrayOfgtdContainer' => '\\ArrayType\\ArrayOfgtdContainer',
            'gtdContainer' => '\\StructType\\GtdContainer',
            'movementFilter' => '\\StructType\\MovementFilter',
            'getMovementListResult' => '\\StructType\\GetMovementListResult',
            'ArrayOfmovementInfo' => '\\ArrayType\\ArrayOfmovementInfo',
            'movementInfo' => '\\StructType\\MovementInfo',
            'movementInfoContainer' => '\\StructType\\MovementInfoContainer',
            'ArrayOfMarkCodeContainer' => '\\ArrayType\\ArrayOfMarkCodeContainer',
            'MarkCodeContainer' => '\\StructType\\MarkCodeContainer',
            'getFastenerFilter' => '\\StructType\\GetFastenerFilter',
            'GetFastenerResult' => '\\StructType\\GetFastenerResult',
            'ArrayOfGetFastenerContainer' => '\\ArrayType\\ArrayOfGetFastenerContainer',
            'GetFastenerContainer' => '\\StructType\\GetFastenerContainer',
            'getAddressListFilter' => '\\StructType\\GetAddressListFilter',
            'getAddressListResult' => '\\StructType\\GetAddressListResult',
            'ArrayOfgetAddressListItem' => '\\ArrayType\\ArrayOfgetAddressListItem',
            'getAddressListItem' => '\\StructType\\GetAddressListItem',
            'GetDeliveryPeriodResult' => '\\StructType\\GetDeliveryPeriodResult',
            'ArrayOfResult.GetDeliveryPeriodItem' => '\\ArrayType\\ArrayOfResult_GetDeliveryPeriodItem',
            'Result.GetDeliveryPeriodItem' => '\\StructType\\Result_GetDeliveryPeriodItem',
            'ArrayOfResult.PeriodContainer' => '\\ArrayType\\ArrayOfResult_PeriodContainer',
            'Result.PeriodContainer' => '\\StructType\\Result_PeriodContainer',
            'SetDeliveryAddressParams' => '\\StructType\\SetDeliveryAddressParams',
            'DeliveryAddress' => '\\StructType\\DeliveryAddress',
            'SetDeliveryAddresResultContainer' => '\\StructType\\SetDeliveryAddresResultContainer',
            'ArrayOfSetDeliveryAddresResultItem' => '\\ArrayType\\ArrayOfSetDeliveryAddresResultItem',
            'SetDeliveryAddresResultItem' => '\\StructType\\SetDeliveryAddresResultItem',
            'SetOrderDeliveryParameters' => '\\StructType\\SetOrderDeliveryParameters',
            'ArrayOfSetOrderDeliveryPeriodContainer' => '\\ArrayType\\ArrayOfSetOrderDeliveryPeriodContainer',
            'SetOrderDeliveryPeriodContainer' => '\\StructType\\SetOrderDeliveryPeriodContainer',
            'SetOrderDeliveryResult' => '\\StructType\\SetOrderDeliveryResult',
            'ArrayOfSetOrderDeliveryResultItem' => '\\ArrayType\\ArrayOfSetOrderDeliveryResultItem',
            'SetOrderDeliveryResultItem' => '\\StructType\\SetOrderDeliveryResultItem',
            'ArrayOfSaleGoodContainer' => '\\ArrayType\\ArrayOfSaleGoodContainer',
            'SaleGoodContainer' => '\\StructType\\SaleGoodContainer',
            'SaleFilter' => '\\StructType\\SaleFilter',
            'ArrayOfSaleContainer' => '\\ArrayType\\ArrayOfSaleContainer',
            'SaleContainer' => '\\StructType\\SaleContainer',
            'GetConsumableFilter' => '\\StructType\\GetConsumableFilter',
            'GetConsumableResult' => '\\StructType\\GetConsumableResult',
            'ArrayOfGetConsumableResultItem' => '\\ArrayType\\ArrayOfGetConsumableResultItem',
            'GetConsumableResultItem' => '\\StructType\\GetConsumableResultItem',
            'ConsigneeCreateContainer' => '\\StructType\\ConsigneeCreateContainer',
            'ConsigneeResult' => '\\StructType\\ConsigneeResult',
            'ConsigneeListContainer' => '\\StructType\\ConsigneeListContainer',
            'ArrayOfConsigneeInfoContainer' => '\\ArrayType\\ArrayOfConsigneeInfoContainer',
            'ConsigneeInfoContainer' => '\\StructType\\ConsigneeInfoContainer',
        );
    }
}
