<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsigneeCreateContainer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsigneeCreateContainer
 * @subpackage Structs
 */
class ConsigneeCreateContainer extends AbstractStructBase
{
    /**
     * The inn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $inn;
    /**
     * The kpp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kpp;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $type;
    /**
     * Constructor method for ConsigneeCreateContainer
     * @uses ConsigneeCreateContainer::setInn()
     * @uses ConsigneeCreateContainer::setKpp()
     * @uses ConsigneeCreateContainer::setName()
     * @uses ConsigneeCreateContainer::setType()
     * @param string $inn
     * @param string $kpp
     * @param string $name
     * @param int $type
     */
    public function __construct($inn = null, $kpp = null, $name = null, $type = null)
    {
        $this
            ->setInn($inn)
            ->setKpp($kpp)
            ->setName($name)
            ->setType($type);
    }
    /**
     * Get inn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInn()
    {
        return isset($this->inn) ? $this->inn : null;
    }
    /**
     * Set inn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $inn
     * @return \StructType\ConsigneeCreateContainer
     */
    public function setInn($inn = null)
    {
        // validation for constraint: string
        if (!is_null($inn) && !is_string($inn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inn, true), gettype($inn)), __LINE__);
        }
        if (is_null($inn) || (is_array($inn) && empty($inn))) {
            unset($this->inn);
        } else {
            $this->inn = $inn;
        }
        return $this;
    }
    /**
     * Get kpp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKpp()
    {
        return isset($this->kpp) ? $this->kpp : null;
    }
    /**
     * Set kpp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kpp
     * @return \StructType\ConsigneeCreateContainer
     */
    public function setKpp($kpp = null)
    {
        // validation for constraint: string
        if (!is_null($kpp) && !is_string($kpp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kpp, true), gettype($kpp)), __LINE__);
        }
        if (is_null($kpp) || (is_array($kpp) && empty($kpp))) {
            unset($this->kpp);
        } else {
            $this->kpp = $kpp;
        }
        return $this;
    }
    /**
     * Get name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : null;
    }
    /**
     * Set name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\ConsigneeCreateContainer
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->name);
        } else {
            $this->name = $name;
        }
        return $this;
    }
    /**
     * Get type value
     * @return int|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param int $type
     * @return \StructType\ConsigneeCreateContainer
     */
    public function setType($type = null)
    {
        // validation for constraint: int
        if (!is_null($type) && !(is_int($type) || ctype_digit($type))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
}
