<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsigneeInfoContainer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsigneeInfoContainer
 * @subpackage Structs
 */
class ConsigneeInfoContainer extends AbstractStructBase
{
    /**
     * The guid
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $guid;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $id;
    /**
     * The inn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $inn;
    /**
     * The kpp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $kpp;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $type;
    /**
     * Constructor method for ConsigneeInfoContainer
     * @uses ConsigneeInfoContainer::setGuid()
     * @uses ConsigneeInfoContainer::setId()
     * @uses ConsigneeInfoContainer::setInn()
     * @uses ConsigneeInfoContainer::setKpp()
     * @uses ConsigneeInfoContainer::setName()
     * @uses ConsigneeInfoContainer::setType()
     * @param string $guid
     * @param int $id
     * @param string $inn
     * @param string $kpp
     * @param string $name
     * @param int $type
     */
    public function __construct($guid = null, $id = null, $inn = null, $kpp = null, $name = null, $type = null)
    {
        $this
            ->setGuid($guid)
            ->setId($id)
            ->setInn($inn)
            ->setKpp($kpp)
            ->setName($name)
            ->setType($type);
    }
    /**
     * Get guid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGuid()
    {
        return isset($this->guid) ? $this->guid : null;
    }
    /**
     * Set guid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $guid
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setGuid($guid = null)
    {
        // validation for constraint: string
        if (!is_null($guid) && !is_string($guid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guid, true), gettype($guid)), __LINE__);
        }
        if (is_null($guid) || (is_array($guid) && empty($guid))) {
            unset($this->guid);
        } else {
            $this->guid = $guid;
        }
        return $this;
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get inn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInn()
    {
        return isset($this->inn) ? $this->inn : null;
    }
    /**
     * Set inn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $inn
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setInn($inn = null)
    {
        // validation for constraint: string
        if (!is_null($inn) && !is_string($inn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inn, true), gettype($inn)), __LINE__);
        }
        if (is_null($inn) || (is_array($inn) && empty($inn))) {
            unset($this->inn);
        } else {
            $this->inn = $inn;
        }
        return $this;
    }
    /**
     * Get kpp value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKpp()
    {
        return isset($this->kpp) ? $this->kpp : null;
    }
    /**
     * Set kpp value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kpp
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setKpp($kpp = null)
    {
        // validation for constraint: string
        if (!is_null($kpp) && !is_string($kpp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kpp, true), gettype($kpp)), __LINE__);
        }
        if (is_null($kpp) || (is_array($kpp) && empty($kpp))) {
            unset($this->kpp);
        } else {
            $this->kpp = $kpp;
        }
        return $this;
    }
    /**
     * Get name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : null;
    }
    /**
     * Set name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->name);
        } else {
            $this->name = $name;
        }
        return $this;
    }
    /**
     * Get type value
     * @return int|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param int $type
     * @return \StructType\ConsigneeInfoContainer
     */
    public function setType($type = null)
    {
        // validation for constraint: int
        if (!is_null($type) && !(is_int($type) || ctype_digit($type))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
}
