<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsigneeListContainer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsigneeListContainer
 * @subpackage Structs
 */
class ConsigneeListContainer extends ClientServiceResult
{
    /**
     * The Consignees
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfConsigneeInfoContainer
     */
    public $Consignees;
    /**
     * Constructor method for ConsigneeListContainer
     * @uses ConsigneeListContainer::setConsignees()
     * @param \ArrayType\ArrayOfConsigneeInfoContainer $consignees
     */
    public function __construct(\ArrayType\ArrayOfConsigneeInfoContainer $consignees = null)
    {
        $this
            ->setConsignees($consignees);
    }
    /**
     * Get Consignees value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfConsigneeInfoContainer|null
     */
    public function getConsignees()
    {
        return isset($this->Consignees) ? $this->Consignees : null;
    }
    /**
     * Set Consignees value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfConsigneeInfoContainer $consignees
     * @return \StructType\ConsigneeListContainer
     */
    public function setConsignees(\ArrayType\ArrayOfConsigneeInfoContainer $consignees = null)
    {
        if (is_null($consignees) || (is_array($consignees) && empty($consignees))) {
            unset($this->Consignees);
        } else {
            $this->Consignees = $consignees;
        }
        return $this;
    }
}
