<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateOrderResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateOrderResult
 * @subpackage Structs
 */
class CreateOrderResult extends AbstractStructBase
{
    /**
     * The URL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $URL;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The error_product_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfOrderProductError
     */
    public $error_product_list;
    /**
     * The goods
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGoods
     */
    public $goods;
    /**
     * The orderNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orderNumber;
    /**
     * The success
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $success;
    /**
     * Constructor method for CreateOrderResult
     * @uses CreateOrderResult::setURL()
     * @uses CreateOrderResult::setError()
     * @uses CreateOrderResult::setError_product_list()
     * @uses CreateOrderResult::setGoods()
     * @uses CreateOrderResult::setOrderNumber()
     * @uses CreateOrderResult::setSuccess()
     * @param string $uRL
     * @param \StructType\Error $error
     * @param \ArrayType\ArrayOfOrderProductError $error_product_list
     * @param \ArrayType\ArrayOfGoods $goods
     * @param string $orderNumber
     * @param bool $success
     */
    public function __construct($uRL = null, \StructType\Error $error = null, \ArrayType\ArrayOfOrderProductError $error_product_list = null, \ArrayType\ArrayOfGoods $goods = null, $orderNumber = null, $success = null)
    {
        $this
            ->setURL($uRL)
            ->setError($error)
            ->setError_product_list($error_product_list)
            ->setGoods($goods)
            ->setOrderNumber($orderNumber)
            ->setSuccess($success);
    }
    /**
     * Get URL value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getURL()
    {
        return isset($this->URL) ? $this->URL : null;
    }
    /**
     * Set URL value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uRL
     * @return \StructType\CreateOrderResult
     */
    public function setURL($uRL = null)
    {
        // validation for constraint: string
        if (!is_null($uRL) && !is_string($uRL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uRL, true), gettype($uRL)), __LINE__);
        }
        if (is_null($uRL) || (is_array($uRL) && empty($uRL))) {
            unset($this->URL);
        } else {
            $this->URL = $uRL;
        }
        return $this;
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\CreateOrderResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get error_product_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfOrderProductError|null
     */
    public function getError_product_list()
    {
        return isset($this->error_product_list) ? $this->error_product_list : null;
    }
    /**
     * Set error_product_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfOrderProductError $error_product_list
     * @return \StructType\CreateOrderResult
     */
    public function setError_product_list(\ArrayType\ArrayOfOrderProductError $error_product_list = null)
    {
        if (is_null($error_product_list) || (is_array($error_product_list) && empty($error_product_list))) {
            unset($this->error_product_list);
        } else {
            $this->error_product_list = $error_product_list;
        }
        return $this;
    }
    /**
     * Get goods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGoods|null
     */
    public function getGoods()
    {
        return isset($this->goods) ? $this->goods : null;
    }
    /**
     * Set goods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGoods $goods
     * @return \StructType\CreateOrderResult
     */
    public function setGoods(\ArrayType\ArrayOfGoods $goods = null)
    {
        if (is_null($goods) || (is_array($goods) && empty($goods))) {
            unset($this->goods);
        } else {
            $this->goods = $goods;
        }
        return $this;
    }
    /**
     * Get orderNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrderNumber()
    {
        return isset($this->orderNumber) ? $this->orderNumber : null;
    }
    /**
     * Set orderNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orderNumber
     * @return \StructType\CreateOrderResult
     */
    public function setOrderNumber($orderNumber = null)
    {
        // validation for constraint: string
        if (!is_null($orderNumber) && !is_string($orderNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orderNumber, true), gettype($orderNumber)), __LINE__);
        }
        if (is_null($orderNumber) || (is_array($orderNumber) && empty($orderNumber))) {
            unset($this->orderNumber);
        } else {
            $this->orderNumber = $orderNumber;
        }
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\CreateOrderResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
}
