<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeleteConsignee StructType
 * @subpackage Structs
 */
class DeleteConsignee extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $login;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $password;
    /**
     * The consigneeId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $consigneeId;
    /**
     * Constructor method for DeleteConsignee
     * @uses DeleteConsignee::setLogin()
     * @uses DeleteConsignee::setPassword()
     * @uses DeleteConsignee::setConsigneeId()
     * @param string $login
     * @param string $password
     * @param int $consigneeId
     */
    public function __construct($login = null, $password = null, $consigneeId = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setConsigneeId($consigneeId);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $login
     * @return \StructType\DeleteConsignee
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($login, true), gettype($login)), __LINE__);
        }
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->password) ? $this->password : null;
    }
    /**
     * Set password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \StructType\DeleteConsignee
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->password);
        } else {
            $this->password = $password;
        }
        return $this;
    }
    /**
     * Get consigneeId value
     * @return int|null
     */
    public function getConsigneeId()
    {
        return $this->consigneeId;
    }
    /**
     * Set consigneeId value
     * @param int $consigneeId
     * @return \StructType\DeleteConsignee
     */
    public function setConsigneeId($consigneeId = null)
    {
        // validation for constraint: int
        if (!is_null($consigneeId) && !(is_int($consigneeId) || ctype_digit($consigneeId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($consigneeId, true), gettype($consigneeId)), __LINE__);
        }
        $this->consigneeId = $consigneeId;
        return $this;
    }
}
