<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FindOrderCommentFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FindOrderCommentFilter
 * @subpackage Structs
 */
class FindOrderCommentFilter extends AbstractStructBase
{
    /**
     * The createDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $createDate;
    /**
     * The orderNumbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $orderNumbers;
    /**
     * The userIDs
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $userIDs;
    /**
     * Constructor method for FindOrderCommentFilter
     * @uses FindOrderCommentFilter::setCreateDate()
     * @uses FindOrderCommentFilter::setOrderNumbers()
     * @uses FindOrderCommentFilter::setUserIDs()
     * @param string $createDate
     * @param \ArrayType\ArrayOfstring $orderNumbers
     * @param \ArrayType\ArrayOfint $userIDs
     */
    public function __construct($createDate = null, \ArrayType\ArrayOfstring $orderNumbers = null, \ArrayType\ArrayOfint $userIDs = null)
    {
        $this
            ->setCreateDate($createDate)
            ->setOrderNumbers($orderNumbers)
            ->setUserIDs($userIDs);
    }
    /**
     * Get createDate value
     * @return string|null
     */
    public function getCreateDate()
    {
        return $this->createDate;
    }
    /**
     * Set createDate value
     * @param string $createDate
     * @return \StructType\FindOrderCommentFilter
     */
    public function setCreateDate($createDate = null)
    {
        // validation for constraint: string
        if (!is_null($createDate) && !is_string($createDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createDate, true), gettype($createDate)), __LINE__);
        }
        $this->createDate = $createDate;
        return $this;
    }
    /**
     * Get orderNumbers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getOrderNumbers()
    {
        return isset($this->orderNumbers) ? $this->orderNumbers : null;
    }
    /**
     * Set orderNumbers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $orderNumbers
     * @return \StructType\FindOrderCommentFilter
     */
    public function setOrderNumbers(\ArrayType\ArrayOfstring $orderNumbers = null)
    {
        if (is_null($orderNumbers) || (is_array($orderNumbers) && empty($orderNumbers))) {
            unset($this->orderNumbers);
        } else {
            $this->orderNumbers = $orderNumbers;
        }
        return $this;
    }
    /**
     * Get userIDs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getUserIDs()
    {
        return isset($this->userIDs) ? $this->userIDs : null;
    }
    /**
     * Set userIDs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $userIDs
     * @return \StructType\FindOrderCommentFilter
     */
    public function setUserIDs(\ArrayType\ArrayOfint $userIDs = null)
    {
        if (is_null($userIDs) || (is_array($userIDs) && empty($userIDs))) {
            unset($this->userIDs);
        } else {
            $this->userIDs = $userIDs;
        }
        return $this;
    }
}
