<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetConsumableFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetConsumableFilter
 * @subpackage Structs
 */
class GetConsumableFilter extends AbstractStructBase
{
    /**
     * The applicability_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $applicability_list;
    /**
     * The brand_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $brand_list;
    /**
     * The code_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $code_list;
    /**
     * The color_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $color_list;
    /**
     * The material_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $material_list;
    /**
     * The sort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sort;
    /**
     * The type
     * @var int
     */
    public $type;
    /**
     * The weight_max
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $weight_max;
    /**
     * The weight_min
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $weight_min;
    /**
     * The wrh_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $wrh_list;
    /**
     * The include_paid_delivery
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $include_paid_delivery;
    /**
     * Constructor method for GetConsumableFilter
     * @uses GetConsumableFilter::setApplicability_list()
     * @uses GetConsumableFilter::setBrand_list()
     * @uses GetConsumableFilter::setCode_list()
     * @uses GetConsumableFilter::setColor_list()
     * @uses GetConsumableFilter::setMaterial_list()
     * @uses GetConsumableFilter::setSort()
     * @uses GetConsumableFilter::setType()
     * @uses GetConsumableFilter::setWeight_max()
     * @uses GetConsumableFilter::setWeight_min()
     * @uses GetConsumableFilter::setWrh_list()
     * @uses GetConsumableFilter::setInclude_paid_delivery()
     * @param \ArrayType\ArrayOfint $applicability_list
     * @param \ArrayType\ArrayOfstring $brand_list
     * @param \ArrayType\ArrayOfstring $code_list
     * @param \ArrayType\ArrayOfstring $color_list
     * @param \ArrayType\ArrayOfstring $material_list
     * @param int $sort
     * @param int $type
     * @param int $weight_max
     * @param int $weight_min
     * @param \ArrayType\ArrayOfint $wrh_list
     * @param bool $include_paid_delivery
     */
    public function __construct(\ArrayType\ArrayOfint $applicability_list = null, \ArrayType\ArrayOfstring $brand_list = null, \ArrayType\ArrayOfstring $code_list = null, \ArrayType\ArrayOfstring $color_list = null, \ArrayType\ArrayOfstring $material_list = null, $sort = null, $type = null, $weight_max = null, $weight_min = null, \ArrayType\ArrayOfint $wrh_list = null, $include_paid_delivery = null)
    {
        $this
            ->setApplicability_list($applicability_list)
            ->setBrand_list($brand_list)
            ->setCode_list($code_list)
            ->setColor_list($color_list)
            ->setMaterial_list($material_list)
            ->setSort($sort)
            ->setType($type)
            ->setWeight_max($weight_max)
            ->setWeight_min($weight_min)
            ->setWrh_list($wrh_list)
            ->setInclude_paid_delivery($include_paid_delivery);
    }
    /**
     * Get applicability_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getApplicability_list()
    {
        return isset($this->applicability_list) ? $this->applicability_list : null;
    }
    /**
     * Set applicability_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $applicability_list
     * @return \StructType\GetConsumableFilter
     */
    public function setApplicability_list(\ArrayType\ArrayOfint $applicability_list = null)
    {
        if (is_null($applicability_list) || (is_array($applicability_list) && empty($applicability_list))) {
            unset($this->applicability_list);
        } else {
            $this->applicability_list = $applicability_list;
        }
        return $this;
    }
    /**
     * Get brand_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getBrand_list()
    {
        return isset($this->brand_list) ? $this->brand_list : null;
    }
    /**
     * Set brand_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $brand_list
     * @return \StructType\GetConsumableFilter
     */
    public function setBrand_list(\ArrayType\ArrayOfstring $brand_list = null)
    {
        if (is_null($brand_list) || (is_array($brand_list) && empty($brand_list))) {
            unset($this->brand_list);
        } else {
            $this->brand_list = $brand_list;
        }
        return $this;
    }
    /**
     * Get code_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getCode_list()
    {
        return isset($this->code_list) ? $this->code_list : null;
    }
    /**
     * Set code_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $code_list
     * @return \StructType\GetConsumableFilter
     */
    public function setCode_list(\ArrayType\ArrayOfstring $code_list = null)
    {
        if (is_null($code_list) || (is_array($code_list) && empty($code_list))) {
            unset($this->code_list);
        } else {
            $this->code_list = $code_list;
        }
        return $this;
    }
    /**
     * Get color_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getColor_list()
    {
        return isset($this->color_list) ? $this->color_list : null;
    }
    /**
     * Set color_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $color_list
     * @return \StructType\GetConsumableFilter
     */
    public function setColor_list(\ArrayType\ArrayOfstring $color_list = null)
    {
        if (is_null($color_list) || (is_array($color_list) && empty($color_list))) {
            unset($this->color_list);
        } else {
            $this->color_list = $color_list;
        }
        return $this;
    }
    /**
     * Get material_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getMaterial_list()
    {
        return isset($this->material_list) ? $this->material_list : null;
    }
    /**
     * Set material_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $material_list
     * @return \StructType\GetConsumableFilter
     */
    public function setMaterial_list(\ArrayType\ArrayOfstring $material_list = null)
    {
        if (is_null($material_list) || (is_array($material_list) && empty($material_list))) {
            unset($this->material_list);
        } else {
            $this->material_list = $material_list;
        }
        return $this;
    }
    /**
     * Get sort value
     * @return int|null
     */
    public function getSort()
    {
        return $this->sort;
    }
    /**
     * Set sort value
     * @param int $sort
     * @return \StructType\GetConsumableFilter
     */
    public function setSort($sort = null)
    {
        // validation for constraint: int
        if (!is_null($sort) && !(is_int($sort) || ctype_digit($sort))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sort, true), gettype($sort)), __LINE__);
        }
        $this->sort = $sort;
        return $this;
    }
    /**
     * Get type value
     * @return int|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param int $type
     * @return \StructType\GetConsumableFilter
     */
    public function setType($type = null)
    {
        // validation for constraint: int
        if (!is_null($type) && !(is_int($type) || ctype_digit($type))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get weight_max value
     * @return int|null
     */
    public function getWeight_max()
    {
        return $this->weight_max;
    }
    /**
     * Set weight_max value
     * @param int $weight_max
     * @return \StructType\GetConsumableFilter
     */
    public function setWeight_max($weight_max = null)
    {
        // validation for constraint: int
        if (!is_null($weight_max) && !(is_int($weight_max) || ctype_digit($weight_max))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($weight_max, true), gettype($weight_max)), __LINE__);
        }
        $this->weight_max = $weight_max;
        return $this;
    }
    /**
     * Get weight_min value
     * @return int|null
     */
    public function getWeight_min()
    {
        return $this->weight_min;
    }
    /**
     * Set weight_min value
     * @param int $weight_min
     * @return \StructType\GetConsumableFilter
     */
    public function setWeight_min($weight_min = null)
    {
        // validation for constraint: int
        if (!is_null($weight_min) && !(is_int($weight_min) || ctype_digit($weight_min))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($weight_min, true), gettype($weight_min)), __LINE__);
        }
        $this->weight_min = $weight_min;
        return $this;
    }
    /**
     * Get wrh_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getWrh_list()
    {
        return isset($this->wrh_list) ? $this->wrh_list : null;
    }
    /**
     * Set wrh_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $wrh_list
     * @return \StructType\GetConsumableFilter
     */
    public function setWrh_list(\ArrayType\ArrayOfint $wrh_list = null)
    {
        if (is_null($wrh_list) || (is_array($wrh_list) && empty($wrh_list))) {
            unset($this->wrh_list);
        } else {
            $this->wrh_list = $wrh_list;
        }
        return $this;
    }
    /**
     * Get include_paid_delivery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getInclude_paid_delivery()
    {
        return isset($this->include_paid_delivery) ? $this->include_paid_delivery : null;
    }
    /**
     * Set include_paid_delivery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $include_paid_delivery
     * @return \StructType\GetConsumableFilter
     */
    public function setInclude_paid_delivery($include_paid_delivery = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_paid_delivery) && !is_bool($include_paid_delivery)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($include_paid_delivery, true), gettype($include_paid_delivery)), __LINE__);
        }
        if (is_null($include_paid_delivery) || (is_array($include_paid_delivery) && empty($include_paid_delivery))) {
            unset($this->include_paid_delivery);
        } else {
            $this->include_paid_delivery = $include_paid_delivery;
        }
        return $this;
    }
}
