<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetConsumableResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetConsumableResult
 * @subpackage Structs
 */
class GetConsumableResult extends ClientServiceResult
{
    /**
     * The currencyRate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CurrencyRate
     */
    public $currencyRate;
    /**
     * The getConsumableResultItems
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGetConsumableResultItem
     */
    public $getConsumableResultItems;
    /**
     * The sort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sort;
    /**
     * The totalPages
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $totalPages;
    /**
     * The warehouseLogistics
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWarehouseLogistic
     */
    public $warehouseLogistics;
    /**
     * Constructor method for GetConsumableResult
     * @uses GetConsumableResult::setCurrencyRate()
     * @uses GetConsumableResult::setGetConsumableResultItems()
     * @uses GetConsumableResult::setSort()
     * @uses GetConsumableResult::setTotalPages()
     * @uses GetConsumableResult::setWarehouseLogistics()
     * @param \StructType\CurrencyRate $currencyRate
     * @param \ArrayType\ArrayOfGetConsumableResultItem $getConsumableResultItems
     * @param int $sort
     * @param int $totalPages
     * @param \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics
     */
    public function __construct(\StructType\CurrencyRate $currencyRate = null, \ArrayType\ArrayOfGetConsumableResultItem $getConsumableResultItems = null, $sort = null, $totalPages = null, \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics = null)
    {
        $this
            ->setCurrencyRate($currencyRate)
            ->setGetConsumableResultItems($getConsumableResultItems)
            ->setSort($sort)
            ->setTotalPages($totalPages)
            ->setWarehouseLogistics($warehouseLogistics);
    }
    /**
     * Get currencyRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CurrencyRate|null
     */
    public function getCurrencyRate()
    {
        return isset($this->currencyRate) ? $this->currencyRate : null;
    }
    /**
     * Set currencyRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CurrencyRate $currencyRate
     * @return \StructType\GetConsumableResult
     */
    public function setCurrencyRate(\StructType\CurrencyRate $currencyRate = null)
    {
        if (is_null($currencyRate) || (is_array($currencyRate) && empty($currencyRate))) {
            unset($this->currencyRate);
        } else {
            $this->currencyRate = $currencyRate;
        }
        return $this;
    }
    /**
     * Get getConsumableResultItems value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGetConsumableResultItem|null
     */
    public function getGetConsumableResultItems()
    {
        return isset($this->getConsumableResultItems) ? $this->getConsumableResultItems : null;
    }
    /**
     * Set getConsumableResultItems value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGetConsumableResultItem $getConsumableResultItems
     * @return \StructType\GetConsumableResult
     */
    public function setGetConsumableResultItems(\ArrayType\ArrayOfGetConsumableResultItem $getConsumableResultItems = null)
    {
        if (is_null($getConsumableResultItems) || (is_array($getConsumableResultItems) && empty($getConsumableResultItems))) {
            unset($this->getConsumableResultItems);
        } else {
            $this->getConsumableResultItems = $getConsumableResultItems;
        }
        return $this;
    }
    /**
     * Get sort value
     * @return int|null
     */
    public function getSort()
    {
        return $this->sort;
    }
    /**
     * Set sort value
     * @param int $sort
     * @return \StructType\GetConsumableResult
     */
    public function setSort($sort = null)
    {
        // validation for constraint: int
        if (!is_null($sort) && !(is_int($sort) || ctype_digit($sort))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sort, true), gettype($sort)), __LINE__);
        }
        $this->sort = $sort;
        return $this;
    }
    /**
     * Get totalPages value
     * @return int|null
     */
    public function getTotalPages()
    {
        return $this->totalPages;
    }
    /**
     * Set totalPages value
     * @param int $totalPages
     * @return \StructType\GetConsumableResult
     */
    public function setTotalPages($totalPages = null)
    {
        // validation for constraint: int
        if (!is_null($totalPages) && !(is_int($totalPages) || ctype_digit($totalPages))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($totalPages, true), gettype($totalPages)), __LINE__);
        }
        $this->totalPages = $totalPages;
        return $this;
    }
    /**
     * Get warehouseLogistics value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWarehouseLogistic|null
     */
    public function getWarehouseLogistics()
    {
        return isset($this->warehouseLogistics) ? $this->warehouseLogistics : null;
    }
    /**
     * Set warehouseLogistics value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics
     * @return \StructType\GetConsumableResult
     */
    public function setWarehouseLogistics(\ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics = null)
    {
        if (is_null($warehouseLogistics) || (is_array($warehouseLogistics) && empty($warehouseLogistics))) {
            unset($this->warehouseLogistics);
        } else {
            $this->warehouseLogistics = $warehouseLogistics;
        }
        return $this;
    }
}
