<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetConsumableResultItem StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetConsumableResultItem
 * @subpackage Structs
 */
class GetConsumableResultItem extends AbstractStructBase
{
    /**
     * The applicability
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $applicability;
    /**
     * The brand
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $brand;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $code;
    /**
     * The color
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $color;
    /**
     * The img_big_my
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_big_my;
    /**
     * The img_big_pish
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_big_pish;
    /**
     * The img_small
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_small;
    /**
     * The material
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $material;
    /**
     * The model
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $model;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $type;
    /**
     * The weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $weight;
    /**
     * The whpr
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfwh_price_rest
     */
    public $whpr;
    /**
     * Constructor method for GetConsumableResultItem
     * @uses GetConsumableResultItem::setApplicability()
     * @uses GetConsumableResultItem::setBrand()
     * @uses GetConsumableResultItem::setCode()
     * @uses GetConsumableResultItem::setColor()
     * @uses GetConsumableResultItem::setImg_big_my()
     * @uses GetConsumableResultItem::setImg_big_pish()
     * @uses GetConsumableResultItem::setImg_small()
     * @uses GetConsumableResultItem::setMaterial()
     * @uses GetConsumableResultItem::setModel()
     * @uses GetConsumableResultItem::setName()
     * @uses GetConsumableResultItem::setType()
     * @uses GetConsumableResultItem::setWeight()
     * @uses GetConsumableResultItem::setWhpr()
     * @param int $applicability
     * @param string $brand
     * @param string $code
     * @param string $color
     * @param string $img_big_my
     * @param string $img_big_pish
     * @param string $img_small
     * @param string $material
     * @param string $model
     * @param string $name
     * @param int $type
     * @param int $weight
     * @param \ArrayType\ArrayOfwh_price_rest $whpr
     */
    public function __construct($applicability = null, $brand = null, $code = null, $color = null, $img_big_my = null, $img_big_pish = null, $img_small = null, $material = null, $model = null, $name = null, $type = null, $weight = null, \ArrayType\ArrayOfwh_price_rest $whpr = null)
    {
        $this
            ->setApplicability($applicability)
            ->setBrand($brand)
            ->setCode($code)
            ->setColor($color)
            ->setImg_big_my($img_big_my)
            ->setImg_big_pish($img_big_pish)
            ->setImg_small($img_small)
            ->setMaterial($material)
            ->setModel($model)
            ->setName($name)
            ->setType($type)
            ->setWeight($weight)
            ->setWhpr($whpr);
    }
    /**
     * Get applicability value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getApplicability()
    {
        return isset($this->applicability) ? $this->applicability : null;
    }
    /**
     * Set applicability value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $applicability
     * @return \StructType\GetConsumableResultItem
     */
    public function setApplicability($applicability = null)
    {
        // validation for constraint: int
        if (!is_null($applicability) && !(is_int($applicability) || ctype_digit($applicability))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($applicability, true), gettype($applicability)), __LINE__);
        }
        if (is_null($applicability) || (is_array($applicability) && empty($applicability))) {
            unset($this->applicability);
        } else {
            $this->applicability = $applicability;
        }
        return $this;
    }
    /**
     * Get brand value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : null;
    }
    /**
     * Set brand value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $brand
     * @return \StructType\GetConsumableResultItem
     */
    public function setBrand($brand = null)
    {
        // validation for constraint: string
        if (!is_null($brand) && !is_string($brand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brand, true), gettype($brand)), __LINE__);
        }
        if (is_null($brand) || (is_array($brand) && empty($brand))) {
            unset($this->brand);
        } else {
            $this->brand = $brand;
        }
        return $this;
    }
    /**
     * Get code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCode()
    {
        return isset($this->code) ? $this->code : null;
    }
    /**
     * Set code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $code
     * @return \StructType\GetConsumableResultItem
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->code);
        } else {
            $this->code = $code;
        }
        return $this;
    }
    /**
     * Get color value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getColor()
    {
        return isset($this->color) ? $this->color : null;
    }
    /**
     * Set color value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $color
     * @return \StructType\GetConsumableResultItem
     */
    public function setColor($color = null)
    {
        // validation for constraint: string
        if (!is_null($color) && !is_string($color)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($color, true), gettype($color)), __LINE__);
        }
        if (is_null($color) || (is_array($color) && empty($color))) {
            unset($this->color);
        } else {
            $this->color = $color;
        }
        return $this;
    }
    /**
     * Get img_big_my value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_big_my()
    {
        return isset($this->img_big_my) ? $this->img_big_my : null;
    }
    /**
     * Set img_big_my value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_big_my
     * @return \StructType\GetConsumableResultItem
     */
    public function setImg_big_my($img_big_my = null)
    {
        // validation for constraint: string
        if (!is_null($img_big_my) && !is_string($img_big_my)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_big_my, true), gettype($img_big_my)), __LINE__);
        }
        if (is_null($img_big_my) || (is_array($img_big_my) && empty($img_big_my))) {
            unset($this->img_big_my);
        } else {
            $this->img_big_my = $img_big_my;
        }
        return $this;
    }
    /**
     * Get img_big_pish value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_big_pish()
    {
        return isset($this->img_big_pish) ? $this->img_big_pish : null;
    }
    /**
     * Set img_big_pish value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_big_pish
     * @return \StructType\GetConsumableResultItem
     */
    public function setImg_big_pish($img_big_pish = null)
    {
        // validation for constraint: string
        if (!is_null($img_big_pish) && !is_string($img_big_pish)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_big_pish, true), gettype($img_big_pish)), __LINE__);
        }
        if (is_null($img_big_pish) || (is_array($img_big_pish) && empty($img_big_pish))) {
            unset($this->img_big_pish);
        } else {
            $this->img_big_pish = $img_big_pish;
        }
        return $this;
    }
    /**
     * Get img_small value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_small()
    {
        return isset($this->img_small) ? $this->img_small : null;
    }
    /**
     * Set img_small value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_small
     * @return \StructType\GetConsumableResultItem
     */
    public function setImg_small($img_small = null)
    {
        // validation for constraint: string
        if (!is_null($img_small) && !is_string($img_small)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_small, true), gettype($img_small)), __LINE__);
        }
        if (is_null($img_small) || (is_array($img_small) && empty($img_small))) {
            unset($this->img_small);
        } else {
            $this->img_small = $img_small;
        }
        return $this;
    }
    /**
     * Get material value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMaterial()
    {
        return isset($this->material) ? $this->material : null;
    }
    /**
     * Set material value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $material
     * @return \StructType\GetConsumableResultItem
     */
    public function setMaterial($material = null)
    {
        // validation for constraint: string
        if (!is_null($material) && !is_string($material)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($material, true), gettype($material)), __LINE__);
        }
        if (is_null($material) || (is_array($material) && empty($material))) {
            unset($this->material);
        } else {
            $this->material = $material;
        }
        return $this;
    }
    /**
     * Get model value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getModel()
    {
        return isset($this->model) ? $this->model : null;
    }
    /**
     * Set model value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $model
     * @return \StructType\GetConsumableResultItem
     */
    public function setModel($model = null)
    {
        // validation for constraint: string
        if (!is_null($model) && !is_string($model)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model, true), gettype($model)), __LINE__);
        }
        if (is_null($model) || (is_array($model) && empty($model))) {
            unset($this->model);
        } else {
            $this->model = $model;
        }
        return $this;
    }
    /**
     * Get name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : null;
    }
    /**
     * Set name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\GetConsumableResultItem
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->name);
        } else {
            $this->name = $name;
        }
        return $this;
    }
    /**
     * Get type value
     * @return int|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param int $type
     * @return \StructType\GetConsumableResultItem
     */
    public function setType($type = null)
    {
        // validation for constraint: int
        if (!is_null($type) && !(is_int($type) || ctype_digit($type))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get weight value
     * @return int|null
     */
    public function getWeight()
    {
        return $this->weight;
    }
    /**
     * Set weight value
     * @param int $weight
     * @return \StructType\GetConsumableResultItem
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: int
        if (!is_null($weight) && !(is_int($weight) || ctype_digit($weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->weight = $weight;
        return $this;
    }
    /**
     * Get whpr value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfwh_price_rest|null
     */
    public function getWhpr()
    {
        return isset($this->whpr) ? $this->whpr : null;
    }
    /**
     * Set whpr value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfwh_price_rest $whpr
     * @return \StructType\GetConsumableResultItem
     */
    public function setWhpr(\ArrayType\ArrayOfwh_price_rest $whpr = null)
    {
        if (is_null($whpr) || (is_array($whpr) && empty($whpr))) {
            unset($this->whpr);
        } else {
            $this->whpr = $whpr;
        }
        return $this;
    }
}
