<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getFastenerFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:getFastenerFilter
 * @subpackage Structs
 */
class GetFastenerFilter extends AbstractStructBase
{
    /**
     * The brand_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $brand_list;
    /**
     * The code_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $code_list;
    /**
     * The sort
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $sort;
    /**
     * The subtype_id_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $subtype_id_list;
    /**
     * The include_paid_delivery
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $include_paid_delivery;
    /**
     * Constructor method for getFastenerFilter
     * @uses GetFastenerFilter::setBrand_list()
     * @uses GetFastenerFilter::setCode_list()
     * @uses GetFastenerFilter::setSort()
     * @uses GetFastenerFilter::setSubtype_id_list()
     * @uses GetFastenerFilter::setInclude_paid_delivery()
     * @param \ArrayType\ArrayOfstring $brand_list
     * @param \ArrayType\ArrayOfstring $code_list
     * @param int $sort
     * @param \ArrayType\ArrayOfint $subtype_id_list
     * @param bool $include_paid_delivery
     */
    public function __construct(\ArrayType\ArrayOfstring $brand_list = null, \ArrayType\ArrayOfstring $code_list = null, $sort = null, \ArrayType\ArrayOfint $subtype_id_list = null, $include_paid_delivery = null)
    {
        $this
            ->setBrand_list($brand_list)
            ->setCode_list($code_list)
            ->setSort($sort)
            ->setSubtype_id_list($subtype_id_list)
            ->setInclude_paid_delivery($include_paid_delivery);
    }
    /**
     * Get brand_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getBrand_list()
    {
        return isset($this->brand_list) ? $this->brand_list : null;
    }
    /**
     * Set brand_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $brand_list
     * @return \StructType\GetFastenerFilter
     */
    public function setBrand_list(\ArrayType\ArrayOfstring $brand_list = null)
    {
        if (is_null($brand_list) || (is_array($brand_list) && empty($brand_list))) {
            unset($this->brand_list);
        } else {
            $this->brand_list = $brand_list;
        }
        return $this;
    }
    /**
     * Get code_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getCode_list()
    {
        return isset($this->code_list) ? $this->code_list : null;
    }
    /**
     * Set code_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $code_list
     * @return \StructType\GetFastenerFilter
     */
    public function setCode_list(\ArrayType\ArrayOfstring $code_list = null)
    {
        if (is_null($code_list) || (is_array($code_list) && empty($code_list))) {
            unset($this->code_list);
        } else {
            $this->code_list = $code_list;
        }
        return $this;
    }
    /**
     * Get sort value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSort()
    {
        return isset($this->sort) ? $this->sort : null;
    }
    /**
     * Set sort value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sort
     * @return \StructType\GetFastenerFilter
     */
    public function setSort($sort = null)
    {
        // validation for constraint: int
        if (!is_null($sort) && !(is_int($sort) || ctype_digit($sort))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sort, true), gettype($sort)), __LINE__);
        }
        if (is_null($sort) || (is_array($sort) && empty($sort))) {
            unset($this->sort);
        } else {
            $this->sort = $sort;
        }
        return $this;
    }
    /**
     * Get subtype_id_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getSubtype_id_list()
    {
        return isset($this->subtype_id_list) ? $this->subtype_id_list : null;
    }
    /**
     * Set subtype_id_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $subtype_id_list
     * @return \StructType\GetFastenerFilter
     */
    public function setSubtype_id_list(\ArrayType\ArrayOfint $subtype_id_list = null)
    {
        if (is_null($subtype_id_list) || (is_array($subtype_id_list) && empty($subtype_id_list))) {
            unset($this->subtype_id_list);
        } else {
            $this->subtype_id_list = $subtype_id_list;
        }
        return $this;
    }
    /**
     * Get include_paid_delivery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getInclude_paid_delivery()
    {
        return isset($this->include_paid_delivery) ? $this->include_paid_delivery : null;
    }
    /**
     * Set include_paid_delivery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $include_paid_delivery
     * @return \StructType\GetFastenerFilter
     */
    public function setInclude_paid_delivery($include_paid_delivery = null)
    {
        // validation for constraint: boolean
        if (!is_null($include_paid_delivery) && !is_bool($include_paid_delivery)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($include_paid_delivery, true), gettype($include_paid_delivery)), __LINE__);
        }
        if (is_null($include_paid_delivery) || (is_array($include_paid_delivery) && empty($include_paid_delivery))) {
            unset($this->include_paid_delivery);
        } else {
            $this->include_paid_delivery = $include_paid_delivery;
        }
        return $this;
    }
}
