<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetGoodsByCarFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetGoodsByCarFilter
 * @subpackage Structs
 */
class GetGoodsByCarFilter extends AbstractStructBase
{
    /**
     * The marka
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $marka;
    /**
     * The model
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $model;
    /**
     * The modification
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $modification;
    /**
     * The podbor_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $podbor_type;
    /**
     * The season_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $season_list;
    /**
     * The thorn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $thorn;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $type;
    /**
     * The wrh_list
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfint
     */
    public $wrh_list;
    /**
     * The year_beg
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $year_beg;
    /**
     * The year_end
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $year_end;
    /**
     * Constructor method for GetGoodsByCarFilter
     * @uses GetGoodsByCarFilter::setMarka()
     * @uses GetGoodsByCarFilter::setModel()
     * @uses GetGoodsByCarFilter::setModification()
     * @uses GetGoodsByCarFilter::setPodbor_type()
     * @uses GetGoodsByCarFilter::setSeason_list()
     * @uses GetGoodsByCarFilter::setThorn()
     * @uses GetGoodsByCarFilter::setType()
     * @uses GetGoodsByCarFilter::setWrh_list()
     * @uses GetGoodsByCarFilter::setYear_beg()
     * @uses GetGoodsByCarFilter::setYear_end()
     * @param string $marka
     * @param string $model
     * @param string $modification
     * @param \ArrayType\ArrayOfint $podbor_type
     * @param \ArrayType\ArrayOfstring $season_list
     * @param bool $thorn
     * @param \ArrayType\ArrayOfstring $type
     * @param \ArrayType\ArrayOfint $wrh_list
     * @param string $year_beg
     * @param string $year_end
     */
    public function __construct($marka = null, $model = null, $modification = null, \ArrayType\ArrayOfint $podbor_type = null, \ArrayType\ArrayOfstring $season_list = null, $thorn = null, \ArrayType\ArrayOfstring $type = null, \ArrayType\ArrayOfint $wrh_list = null, $year_beg = null, $year_end = null)
    {
        $this
            ->setMarka($marka)
            ->setModel($model)
            ->setModification($modification)
            ->setPodbor_type($podbor_type)
            ->setSeason_list($season_list)
            ->setThorn($thorn)
            ->setType($type)
            ->setWrh_list($wrh_list)
            ->setYear_beg($year_beg)
            ->setYear_end($year_end);
    }
    /**
     * Get marka value
     * @return string|null
     */
    public function getMarka()
    {
        return $this->marka;
    }
    /**
     * Set marka value
     * @param string $marka
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setMarka($marka = null)
    {
        // validation for constraint: string
        if (!is_null($marka) && !is_string($marka)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($marka, true), gettype($marka)), __LINE__);
        }
        $this->marka = $marka;
        return $this;
    }
    /**
     * Get model value
     * @return string|null
     */
    public function getModel()
    {
        return $this->model;
    }
    /**
     * Set model value
     * @param string $model
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setModel($model = null)
    {
        // validation for constraint: string
        if (!is_null($model) && !is_string($model)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model, true), gettype($model)), __LINE__);
        }
        $this->model = $model;
        return $this;
    }
    /**
     * Get modification value
     * @return string|null
     */
    public function getModification()
    {
        return $this->modification;
    }
    /**
     * Set modification value
     * @param string $modification
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setModification($modification = null)
    {
        // validation for constraint: string
        if (!is_null($modification) && !is_string($modification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($modification, true), gettype($modification)), __LINE__);
        }
        $this->modification = $modification;
        return $this;
    }
    /**
     * Get podbor_type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getPodbor_type()
    {
        return isset($this->podbor_type) ? $this->podbor_type : null;
    }
    /**
     * Set podbor_type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $podbor_type
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setPodbor_type(\ArrayType\ArrayOfint $podbor_type = null)
    {
        if (is_null($podbor_type) || (is_array($podbor_type) && empty($podbor_type))) {
            unset($this->podbor_type);
        } else {
            $this->podbor_type = $podbor_type;
        }
        return $this;
    }
    /**
     * Get season_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getSeason_list()
    {
        return isset($this->season_list) ? $this->season_list : null;
    }
    /**
     * Set season_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $season_list
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setSeason_list(\ArrayType\ArrayOfstring $season_list = null)
    {
        if (is_null($season_list) || (is_array($season_list) && empty($season_list))) {
            unset($this->season_list);
        } else {
            $this->season_list = $season_list;
        }
        return $this;
    }
    /**
     * Get thorn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getThorn()
    {
        return isset($this->thorn) ? $this->thorn : null;
    }
    /**
     * Set thorn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $thorn
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setThorn($thorn = null)
    {
        // validation for constraint: boolean
        if (!is_null($thorn) && !is_bool($thorn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($thorn, true), gettype($thorn)), __LINE__);
        }
        if (is_null($thorn) || (is_array($thorn) && empty($thorn))) {
            unset($this->thorn);
        } else {
            $this->thorn = $thorn;
        }
        return $this;
    }
    /**
     * Get type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getType()
    {
        return isset($this->type) ? $this->type : null;
    }
    /**
     * Set type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $type
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setType(\ArrayType\ArrayOfstring $type = null)
    {
        if (is_null($type) || (is_array($type) && empty($type))) {
            unset($this->type);
        } else {
            $this->type = $type;
        }
        return $this;
    }
    /**
     * Get wrh_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfint|null
     */
    public function getWrh_list()
    {
        return isset($this->wrh_list) ? $this->wrh_list : null;
    }
    /**
     * Set wrh_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfint $wrh_list
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setWrh_list(\ArrayType\ArrayOfint $wrh_list = null)
    {
        if (is_null($wrh_list) || (is_array($wrh_list) && empty($wrh_list))) {
            unset($this->wrh_list);
        } else {
            $this->wrh_list = $wrh_list;
        }
        return $this;
    }
    /**
     * Get year_beg value
     * @return string|null
     */
    public function getYear_beg()
    {
        return $this->year_beg;
    }
    /**
     * Set year_beg value
     * @param string $year_beg
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setYear_beg($year_beg = null)
    {
        // validation for constraint: string
        if (!is_null($year_beg) && !is_string($year_beg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($year_beg, true), gettype($year_beg)), __LINE__);
        }
        $this->year_beg = $year_beg;
        return $this;
    }
    /**
     * Get year_end value
     * @return string|null
     */
    public function getYear_end()
    {
        return $this->year_end;
    }
    /**
     * Set year_end value
     * @param string $year_end
     * @return \StructType\GetGoodsByCarFilter
     */
    public function setYear_end($year_end = null)
    {
        // validation for constraint: string
        if (!is_null($year_end) && !is_string($year_end)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($year_end, true), gettype($year_end)), __LINE__);
        }
        $this->year_end = $year_end;
        return $this;
    }
}
