<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPressureSensorResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetPressureSensorResult
 * @subpackage Structs
 */
class GetPressureSensorResult extends AbstractStructBase
{
    /**
     * The currencyRate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CurrencyRate
     */
    public $currencyRate;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The items
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPressureSensorContainer
     */
    public $items;
    /**
     * The warehouseLogistics
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWarehouseLogistic
     */
    public $warehouseLogistics;
    /**
     * Constructor method for GetPressureSensorResult
     * @uses GetPressureSensorResult::setCurrencyRate()
     * @uses GetPressureSensorResult::setError()
     * @uses GetPressureSensorResult::setItems()
     * @uses GetPressureSensorResult::setWarehouseLogistics()
     * @param \StructType\CurrencyRate $currencyRate
     * @param \StructType\Error $error
     * @param \ArrayType\ArrayOfPressureSensorContainer $items
     * @param \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics
     */
    public function __construct(\StructType\CurrencyRate $currencyRate = null, \StructType\Error $error = null, \ArrayType\ArrayOfPressureSensorContainer $items = null, \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics = null)
    {
        $this
            ->setCurrencyRate($currencyRate)
            ->setError($error)
            ->setItems($items)
            ->setWarehouseLogistics($warehouseLogistics);
    }
    /**
     * Get currencyRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CurrencyRate|null
     */
    public function getCurrencyRate()
    {
        return isset($this->currencyRate) ? $this->currencyRate : null;
    }
    /**
     * Set currencyRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\CurrencyRate $currencyRate
     * @return \StructType\GetPressureSensorResult
     */
    public function setCurrencyRate(\StructType\CurrencyRate $currencyRate = null)
    {
        if (is_null($currencyRate) || (is_array($currencyRate) && empty($currencyRate))) {
            unset($this->currencyRate);
        } else {
            $this->currencyRate = $currencyRate;
        }
        return $this;
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\GetPressureSensorResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get items value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPressureSensorContainer|null
     */
    public function getItems()
    {
        return isset($this->items) ? $this->items : null;
    }
    /**
     * Set items value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPressureSensorContainer $items
     * @return \StructType\GetPressureSensorResult
     */
    public function setItems(\ArrayType\ArrayOfPressureSensorContainer $items = null)
    {
        if (is_null($items) || (is_array($items) && empty($items))) {
            unset($this->items);
        } else {
            $this->items = $items;
        }
        return $this;
    }
    /**
     * Get warehouseLogistics value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWarehouseLogistic|null
     */
    public function getWarehouseLogistics()
    {
        return isset($this->warehouseLogistics) ? $this->warehouseLogistics : null;
    }
    /**
     * Set warehouseLogistics value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics
     * @return \StructType\GetPressureSensorResult
     */
    public function setWarehouseLogistics(\ArrayType\ArrayOfWarehouseLogistic $warehouseLogistics = null)
    {
        if (is_null($warehouseLogistics) || (is_array($warehouseLogistics) && empty($warehouseLogistics))) {
            unset($this->warehouseLogistics);
        } else {
            $this->warehouseLogistics = $warehouseLogistics;
        }
        return $this;
    }
}
