<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUserListResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetUserListResult
 * @subpackage Structs
 */
class GetUserListResult extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The userInfoList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfuserInfo
     */
    public $userInfoList;
    /**
     * Constructor method for GetUserListResult
     * @uses GetUserListResult::setError()
     * @uses GetUserListResult::setUserInfoList()
     * @param \StructType\Error $error
     * @param \ArrayType\ArrayOfuserInfo $userInfoList
     */
    public function __construct(\StructType\Error $error = null, \ArrayType\ArrayOfuserInfo $userInfoList = null)
    {
        $this
            ->setError($error)
            ->setUserInfoList($userInfoList);
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\GetUserListResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get userInfoList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfuserInfo|null
     */
    public function getUserInfoList()
    {
        return isset($this->userInfoList) ? $this->userInfoList : null;
    }
    /**
     * Set userInfoList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfuserInfo $userInfoList
     * @return \StructType\GetUserListResult
     */
    public function setUserInfoList(\ArrayType\ArrayOfuserInfo $userInfoList = null)
    {
        if (is_null($userInfoList) || (is_array($userInfoList) && empty($userInfoList))) {
            unset($this->userInfoList);
        } else {
            $this->userInfoList = $userInfoList;
        }
        return $this;
    }
}
