<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetWarehousesResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetWarehousesResult
 * @subpackage Structs
 */
class GetWarehousesResult extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The success
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $success;
    /**
     * The warehouses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWarehouseInfo
     */
    public $warehouses;
    /**
     * Constructor method for GetWarehousesResult
     * @uses GetWarehousesResult::setError()
     * @uses GetWarehousesResult::setSuccess()
     * @uses GetWarehousesResult::setWarehouses()
     * @param \StructType\Error $error
     * @param bool $success
     * @param \ArrayType\ArrayOfWarehouseInfo $warehouses
     */
    public function __construct(\StructType\Error $error = null, $success = null, \ArrayType\ArrayOfWarehouseInfo $warehouses = null)
    {
        $this
            ->setError($error)
            ->setSuccess($success)
            ->setWarehouses($warehouses);
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\GetWarehousesResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\GetWarehousesResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
    /**
     * Get warehouses value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWarehouseInfo|null
     */
    public function getWarehouses()
    {
        return isset($this->warehouses) ? $this->warehouses : null;
    }
    /**
     * Set warehouses value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWarehouseInfo $warehouses
     * @return \StructType\GetWarehousesResult
     */
    public function setWarehouses(\ArrayType\ArrayOfWarehouseInfo $warehouses = null)
    {
        if (is_null($warehouses) || (is_array($warehouses) && empty($warehouses))) {
            unset($this->warehouses);
        } else {
            $this->warehouses = $warehouses;
        }
        return $this;
    }
}
