<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for movementInfoContainer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:movementInfoContainer
 * @subpackage Structs
 */
class MovementInfoContainer extends Result
{
    /**
     * The MX1_Date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MX1_Date;
    /**
     * The MX1_Number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MX1_Number;
    /**
     * The MX3_Date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MX3_Date;
    /**
     * The MX3_Number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MX3_Number;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date;
    /**
     * The idStoreFrom
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $idStoreFrom;
    /**
     * The idStoreTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $idStoreTo;
    /**
     * The markCodeList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMarkCodeContainer
     */
    public $markCodeList;
    /**
     * The statusID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $statusID;
    /**
     * Constructor method for movementInfoContainer
     * @uses MovementInfoContainer::setMX1_Date()
     * @uses MovementInfoContainer::setMX1_Number()
     * @uses MovementInfoContainer::setMX3_Date()
     * @uses MovementInfoContainer::setMX3_Number()
     * @uses MovementInfoContainer::setDate()
     * @uses MovementInfoContainer::setIdStoreFrom()
     * @uses MovementInfoContainer::setIdStoreTo()
     * @uses MovementInfoContainer::setMarkCodeList()
     * @uses MovementInfoContainer::setStatusID()
     * @param string $mX1_Date
     * @param string $mX1_Number
     * @param string $mX3_Date
     * @param string $mX3_Number
     * @param string $date
     * @param int $idStoreFrom
     * @param int $idStoreTo
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @param int $statusID
     */
    public function __construct($mX1_Date = null, $mX1_Number = null, $mX3_Date = null, $mX3_Number = null, $date = null, $idStoreFrom = null, $idStoreTo = null, \ArrayType\ArrayOfMarkCodeContainer $markCodeList = null, $statusID = null)
    {
        $this
            ->setMX1_Date($mX1_Date)
            ->setMX1_Number($mX1_Number)
            ->setMX3_Date($mX3_Date)
            ->setMX3_Number($mX3_Number)
            ->setDate($date)
            ->setIdStoreFrom($idStoreFrom)
            ->setIdStoreTo($idStoreTo)
            ->setMarkCodeList($markCodeList)
            ->setStatusID($statusID);
    }
    /**
     * Get MX1_Date value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMX1_Date()
    {
        return isset($this->MX1_Date) ? $this->MX1_Date : null;
    }
    /**
     * Set MX1_Date value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mX1_Date
     * @return \StructType\MovementInfoContainer
     */
    public function setMX1_Date($mX1_Date = null)
    {
        // validation for constraint: string
        if (!is_null($mX1_Date) && !is_string($mX1_Date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mX1_Date, true), gettype($mX1_Date)), __LINE__);
        }
        if (is_null($mX1_Date) || (is_array($mX1_Date) && empty($mX1_Date))) {
            unset($this->MX1_Date);
        } else {
            $this->MX1_Date = $mX1_Date;
        }
        return $this;
    }
    /**
     * Get MX1_Number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMX1_Number()
    {
        return isset($this->MX1_Number) ? $this->MX1_Number : null;
    }
    /**
     * Set MX1_Number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mX1_Number
     * @return \StructType\MovementInfoContainer
     */
    public function setMX1_Number($mX1_Number = null)
    {
        // validation for constraint: string
        if (!is_null($mX1_Number) && !is_string($mX1_Number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mX1_Number, true), gettype($mX1_Number)), __LINE__);
        }
        if (is_null($mX1_Number) || (is_array($mX1_Number) && empty($mX1_Number))) {
            unset($this->MX1_Number);
        } else {
            $this->MX1_Number = $mX1_Number;
        }
        return $this;
    }
    /**
     * Get MX3_Date value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMX3_Date()
    {
        return isset($this->MX3_Date) ? $this->MX3_Date : null;
    }
    /**
     * Set MX3_Date value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mX3_Date
     * @return \StructType\MovementInfoContainer
     */
    public function setMX3_Date($mX3_Date = null)
    {
        // validation for constraint: string
        if (!is_null($mX3_Date) && !is_string($mX3_Date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mX3_Date, true), gettype($mX3_Date)), __LINE__);
        }
        if (is_null($mX3_Date) || (is_array($mX3_Date) && empty($mX3_Date))) {
            unset($this->MX3_Date);
        } else {
            $this->MX3_Date = $mX3_Date;
        }
        return $this;
    }
    /**
     * Get MX3_Number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMX3_Number()
    {
        return isset($this->MX3_Number) ? $this->MX3_Number : null;
    }
    /**
     * Set MX3_Number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mX3_Number
     * @return \StructType\MovementInfoContainer
     */
    public function setMX3_Number($mX3_Number = null)
    {
        // validation for constraint: string
        if (!is_null($mX3_Number) && !is_string($mX3_Number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mX3_Number, true), gettype($mX3_Number)), __LINE__);
        }
        if (is_null($mX3_Number) || (is_array($mX3_Number) && empty($mX3_Number))) {
            unset($this->MX3_Number);
        } else {
            $this->MX3_Number = $mX3_Number;
        }
        return $this;
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\MovementInfoContainer
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get idStoreFrom value
     * @return int|null
     */
    public function getIdStoreFrom()
    {
        return $this->idStoreFrom;
    }
    /**
     * Set idStoreFrom value
     * @param int $idStoreFrom
     * @return \StructType\MovementInfoContainer
     */
    public function setIdStoreFrom($idStoreFrom = null)
    {
        // validation for constraint: int
        if (!is_null($idStoreFrom) && !(is_int($idStoreFrom) || ctype_digit($idStoreFrom))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idStoreFrom, true), gettype($idStoreFrom)), __LINE__);
        }
        $this->idStoreFrom = $idStoreFrom;
        return $this;
    }
    /**
     * Get idStoreTo value
     * @return int|null
     */
    public function getIdStoreTo()
    {
        return $this->idStoreTo;
    }
    /**
     * Set idStoreTo value
     * @param int $idStoreTo
     * @return \StructType\MovementInfoContainer
     */
    public function setIdStoreTo($idStoreTo = null)
    {
        // validation for constraint: int
        if (!is_null($idStoreTo) && !(is_int($idStoreTo) || ctype_digit($idStoreTo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idStoreTo, true), gettype($idStoreTo)), __LINE__);
        }
        $this->idStoreTo = $idStoreTo;
        return $this;
    }
    /**
     * Get markCodeList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMarkCodeContainer|null
     */
    public function getMarkCodeList()
    {
        return isset($this->markCodeList) ? $this->markCodeList : null;
    }
    /**
     * Set markCodeList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @return \StructType\MovementInfoContainer
     */
    public function setMarkCodeList(\ArrayType\ArrayOfMarkCodeContainer $markCodeList = null)
    {
        if (is_null($markCodeList) || (is_array($markCodeList) && empty($markCodeList))) {
            unset($this->markCodeList);
        } else {
            $this->markCodeList = $markCodeList;
        }
        return $this;
    }
    /**
     * Get statusID value
     * @return int|null
     */
    public function getStatusID()
    {
        return $this->statusID;
    }
    /**
     * Set statusID value
     * @param int $statusID
     * @return \StructType\MovementInfoContainer
     */
    public function setStatusID($statusID = null)
    {
        // validation for constraint: int
        if (!is_null($statusID) && !(is_int($statusID) || ctype_digit($statusID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusID, true), gettype($statusID)), __LINE__);
        }
        $this->statusID = $statusID;
        return $this;
    }
}
