<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for note StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:note
 * @subpackage Structs
 */
class Note extends AbstractStructBase
{
    /**
     * The noteCreateDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $noteCreateDate;
    /**
     * The noteText
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $noteText;
    /**
     * Constructor method for note
     * @uses Note::setNoteCreateDate()
     * @uses Note::setNoteText()
     * @param string $noteCreateDate
     * @param string $noteText
     */
    public function __construct($noteCreateDate = null, $noteText = null)
    {
        $this
            ->setNoteCreateDate($noteCreateDate)
            ->setNoteText($noteText);
    }
    /**
     * Get noteCreateDate value
     * @return string|null
     */
    public function getNoteCreateDate()
    {
        return $this->noteCreateDate;
    }
    /**
     * Set noteCreateDate value
     * @param string $noteCreateDate
     * @return \StructType\Note
     */
    public function setNoteCreateDate($noteCreateDate = null)
    {
        // validation for constraint: string
        if (!is_null($noteCreateDate) && !is_string($noteCreateDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($noteCreateDate, true), gettype($noteCreateDate)), __LINE__);
        }
        $this->noteCreateDate = $noteCreateDate;
        return $this;
    }
    /**
     * Get noteText value
     * @return string|null
     */
    public function getNoteText()
    {
        return $this->noteText;
    }
    /**
     * Set noteText value
     * @param string $noteText
     * @return \StructType\Note
     */
    public function setNoteText($noteText = null)
    {
        // validation for constraint: string
        if (!is_null($noteText) && !is_string($noteText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($noteText, true), gettype($noteText)), __LINE__);
        }
        $this->noteText = $noteText;
        return $this;
    }
}
