<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for proposeDiskItem StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:proposeDiskItem
 * @subpackage Structs
 */
class ProposeDiskItem extends AbstractStructBase
{
    /**
     * The boltsCount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $boltsCount;
    /**
     * The brand
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $brand;
    /**
     * The car
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $car;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $code;
    /**
     * The color
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $color;
    /**
     * The dia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $dia;
    /**
     * The diameter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $diameter;
    /**
     * The et
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $et;
    /**
     * The insertType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $insertType;
    /**
     * The manufactory
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $manufactory;
    /**
     * The manufactoryCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $manufactoryCode;
    /**
     * The model
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $model;
    /**
     * The mount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mount;
    /**
     * The mountNote
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mountNote;
    /**
     * The pcd1
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $pcd1;
    /**
     * The pcd2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $pcd2;
    /**
     * The width
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $width;
    /**
     * Constructor method for proposeDiskItem
     * @uses ProposeDiskItem::setBoltsCount()
     * @uses ProposeDiskItem::setBrand()
     * @uses ProposeDiskItem::setCar()
     * @uses ProposeDiskItem::setCode()
     * @uses ProposeDiskItem::setColor()
     * @uses ProposeDiskItem::setDia()
     * @uses ProposeDiskItem::setDiameter()
     * @uses ProposeDiskItem::setEt()
     * @uses ProposeDiskItem::setInsertType()
     * @uses ProposeDiskItem::setManufactory()
     * @uses ProposeDiskItem::setManufactoryCode()
     * @uses ProposeDiskItem::setModel()
     * @uses ProposeDiskItem::setMount()
     * @uses ProposeDiskItem::setMountNote()
     * @uses ProposeDiskItem::setPcd1()
     * @uses ProposeDiskItem::setPcd2()
     * @uses ProposeDiskItem::setWidth()
     * @param int $boltsCount
     * @param string $brand
     * @param string $car
     * @param string $code
     * @param string $color
     * @param float $dia
     * @param float $diameter
     * @param float $et
     * @param string $insertType
     * @param string $manufactory
     * @param string $manufactoryCode
     * @param string $model
     * @param string $mount
     * @param string $mountNote
     * @param float $pcd1
     * @param float $pcd2
     * @param float $width
     */
    public function __construct($boltsCount = null, $brand = null, $car = null, $code = null, $color = null, $dia = null, $diameter = null, $et = null, $insertType = null, $manufactory = null, $manufactoryCode = null, $model = null, $mount = null, $mountNote = null, $pcd1 = null, $pcd2 = null, $width = null)
    {
        $this
            ->setBoltsCount($boltsCount)
            ->setBrand($brand)
            ->setCar($car)
            ->setCode($code)
            ->setColor($color)
            ->setDia($dia)
            ->setDiameter($diameter)
            ->setEt($et)
            ->setInsertType($insertType)
            ->setManufactory($manufactory)
            ->setManufactoryCode($manufactoryCode)
            ->setModel($model)
            ->setMount($mount)
            ->setMountNote($mountNote)
            ->setPcd1($pcd1)
            ->setPcd2($pcd2)
            ->setWidth($width);
    }
    /**
     * Get boltsCount value
     * @return int|null
     */
    public function getBoltsCount()
    {
        return $this->boltsCount;
    }
    /**
     * Set boltsCount value
     * @param int $boltsCount
     * @return \StructType\ProposeDiskItem
     */
    public function setBoltsCount($boltsCount = null)
    {
        // validation for constraint: int
        if (!is_null($boltsCount) && !(is_int($boltsCount) || ctype_digit($boltsCount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($boltsCount, true), gettype($boltsCount)), __LINE__);
        }
        $this->boltsCount = $boltsCount;
        return $this;
    }
    /**
     * Get brand value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : null;
    }
    /**
     * Set brand value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $brand
     * @return \StructType\ProposeDiskItem
     */
    public function setBrand($brand = null)
    {
        // validation for constraint: string
        if (!is_null($brand) && !is_string($brand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brand, true), gettype($brand)), __LINE__);
        }
        if (is_null($brand) || (is_array($brand) && empty($brand))) {
            unset($this->brand);
        } else {
            $this->brand = $brand;
        }
        return $this;
    }
    /**
     * Get car value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCar()
    {
        return isset($this->car) ? $this->car : null;
    }
    /**
     * Set car value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $car
     * @return \StructType\ProposeDiskItem
     */
    public function setCar($car = null)
    {
        // validation for constraint: string
        if (!is_null($car) && !is_string($car)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($car, true), gettype($car)), __LINE__);
        }
        if (is_null($car) || (is_array($car) && empty($car))) {
            unset($this->car);
        } else {
            $this->car = $car;
        }
        return $this;
    }
    /**
     * Get code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCode()
    {
        return isset($this->code) ? $this->code : null;
    }
    /**
     * Set code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $code
     * @return \StructType\ProposeDiskItem
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->code);
        } else {
            $this->code = $code;
        }
        return $this;
    }
    /**
     * Get color value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getColor()
    {
        return isset($this->color) ? $this->color : null;
    }
    /**
     * Set color value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $color
     * @return \StructType\ProposeDiskItem
     */
    public function setColor($color = null)
    {
        // validation for constraint: string
        if (!is_null($color) && !is_string($color)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($color, true), gettype($color)), __LINE__);
        }
        if (is_null($color) || (is_array($color) && empty($color))) {
            unset($this->color);
        } else {
            $this->color = $color;
        }
        return $this;
    }
    /**
     * Get dia value
     * @return float|null
     */
    public function getDia()
    {
        return $this->dia;
    }
    /**
     * Set dia value
     * @param float $dia
     * @return \StructType\ProposeDiskItem
     */
    public function setDia($dia = null)
    {
        // validation for constraint: float
        if (!is_null($dia) && !(is_float($dia) || is_numeric($dia))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($dia, true), gettype($dia)), __LINE__);
        }
        $this->dia = $dia;
        return $this;
    }
    /**
     * Get diameter value
     * @return float|null
     */
    public function getDiameter()
    {
        return $this->diameter;
    }
    /**
     * Set diameter value
     * @param float $diameter
     * @return \StructType\ProposeDiskItem
     */
    public function setDiameter($diameter = null)
    {
        // validation for constraint: float
        if (!is_null($diameter) && !(is_float($diameter) || is_numeric($diameter))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($diameter, true), gettype($diameter)), __LINE__);
        }
        $this->diameter = $diameter;
        return $this;
    }
    /**
     * Get et value
     * @return float|null
     */
    public function getEt()
    {
        return $this->et;
    }
    /**
     * Set et value
     * @param float $et
     * @return \StructType\ProposeDiskItem
     */
    public function setEt($et = null)
    {
        // validation for constraint: float
        if (!is_null($et) && !(is_float($et) || is_numeric($et))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($et, true), gettype($et)), __LINE__);
        }
        $this->et = $et;
        return $this;
    }
    /**
     * Get insertType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInsertType()
    {
        return isset($this->insertType) ? $this->insertType : null;
    }
    /**
     * Set insertType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $insertType
     * @return \StructType\ProposeDiskItem
     */
    public function setInsertType($insertType = null)
    {
        // validation for constraint: string
        if (!is_null($insertType) && !is_string($insertType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insertType, true), gettype($insertType)), __LINE__);
        }
        if (is_null($insertType) || (is_array($insertType) && empty($insertType))) {
            unset($this->insertType);
        } else {
            $this->insertType = $insertType;
        }
        return $this;
    }
    /**
     * Get manufactory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getManufactory()
    {
        return isset($this->manufactory) ? $this->manufactory : null;
    }
    /**
     * Set manufactory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $manufactory
     * @return \StructType\ProposeDiskItem
     */
    public function setManufactory($manufactory = null)
    {
        // validation for constraint: string
        if (!is_null($manufactory) && !is_string($manufactory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($manufactory, true), gettype($manufactory)), __LINE__);
        }
        if (is_null($manufactory) || (is_array($manufactory) && empty($manufactory))) {
            unset($this->manufactory);
        } else {
            $this->manufactory = $manufactory;
        }
        return $this;
    }
    /**
     * Get manufactoryCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getManufactoryCode()
    {
        return isset($this->manufactoryCode) ? $this->manufactoryCode : null;
    }
    /**
     * Set manufactoryCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $manufactoryCode
     * @return \StructType\ProposeDiskItem
     */
    public function setManufactoryCode($manufactoryCode = null)
    {
        // validation for constraint: string
        if (!is_null($manufactoryCode) && !is_string($manufactoryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($manufactoryCode, true), gettype($manufactoryCode)), __LINE__);
        }
        if (is_null($manufactoryCode) || (is_array($manufactoryCode) && empty($manufactoryCode))) {
            unset($this->manufactoryCode);
        } else {
            $this->manufactoryCode = $manufactoryCode;
        }
        return $this;
    }
    /**
     * Get model value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getModel()
    {
        return isset($this->model) ? $this->model : null;
    }
    /**
     * Set model value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $model
     * @return \StructType\ProposeDiskItem
     */
    public function setModel($model = null)
    {
        // validation for constraint: string
        if (!is_null($model) && !is_string($model)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model, true), gettype($model)), __LINE__);
        }
        if (is_null($model) || (is_array($model) && empty($model))) {
            unset($this->model);
        } else {
            $this->model = $model;
        }
        return $this;
    }
    /**
     * Get mount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMount()
    {
        return isset($this->mount) ? $this->mount : null;
    }
    /**
     * Set mount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mount
     * @return \StructType\ProposeDiskItem
     */
    public function setMount($mount = null)
    {
        // validation for constraint: string
        if (!is_null($mount) && !is_string($mount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mount, true), gettype($mount)), __LINE__);
        }
        if (is_null($mount) || (is_array($mount) && empty($mount))) {
            unset($this->mount);
        } else {
            $this->mount = $mount;
        }
        return $this;
    }
    /**
     * Get mountNote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMountNote()
    {
        return isset($this->mountNote) ? $this->mountNote : null;
    }
    /**
     * Set mountNote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mountNote
     * @return \StructType\ProposeDiskItem
     */
    public function setMountNote($mountNote = null)
    {
        // validation for constraint: string
        if (!is_null($mountNote) && !is_string($mountNote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mountNote, true), gettype($mountNote)), __LINE__);
        }
        if (is_null($mountNote) || (is_array($mountNote) && empty($mountNote))) {
            unset($this->mountNote);
        } else {
            $this->mountNote = $mountNote;
        }
        return $this;
    }
    /**
     * Get pcd1 value
     * @return float|null
     */
    public function getPcd1()
    {
        return $this->pcd1;
    }
    /**
     * Set pcd1 value
     * @param float $pcd1
     * @return \StructType\ProposeDiskItem
     */
    public function setPcd1($pcd1 = null)
    {
        // validation for constraint: float
        if (!is_null($pcd1) && !(is_float($pcd1) || is_numeric($pcd1))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pcd1, true), gettype($pcd1)), __LINE__);
        }
        $this->pcd1 = $pcd1;
        return $this;
    }
    /**
     * Get pcd2 value
     * @return float|null
     */
    public function getPcd2()
    {
        return $this->pcd2;
    }
    /**
     * Set pcd2 value
     * @param float $pcd2
     * @return \StructType\ProposeDiskItem
     */
    public function setPcd2($pcd2 = null)
    {
        // validation for constraint: float
        if (!is_null($pcd2) && !(is_float($pcd2) || is_numeric($pcd2))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($pcd2, true), gettype($pcd2)), __LINE__);
        }
        $this->pcd2 = $pcd2;
        return $this;
    }
    /**
     * Get width value
     * @return float|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param float $width
     * @return \StructType\ProposeDiskItem
     */
    public function setWidth($width = null)
    {
        // validation for constraint: float
        if (!is_null($width) && !(is_float($width) || is_numeric($width))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($width, true), gettype($width)), __LINE__);
        }
        $this->width = $width;
        return $this;
    }
}
