<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Result StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Result
 * @subpackage Structs
 */
class Result extends ClientServiceResult
{
    /**
     * The goods
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfgood
     */
    public $goods;
    /**
     * The gtdList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfgtdContainer
     */
    public $gtdList;
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $number;
    /**
     * The MarkCodeContainerList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMarkCodeContainer
     */
    public $MarkCodeContainerList;
    /**
     * The MarkCodeList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMarkCodeContainer
     */
    public $MarkCodeList;
    /**
     * The contractName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contractName;
    /**
     * The contractNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contractNumber;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $date;
    /**
     * The dateSF
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dateSF;
    /**
     * The markCodeList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfMarkCodeContainer
     */
    public $markCodeList;
    /**
     * The numberSF
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numberSF;
    /**
     * The statusID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $statusID;
    /**
     * The sumRTU
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $sumRTU;
    /**
     * The sales
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfSaleContainer
     */
    public $sales;
    /**
     * Constructor method for Result
     * @uses Result::setGoods()
     * @uses Result::setGtdList()
     * @uses Result::setNumber()
     * @uses Result::setMarkCodeContainerList()
     * @uses Result::setMarkCodeList()
     * @uses Result::setContractName()
     * @uses Result::setContractNumber()
     * @uses Result::setDate()
     * @uses Result::setDateSF()
     * @uses Result::setMarkCodeList_1()
     * @uses Result::setNumberSF()
     * @uses Result::setStatusID()
     * @uses Result::setSumRTU()
     * @uses Result::setSales()
     * @param \ArrayType\ArrayOfgood $goods
     * @param \ArrayType\ArrayOfgtdContainer $gtdList
     * @param string $number
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeContainerList
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @param string $contractName
     * @param string $contractNumber
     * @param string $date
     * @param string $dateSF
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @param string $numberSF
     * @param int $statusID
     * @param float $sumRTU
     * @param \ArrayType\ArrayOfSaleContainer $sales
     */
    public function __construct(\ArrayType\ArrayOfgood $goods = null, \ArrayType\ArrayOfgtdContainer $gtdList = null, $number = null, \ArrayType\ArrayOfMarkCodeContainer $markCodeContainerList = null, \ArrayType\ArrayOfMarkCodeContainer $markCodeList = null, $contractName = null, $contractNumber = null, $date = null, $dateSF = null, \ArrayType\ArrayOfMarkCodeContainer $markCodeList_1 = null, $numberSF = null, $statusID = null, $sumRTU = null, \ArrayType\ArrayOfSaleContainer $sales = null)
    {
        $this
            ->setGoods($goods)
            ->setGtdList($gtdList)
            ->setNumber($number)
            ->setMarkCodeContainerList($markCodeContainerList)
            ->setMarkCodeList($markCodeList)
            ->setContractName($contractName)
            ->setContractNumber($contractNumber)
            ->setDate($date)
            ->setDateSF($dateSF)
            ->setMarkCodeList_1($markCodeList_1)
            ->setNumberSF($numberSF)
            ->setStatusID($statusID)
            ->setSumRTU($sumRTU)
            ->setSales($sales);
    }
    /**
     * Get goods value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfgood|null
     */
    public function getGoods()
    {
        return isset($this->goods) ? $this->goods : null;
    }
    /**
     * Set goods value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfgood $goods
     * @return \StructType\Result
     */
    public function setGoods(\ArrayType\ArrayOfgood $goods = null)
    {
        if (is_null($goods) || (is_array($goods) && empty($goods))) {
            unset($this->goods);
        } else {
            $this->goods = $goods;
        }
        return $this;
    }
    /**
     * Get gtdList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfgtdContainer|null
     */
    public function getGtdList()
    {
        return isset($this->gtdList) ? $this->gtdList : null;
    }
    /**
     * Set gtdList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfgtdContainer $gtdList
     * @return \StructType\Result
     */
    public function setGtdList(\ArrayType\ArrayOfgtdContainer $gtdList = null)
    {
        if (is_null($gtdList) || (is_array($gtdList) && empty($gtdList))) {
            unset($this->gtdList);
        } else {
            $this->gtdList = $gtdList;
        }
        return $this;
    }
    /**
     * Get number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumber()
    {
        return isset($this->number) ? $this->number : null;
    }
    /**
     * Set number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $number
     * @return \StructType\Result
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        if (is_null($number) || (is_array($number) && empty($number))) {
            unset($this->number);
        } else {
            $this->number = $number;
        }
        return $this;
    }
    /**
     * Get MarkCodeContainerList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMarkCodeContainer|null
     */
    public function getMarkCodeContainerList()
    {
        return isset($this->MarkCodeContainerList) ? $this->MarkCodeContainerList : null;
    }
    /**
     * Set MarkCodeContainerList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeContainerList
     * @return \StructType\Result
     */
    public function setMarkCodeContainerList(\ArrayType\ArrayOfMarkCodeContainer $markCodeContainerList = null)
    {
        if (is_null($markCodeContainerList) || (is_array($markCodeContainerList) && empty($markCodeContainerList))) {
            unset($this->MarkCodeContainerList);
        } else {
            $this->MarkCodeContainerList = $markCodeContainerList;
        }
        return $this;
    }
    /**
     * Get MarkCodeList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMarkCodeContainer|null
     */
    public function getMarkCodeList()
    {
        return isset($this->MarkCodeList) ? $this->MarkCodeList : null;
    }
    /**
     * Set MarkCodeList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @return \StructType\Result
     */
    public function setMarkCodeList(\ArrayType\ArrayOfMarkCodeContainer $markCodeList = null)
    {
        if (is_null($markCodeList) || (is_array($markCodeList) && empty($markCodeList))) {
            unset($this->MarkCodeList);
        } else {
            $this->MarkCodeList = $markCodeList;
        }
        return $this;
    }
    /**
     * Get contractName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContractName()
    {
        return isset($this->contractName) ? $this->contractName : null;
    }
    /**
     * Set contractName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contractName
     * @return \StructType\Result
     */
    public function setContractName($contractName = null)
    {
        // validation for constraint: string
        if (!is_null($contractName) && !is_string($contractName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contractName, true), gettype($contractName)), __LINE__);
        }
        if (is_null($contractName) || (is_array($contractName) && empty($contractName))) {
            unset($this->contractName);
        } else {
            $this->contractName = $contractName;
        }
        return $this;
    }
    /**
     * Get contractNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContractNumber()
    {
        return isset($this->contractNumber) ? $this->contractNumber : null;
    }
    /**
     * Set contractNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contractNumber
     * @return \StructType\Result
     */
    public function setContractNumber($contractNumber = null)
    {
        // validation for constraint: string
        if (!is_null($contractNumber) && !is_string($contractNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contractNumber, true), gettype($contractNumber)), __LINE__);
        }
        if (is_null($contractNumber) || (is_array($contractNumber) && empty($contractNumber))) {
            unset($this->contractNumber);
        } else {
            $this->contractNumber = $contractNumber;
        }
        return $this;
    }
    /**
     * Get date value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDate()
    {
        return isset($this->date) ? $this->date : null;
    }
    /**
     * Set date value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $date
     * @return \StructType\Result
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        if (is_null($date) || (is_array($date) && empty($date))) {
            unset($this->date);
        } else {
            $this->date = $date;
        }
        return $this;
    }
    /**
     * Get dateSF value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDateSF()
    {
        return isset($this->dateSF) ? $this->dateSF : null;
    }
    /**
     * Set dateSF value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dateSF
     * @return \StructType\Result
     */
    public function setDateSF($dateSF = null)
    {
        // validation for constraint: string
        if (!is_null($dateSF) && !is_string($dateSF)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateSF, true), gettype($dateSF)), __LINE__);
        }
        if (is_null($dateSF) || (is_array($dateSF) && empty($dateSF))) {
            unset($this->dateSF);
        } else {
            $this->dateSF = $dateSF;
        }
        return $this;
    }
    /**
     * Get MarkCodeList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfMarkCodeContainer|null
     */
    public function getMarkCodeList_1()
    {
        return isset($this->markCodeList) ? $this->markCodeList : null;
    }
    /**
     * Set MarkCodeList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfMarkCodeContainer $markCodeList
     * @return \StructType\Result
     */
    public function setMarkCodeList_1(\ArrayType\ArrayOfMarkCodeContainer $markCodeList_1 = null)
    {
        if (is_null($markCodeList_1) || (is_array($markCodeList_1) && empty($markCodeList_1))) {
            unset($this->markCodeList);
        } else {
            $this->markCodeList = $markCodeList_1;
        }
        return $this;
    }
    /**
     * Get numberSF value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumberSF()
    {
        return isset($this->numberSF) ? $this->numberSF : null;
    }
    /**
     * Set numberSF value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numberSF
     * @return \StructType\Result
     */
    public function setNumberSF($numberSF = null)
    {
        // validation for constraint: string
        if (!is_null($numberSF) && !is_string($numberSF)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numberSF, true), gettype($numberSF)), __LINE__);
        }
        if (is_null($numberSF) || (is_array($numberSF) && empty($numberSF))) {
            unset($this->numberSF);
        } else {
            $this->numberSF = $numberSF;
        }
        return $this;
    }
    /**
     * Get statusID value
     * @return int|null
     */
    public function getStatusID()
    {
        return $this->statusID;
    }
    /**
     * Set statusID value
     * @param int $statusID
     * @return \StructType\Result
     */
    public function setStatusID($statusID = null)
    {
        // validation for constraint: int
        if (!is_null($statusID) && !(is_int($statusID) || ctype_digit($statusID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusID, true), gettype($statusID)), __LINE__);
        }
        $this->statusID = $statusID;
        return $this;
    }
    /**
     * Get sumRTU value
     * @return float|null
     */
    public function getSumRTU()
    {
        return $this->sumRTU;
    }
    /**
     * Set sumRTU value
     * @param float $sumRTU
     * @return \StructType\Result
     */
    public function setSumRTU($sumRTU = null)
    {
        // validation for constraint: float
        if (!is_null($sumRTU) && !(is_float($sumRTU) || is_numeric($sumRTU))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sumRTU, true), gettype($sumRTU)), __LINE__);
        }
        $this->sumRTU = $sumRTU;
        return $this;
    }
    /**
     * Get sales value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfSaleContainer|null
     */
    public function getSales()
    {
        return isset($this->sales) ? $this->sales : null;
    }
    /**
     * Set sales value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfSaleContainer $sales
     * @return \StructType\Result
     */
    public function setSales(\ArrayType\ArrayOfSaleContainer $sales = null)
    {
        if (is_null($sales) || (is_array($sales) && empty($sales))) {
            unset($this->sales);
        } else {
            $this->sales = $sales;
        }
        return $this;
    }
}
