<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultGetGoodsInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ResultGetGoodsInfo
 * @subpackage Structs
 */
class ResultGetGoodsInfo extends AbstractStructBase
{
    /**
     * The fastenerList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFastenerContainer
     */
    public $fastenerList;
    /**
     * The pressureSensorList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfPressureSensorContainer
     */
    public $pressureSensorList;
    /**
     * The rimList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfRimContainer
     */
    public $rimList;
    /**
     * The sparePartList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfSparePartContainer
     */
    public $sparePartList;
    /**
     * The tyreList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTyreContainer
     */
    public $tyreList;
    /**
     * The GtinList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGtinItem
     */
    public $GtinList;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * Constructor method for ResultGetGoodsInfo
     * @uses ResultGetGoodsInfo::setFastenerList()
     * @uses ResultGetGoodsInfo::setPressureSensorList()
     * @uses ResultGetGoodsInfo::setRimList()
     * @uses ResultGetGoodsInfo::setSparePartList()
     * @uses ResultGetGoodsInfo::setTyreList()
     * @uses ResultGetGoodsInfo::setGtinList()
     * @uses ResultGetGoodsInfo::setError()
     * @param \ArrayType\ArrayOfFastenerContainer $fastenerList
     * @param \ArrayType\ArrayOfPressureSensorContainer $pressureSensorList
     * @param \ArrayType\ArrayOfRimContainer $rimList
     * @param \ArrayType\ArrayOfSparePartContainer $sparePartList
     * @param \ArrayType\ArrayOfTyreContainer $tyreList
     * @param \ArrayType\ArrayOfGtinItem $gtinList
     * @param \StructType\Error $error
     */
    public function __construct(\ArrayType\ArrayOfFastenerContainer $fastenerList = null, \ArrayType\ArrayOfPressureSensorContainer $pressureSensorList = null, \ArrayType\ArrayOfRimContainer $rimList = null, \ArrayType\ArrayOfSparePartContainer $sparePartList = null, \ArrayType\ArrayOfTyreContainer $tyreList = null, \ArrayType\ArrayOfGtinItem $gtinList = null, \StructType\Error $error = null)
    {
        $this
            ->setFastenerList($fastenerList)
            ->setPressureSensorList($pressureSensorList)
            ->setRimList($rimList)
            ->setSparePartList($sparePartList)
            ->setTyreList($tyreList)
            ->setGtinList($gtinList)
            ->setError($error);
    }
    /**
     * Get fastenerList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFastenerContainer|null
     */
    public function getFastenerList()
    {
        return isset($this->fastenerList) ? $this->fastenerList : null;
    }
    /**
     * Set fastenerList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFastenerContainer $fastenerList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setFastenerList(\ArrayType\ArrayOfFastenerContainer $fastenerList = null)
    {
        if (is_null($fastenerList) || (is_array($fastenerList) && empty($fastenerList))) {
            unset($this->fastenerList);
        } else {
            $this->fastenerList = $fastenerList;
        }
        return $this;
    }
    /**
     * Get pressureSensorList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfPressureSensorContainer|null
     */
    public function getPressureSensorList()
    {
        return isset($this->pressureSensorList) ? $this->pressureSensorList : null;
    }
    /**
     * Set pressureSensorList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfPressureSensorContainer $pressureSensorList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setPressureSensorList(\ArrayType\ArrayOfPressureSensorContainer $pressureSensorList = null)
    {
        if (is_null($pressureSensorList) || (is_array($pressureSensorList) && empty($pressureSensorList))) {
            unset($this->pressureSensorList);
        } else {
            $this->pressureSensorList = $pressureSensorList;
        }
        return $this;
    }
    /**
     * Get rimList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfRimContainer|null
     */
    public function getRimList()
    {
        return isset($this->rimList) ? $this->rimList : null;
    }
    /**
     * Set rimList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfRimContainer $rimList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setRimList(\ArrayType\ArrayOfRimContainer $rimList = null)
    {
        if (is_null($rimList) || (is_array($rimList) && empty($rimList))) {
            unset($this->rimList);
        } else {
            $this->rimList = $rimList;
        }
        return $this;
    }
    /**
     * Get sparePartList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfSparePartContainer|null
     */
    public function getSparePartList()
    {
        return isset($this->sparePartList) ? $this->sparePartList : null;
    }
    /**
     * Set sparePartList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfSparePartContainer $sparePartList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setSparePartList(\ArrayType\ArrayOfSparePartContainer $sparePartList = null)
    {
        if (is_null($sparePartList) || (is_array($sparePartList) && empty($sparePartList))) {
            unset($this->sparePartList);
        } else {
            $this->sparePartList = $sparePartList;
        }
        return $this;
    }
    /**
     * Get tyreList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTyreContainer|null
     */
    public function getTyreList()
    {
        return isset($this->tyreList) ? $this->tyreList : null;
    }
    /**
     * Set tyreList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTyreContainer $tyreList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setTyreList(\ArrayType\ArrayOfTyreContainer $tyreList = null)
    {
        if (is_null($tyreList) || (is_array($tyreList) && empty($tyreList))) {
            unset($this->tyreList);
        } else {
            $this->tyreList = $tyreList;
        }
        return $this;
    }
    /**
     * Get GtinList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGtinItem|null
     */
    public function getGtinList()
    {
        return isset($this->GtinList) ? $this->GtinList : null;
    }
    /**
     * Set GtinList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGtinItem $gtinList
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setGtinList(\ArrayType\ArrayOfGtinItem $gtinList = null)
    {
        if (is_null($gtinList) || (is_array($gtinList) && empty($gtinList))) {
            unset($this->GtinList);
        } else {
            $this->GtinList = $gtinList;
        }
        return $this;
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\ResultGetGoodsInfo
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
}
