<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleFilter StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SaleFilter
 * @subpackage Structs
 */
class SaleFilter extends AbstractStructBase
{
    /**
     * The dEnd
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dEnd;
    /**
     * The dStart
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dStart;
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $number;
    /**
     * The numberSF
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numberSF;
    /**
     * The statusId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $statusId;
    /**
     * Constructor method for SaleFilter
     * @uses SaleFilter::setDEnd()
     * @uses SaleFilter::setDStart()
     * @uses SaleFilter::setNumber()
     * @uses SaleFilter::setNumberSF()
     * @uses SaleFilter::setStatusId()
     * @param string $dEnd
     * @param string $dStart
     * @param string $number
     * @param string $numberSF
     * @param int $statusId
     */
    public function __construct($dEnd = null, $dStart = null, $number = null, $numberSF = null, $statusId = null)
    {
        $this
            ->setDEnd($dEnd)
            ->setDStart($dStart)
            ->setNumber($number)
            ->setNumberSF($numberSF)
            ->setStatusId($statusId);
    }
    /**
     * Get dEnd value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDEnd()
    {
        return isset($this->dEnd) ? $this->dEnd : null;
    }
    /**
     * Set dEnd value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dEnd
     * @return \StructType\SaleFilter
     */
    public function setDEnd($dEnd = null)
    {
        // validation for constraint: string
        if (!is_null($dEnd) && !is_string($dEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dEnd, true), gettype($dEnd)), __LINE__);
        }
        if (is_null($dEnd) || (is_array($dEnd) && empty($dEnd))) {
            unset($this->dEnd);
        } else {
            $this->dEnd = $dEnd;
        }
        return $this;
    }
    /**
     * Get dStart value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDStart()
    {
        return isset($this->dStart) ? $this->dStart : null;
    }
    /**
     * Set dStart value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dStart
     * @return \StructType\SaleFilter
     */
    public function setDStart($dStart = null)
    {
        // validation for constraint: string
        if (!is_null($dStart) && !is_string($dStart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dStart, true), gettype($dStart)), __LINE__);
        }
        if (is_null($dStart) || (is_array($dStart) && empty($dStart))) {
            unset($this->dStart);
        } else {
            $this->dStart = $dStart;
        }
        return $this;
    }
    /**
     * Get number value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumber()
    {
        return isset($this->number) ? $this->number : null;
    }
    /**
     * Set number value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $number
     * @return \StructType\SaleFilter
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        if (is_null($number) || (is_array($number) && empty($number))) {
            unset($this->number);
        } else {
            $this->number = $number;
        }
        return $this;
    }
    /**
     * Get numberSF value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumberSF()
    {
        return isset($this->numberSF) ? $this->numberSF : null;
    }
    /**
     * Set numberSF value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numberSF
     * @return \StructType\SaleFilter
     */
    public function setNumberSF($numberSF = null)
    {
        // validation for constraint: string
        if (!is_null($numberSF) && !is_string($numberSF)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numberSF, true), gettype($numberSF)), __LINE__);
        }
        if (is_null($numberSF) || (is_array($numberSF) && empty($numberSF))) {
            unset($this->numberSF);
        } else {
            $this->numberSF = $numberSF;
        }
        return $this;
    }
    /**
     * Get statusId value
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->statusId;
    }
    /**
     * Set statusId value
     * @param int $statusId
     * @return \StructType\SaleFilter
     */
    public function setStatusId($statusId = null)
    {
        // validation for constraint: int
        if (!is_null($statusId) && !(is_int($statusId) || ctype_digit($statusId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusId, true), gettype($statusId)), __LINE__);
        }
        $this->statusId = $statusId;
        return $this;
    }
}
