<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetOrderCommentResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SetOrderCommentResult
 * @subpackage Structs
 */
class SetOrderCommentResult extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The success
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $success;
    /**
     * Constructor method for SetOrderCommentResult
     * @uses SetOrderCommentResult::setError()
     * @uses SetOrderCommentResult::setSuccess()
     * @param \StructType\Error $error
     * @param bool $success
     */
    public function __construct(\StructType\Error $error = null, $success = null)
    {
        $this
            ->setError($error)
            ->setSuccess($success);
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\SetOrderCommentResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\SetOrderCommentResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
}
