<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SparePartContainer StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SparePartContainer
 * @subpackage Structs
 */
class SparePartContainer extends AbstractStructBase
{
    /**
     * The brand
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $brand;
    /**
     * The code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $code;
    /**
     * The img_big_my
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_big_my;
    /**
     * The img_big_pish
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_big_pish;
    /**
     * The img_small
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $img_small;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $name;
    /**
     * The sub_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sub_type;
    /**
     * Constructor method for SparePartContainer
     * @uses SparePartContainer::setBrand()
     * @uses SparePartContainer::setCode()
     * @uses SparePartContainer::setImg_big_my()
     * @uses SparePartContainer::setImg_big_pish()
     * @uses SparePartContainer::setImg_small()
     * @uses SparePartContainer::setName()
     * @uses SparePartContainer::setSub_type()
     * @param string $brand
     * @param string $code
     * @param string $img_big_my
     * @param string $img_big_pish
     * @param string $img_small
     * @param string $name
     * @param string $sub_type
     */
    public function __construct($brand = null, $code = null, $img_big_my = null, $img_big_pish = null, $img_small = null, $name = null, $sub_type = null)
    {
        $this
            ->setBrand($brand)
            ->setCode($code)
            ->setImg_big_my($img_big_my)
            ->setImg_big_pish($img_big_pish)
            ->setImg_small($img_small)
            ->setName($name)
            ->setSub_type($sub_type);
    }
    /**
     * Get brand value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBrand()
    {
        return isset($this->brand) ? $this->brand : null;
    }
    /**
     * Set brand value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $brand
     * @return \StructType\SparePartContainer
     */
    public function setBrand($brand = null)
    {
        // validation for constraint: string
        if (!is_null($brand) && !is_string($brand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brand, true), gettype($brand)), __LINE__);
        }
        if (is_null($brand) || (is_array($brand) && empty($brand))) {
            unset($this->brand);
        } else {
            $this->brand = $brand;
        }
        return $this;
    }
    /**
     * Get code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCode()
    {
        return isset($this->code) ? $this->code : null;
    }
    /**
     * Set code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $code
     * @return \StructType\SparePartContainer
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->code);
        } else {
            $this->code = $code;
        }
        return $this;
    }
    /**
     * Get img_big_my value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_big_my()
    {
        return isset($this->img_big_my) ? $this->img_big_my : null;
    }
    /**
     * Set img_big_my value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_big_my
     * @return \StructType\SparePartContainer
     */
    public function setImg_big_my($img_big_my = null)
    {
        // validation for constraint: string
        if (!is_null($img_big_my) && !is_string($img_big_my)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_big_my, true), gettype($img_big_my)), __LINE__);
        }
        if (is_null($img_big_my) || (is_array($img_big_my) && empty($img_big_my))) {
            unset($this->img_big_my);
        } else {
            $this->img_big_my = $img_big_my;
        }
        return $this;
    }
    /**
     * Get img_big_pish value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_big_pish()
    {
        return isset($this->img_big_pish) ? $this->img_big_pish : null;
    }
    /**
     * Set img_big_pish value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_big_pish
     * @return \StructType\SparePartContainer
     */
    public function setImg_big_pish($img_big_pish = null)
    {
        // validation for constraint: string
        if (!is_null($img_big_pish) && !is_string($img_big_pish)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_big_pish, true), gettype($img_big_pish)), __LINE__);
        }
        if (is_null($img_big_pish) || (is_array($img_big_pish) && empty($img_big_pish))) {
            unset($this->img_big_pish);
        } else {
            $this->img_big_pish = $img_big_pish;
        }
        return $this;
    }
    /**
     * Get img_small value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getImg_small()
    {
        return isset($this->img_small) ? $this->img_small : null;
    }
    /**
     * Set img_small value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $img_small
     * @return \StructType\SparePartContainer
     */
    public function setImg_small($img_small = null)
    {
        // validation for constraint: string
        if (!is_null($img_small) && !is_string($img_small)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($img_small, true), gettype($img_small)), __LINE__);
        }
        if (is_null($img_small) || (is_array($img_small) && empty($img_small))) {
            unset($this->img_small);
        } else {
            $this->img_small = $img_small;
        }
        return $this;
    }
    /**
     * Get name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->name) ? $this->name : null;
    }
    /**
     * Set name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\SparePartContainer
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->name);
        } else {
            $this->name = $name;
        }
        return $this;
    }
    /**
     * Get sub_type value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSub_type()
    {
        return isset($this->sub_type) ? $this->sub_type : null;
    }
    /**
     * Set sub_type value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sub_type
     * @return \StructType\SparePartContainer
     */
    public function setSub_type($sub_type = null)
    {
        // validation for constraint: string
        if (!is_null($sub_type) && !is_string($sub_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sub_type, true), gettype($sub_type)), __LINE__);
        }
        if (is_null($sub_type) || (is_array($sub_type) && empty($sub_type))) {
            unset($this->sub_type);
        } else {
            $this->sub_type = $sub_type;
        }
        return $this;
    }
}
