<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TireCalcResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TireCalcResult
 * @subpackage Structs
 */
class TireCalcResult extends AbstractStructBase
{
    /**
     * The difference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TireCalcSize
     */
    public $difference;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Error
     */
    public $error;
    /**
     * The new_size
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TireCalcSize
     */
    public $new_size;
    /**
     * The old_size
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TireCalcSize
     */
    public $old_size;
    /**
     * The speedometer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TireCalcSpeedometerInfo
     */
    public $speedometer;
    /**
     * The success
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $success;
    /**
     * Constructor method for TireCalcResult
     * @uses TireCalcResult::setDifference()
     * @uses TireCalcResult::setError()
     * @uses TireCalcResult::setNew_size()
     * @uses TireCalcResult::setOld_size()
     * @uses TireCalcResult::setSpeedometer()
     * @uses TireCalcResult::setSuccess()
     * @param \StructType\TireCalcSize $difference
     * @param \StructType\Error $error
     * @param \StructType\TireCalcSize $new_size
     * @param \StructType\TireCalcSize $old_size
     * @param \StructType\TireCalcSpeedometerInfo $speedometer
     * @param bool $success
     */
    public function __construct(\StructType\TireCalcSize $difference = null, \StructType\Error $error = null, \StructType\TireCalcSize $new_size = null, \StructType\TireCalcSize $old_size = null, \StructType\TireCalcSpeedometerInfo $speedometer = null, $success = null)
    {
        $this
            ->setDifference($difference)
            ->setError($error)
            ->setNew_size($new_size)
            ->setOld_size($old_size)
            ->setSpeedometer($speedometer)
            ->setSuccess($success);
    }
    /**
     * Get difference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TireCalcSize|null
     */
    public function getDifference()
    {
        return isset($this->difference) ? $this->difference : null;
    }
    /**
     * Set difference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TireCalcSize $difference
     * @return \StructType\TireCalcResult
     */
    public function setDifference(\StructType\TireCalcSize $difference = null)
    {
        if (is_null($difference) || (is_array($difference) && empty($difference))) {
            unset($this->difference);
        } else {
            $this->difference = $difference;
        }
        return $this;
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Error|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Error $error
     * @return \StructType\TireCalcResult
     */
    public function setError(\StructType\Error $error = null)
    {
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get new_size value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TireCalcSize|null
     */
    public function getNew_size()
    {
        return isset($this->new_size) ? $this->new_size : null;
    }
    /**
     * Set new_size value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TireCalcSize $new_size
     * @return \StructType\TireCalcResult
     */
    public function setNew_size(\StructType\TireCalcSize $new_size = null)
    {
        if (is_null($new_size) || (is_array($new_size) && empty($new_size))) {
            unset($this->new_size);
        } else {
            $this->new_size = $new_size;
        }
        return $this;
    }
    /**
     * Get old_size value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TireCalcSize|null
     */
    public function getOld_size()
    {
        return isset($this->old_size) ? $this->old_size : null;
    }
    /**
     * Set old_size value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TireCalcSize $old_size
     * @return \StructType\TireCalcResult
     */
    public function setOld_size(\StructType\TireCalcSize $old_size = null)
    {
        if (is_null($old_size) || (is_array($old_size) && empty($old_size))) {
            unset($this->old_size);
        } else {
            $this->old_size = $old_size;
        }
        return $this;
    }
    /**
     * Get speedometer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TireCalcSpeedometerInfo|null
     */
    public function getSpeedometer()
    {
        return isset($this->speedometer) ? $this->speedometer : null;
    }
    /**
     * Set speedometer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TireCalcSpeedometerInfo $speedometer
     * @return \StructType\TireCalcResult
     */
    public function setSpeedometer(\StructType\TireCalcSpeedometerInfo $speedometer = null)
    {
        if (is_null($speedometer) || (is_array($speedometer) && empty($speedometer))) {
            unset($this->speedometer);
        } else {
            $this->speedometer = $speedometer;
        }
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \StructType\TireCalcResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
}
