<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TireCalcSpeedometerInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TireCalcSpeedometerInfo
 * @subpackage Structs
 */
class TireCalcSpeedometerInfo extends AbstractStructBase
{
    /**
     * The clearence_change
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $clearence_change;
    /**
     * The current
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $current;
    /**
     * The difference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $difference;
    /**
     * The real
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $real;
    /**
     * Constructor method for TireCalcSpeedometerInfo
     * @uses TireCalcSpeedometerInfo::setClearence_change()
     * @uses TireCalcSpeedometerInfo::setCurrent()
     * @uses TireCalcSpeedometerInfo::setDifference()
     * @uses TireCalcSpeedometerInfo::setReal()
     * @param float $clearence_change
     * @param float $current
     * @param float $difference
     * @param float $real
     */
    public function __construct($clearence_change = null, $current = null, $difference = null, $real = null)
    {
        $this
            ->setClearence_change($clearence_change)
            ->setCurrent($current)
            ->setDifference($difference)
            ->setReal($real);
    }
    /**
     * Get clearence_change value
     * @return float|null
     */
    public function getClearence_change()
    {
        return $this->clearence_change;
    }
    /**
     * Set clearence_change value
     * @param float $clearence_change
     * @return \StructType\TireCalcSpeedometerInfo
     */
    public function setClearence_change($clearence_change = null)
    {
        // validation for constraint: float
        if (!is_null($clearence_change) && !(is_float($clearence_change) || is_numeric($clearence_change))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($clearence_change, true), gettype($clearence_change)), __LINE__);
        }
        $this->clearence_change = $clearence_change;
        return $this;
    }
    /**
     * Get current value
     * @return float|null
     */
    public function getCurrent()
    {
        return $this->current;
    }
    /**
     * Set current value
     * @param float $current
     * @return \StructType\TireCalcSpeedometerInfo
     */
    public function setCurrent($current = null)
    {
        // validation for constraint: float
        if (!is_null($current) && !(is_float($current) || is_numeric($current))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($current, true), gettype($current)), __LINE__);
        }
        $this->current = $current;
        return $this;
    }
    /**
     * Get difference value
     * @return float|null
     */
    public function getDifference()
    {
        return $this->difference;
    }
    /**
     * Set difference value
     * @param float $difference
     * @return \StructType\TireCalcSpeedometerInfo
     */
    public function setDifference($difference = null)
    {
        // validation for constraint: float
        if (!is_null($difference) && !(is_float($difference) || is_numeric($difference))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($difference, true), gettype($difference)), __LINE__);
        }
        $this->difference = $difference;
        return $this;
    }
    /**
     * Get real value
     * @return float|null
     */
    public function getReal()
    {
        return $this->real;
    }
    /**
     * Set real value
     * @param float $real
     * @return \StructType\TireCalcSpeedometerInfo
     */
    public function setReal($real = null)
    {
        // validation for constraint: float
        if (!is_null($real) && !(is_float($real) || is_numeric($real))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($real, true), gettype($real)), __LINE__);
        }
        $this->real = $real;
        return $this;
    }
}
