<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for wh_price_rest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:wh_price_rest
 * @subpackage Structs
 */
class Wh_price_rest extends AbstractStructBase
{
    /**
     * The price
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $price;
    /**
     * The price_rozn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $price_rozn;
    /**
     * The rest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $rest;
    /**
     * The wrh
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $wrh;
    /**
     * Constructor method for wh_price_rest
     * @uses Wh_price_rest::setPrice()
     * @uses Wh_price_rest::setPrice_rozn()
     * @uses Wh_price_rest::setRest()
     * @uses Wh_price_rest::setWrh()
     * @param float $price
     * @param float $price_rozn
     * @param int $rest
     * @param int $wrh
     */
    public function __construct($price = null, $price_rozn = null, $rest = null, $wrh = null)
    {
        $this
            ->setPrice($price)
            ->setPrice_rozn($price_rozn)
            ->setRest($rest)
            ->setWrh($wrh);
    }
    /**
     * Get price value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPrice()
    {
        return isset($this->price) ? $this->price : null;
    }
    /**
     * Set price value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $price
     * @return \StructType\Wh_price_rest
     */
    public function setPrice($price = null)
    {
        // validation for constraint: float
        if (!is_null($price) && !(is_float($price) || is_numeric($price))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($price, true), gettype($price)), __LINE__);
        }
        if (is_null($price) || (is_array($price) && empty($price))) {
            unset($this->price);
        } else {
            $this->price = $price;
        }
        return $this;
    }
    /**
     * Get price_rozn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPrice_rozn()
    {
        return isset($this->price_rozn) ? $this->price_rozn : null;
    }
    /**
     * Set price_rozn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $price_rozn
     * @return \StructType\Wh_price_rest
     */
    public function setPrice_rozn($price_rozn = null)
    {
        // validation for constraint: float
        if (!is_null($price_rozn) && !(is_float($price_rozn) || is_numeric($price_rozn))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($price_rozn, true), gettype($price_rozn)), __LINE__);
        }
        if (is_null($price_rozn) || (is_array($price_rozn) && empty($price_rozn))) {
            unset($this->price_rozn);
        } else {
            $this->price_rozn = $price_rozn;
        }
        return $this;
    }
    /**
     * Get rest value
     * @return int|null
     */
    public function getRest()
    {
        return $this->rest;
    }
    /**
     * Set rest value
     * @param int $rest
     * @return \StructType\Wh_price_rest
     */
    public function setRest($rest = null)
    {
        // validation for constraint: int
        if (!is_null($rest) && !(is_int($rest) || ctype_digit($rest))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rest, true), gettype($rest)), __LINE__);
        }
        $this->rest = $rest;
        return $this;
    }
    /**
     * Get wrh value
     * @return int|null
     */
    public function getWrh()
    {
        return $this->wrh;
    }
    /**
     * Set wrh value
     * @param int $wrh
     * @return \StructType\Wh_price_rest
     */
    public function setWrh($wrh = null)
    {
        // validation for constraint: int
        if (!is_null($wrh) && !(is_int($wrh) || ctype_digit($wrh))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($wrh, true), gettype($wrh)), __LINE__);
        }
        $this->wrh = $wrh;
        return $this;
    }
}
